




//
//	The Maria Basic Interpreter Written by Dzinleski Jasenko Jun,2005 and later
//					Copyright (C) 2005 and later Jasenko Dzinleski 
//
//	This source and the mariaBasic interpreter apply to GNU General Public License. 
//					
//
//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 
//
//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 
//
//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.


//  			The MariaBasic Interpreter
//
//     			to my daughter Maria Dzinleska




#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#define		plinel		256
#define		vnaml		64
#define		maxv		500

#define		mc		27

FILE		*fout;
int		of=0;

//1-string,2-int,3-long int,4-double

int			linen=0;

char			varnl[maxv][vnaml];
int			tarv[maxv][2];						
int			vi=0;

char			cvarv[maxv][plinel];
int			ci=0;

long			nvarv[maxv][2];
int			ni=0;

double			dvarv[maxv];
int			dni=0;

FILE			*fp;
FILE			*fvars[maxv];

long			fvarp[maxv];
int			fvarc[maxv];
char			fvarn[maxv][plinel];
int			fni=0;

//1 ^,2 *,3 /,4 + ,5 -,6 =

double			opa[vnaml][2];
int			opi=0;

char			kw[maxv][vnaml];
char			pf[maxv][plinel];

char			fw[maxv][vnaml];

//0 line number
//1 execution type #1 
//2 execution type #2 
//3 execution type #3 
//4 execution type #4 
//5 execution type #5 

//Execution types:
//1 execute command
//3 inside if block execute command
//2 inside loop block execute command
//4 inside sub block routine execute command
//5 inside loop block execute command

//13 (re)parse if command
//12 (re)parse loop command 
//14 (re)parse sub command 
//15 (re)parse loop command


int			ri[maxv][7];
int			iri=0;
int			eri=0;

//0 - op1, 1 - op2, 2 - loop_oper, 3 - eval line#, 4 - exit line#, 5 - incr/comp1_op_index, 6 - incr/comp1_op_type 7 - comp2_op_index, 8 - comp2_op_type, 9 - nesting sub/type
//loop_oper: 0 =,1 >,2 <,3 >=,4 <=
 
long		nri[maxv][10];
int			inri=0;
long		cv[10];
int			cvi;
long		iv[10][4];

char		rout[10][vnaml];
int			irout=0;

char		csL[plinel];
char		csR[plinel];

//
char	r_s[50][plinel];	int	r_si=0;
//
char	b_var_n[]="{[az][09][__][AZ][#&]}{=}{[++][--]}{[09][..][,,]}{[++][--][//][**][^^][==]}";
char	b_var_s[]="{[az][09][__][AZ][$$]}{=}{['\'''\'']['\"''\"']}{[  ][AZ][az][09][..]}{['\'''\'']['\"''\"']}";
//
char	b_for[]="{for}{ }{[az][09][__][AZ][#&]}{=}{[09][..]}{ }{to}{ }{[09][..]}";
char	b_for_1[]="{for}{ }{[az][09][__][AZ][#&]}{=}{[az][09][__][AZ][#&]}{ }{to}{ }{[09][..]}";
char	b_for_2[]="{for}{ }{[az][09][__][AZ][#&]}{=}{[az][09][__][AZ][#&]}{ }{to}{ }{[az][09][__][AZ][#&]}";
char	b_for_3[]="{for}{ }{[az][09][__][AZ][#&]}{=}{[09][..]}{ }{to}{ }{[az][09][__][AZ][#&]}";
//
char	b_while[]="{while (}{[az][09][__][AZ][#&]}{[==][>>][<<]}{[09][..]}{)}";
char	b_while_1[]="{while (}{[az][09][__][AZ][#&]}{[==][>>][<<]}{[az][09][__][AZ][#&]}{)}";
//
char	b_if[]="{if}{ (}{[az][09][__][AZ][#&]}{[==][>>][<<]}{[az][09][__][AZ][#&]}{) }{then}";
char	b_if_1[]="{if}{ (}{[az][09][__][AZ][#&]}{[==][>>][<<]}{[09][..]}{) }{then}";
//
char	b_mid[]="{[az][09][__][AZ][#&]}{=}{mid$(}{[az][09][__][AZ][#&]}{,}{[az][09][__][AZ]}{[#&]}{,}{[az][09][__][AZ]}{[#&]}{)}";
//
char	b_trim[]="{[az][09][__][AZ][#&]}{=}{trim$(}{[az][09][__][AZ][#&]}{)}";
//
char	b_left[]="{[az][09][__][AZ][#&]}{=}{left$(}{[az][09][__][AZ][#&]}{,}{[09][..]}{)}";
//
char	b_right[]="{[az][09][__][AZ][#&]}{=}{right$(}{[az][09][__][AZ][#&]}{,}{[09][..]}{)}";
//
char	b_len[]="{[az][09][__][AZ][#&]}{=}{len$(}{[az][09][__][AZ][#&]}{)}";
//
char	b_val[]="{[az][09][__][AZ][#&]}{=}{val$(}{[az][09][__][AZ][#&]}{)}";
//
char	b_round[]="{[az][09][__][AZ][#&]}{=}{round$(}{[az][09][__][AZ][#&]}{)}";
//
char	b_format[]="{[az][09][__][AZ][#&]}{=}{format$(}{[az][09][__][AZ][#&]}{,}{['\'''\'']['\"''\"']}{[--][#&][  ][09][..][,,]}{['\'''\'']['\"''\"']}{)}";
//
char	b_fopen_i[]="{open}{ }{[az][09][__][AZ][$$]}{ }{for input}{ }{as}{ }{#}{[09]}";
char	b_fopen_o[]="{open}{ }{[az][09][__][AZ][$$]}{ }{for output}{ }{as}{ }{#}{[09]}";
char	b_finput[]="{input}{ }{#}{[09]}{,}{[az][09][__][AZ][#&]}";
char	b_fclose[]="{close}{ }{#}{[09]}";
//
char	b_print_s[]="{print}{ }{#}{[09]}{[,,][;;]}{['\'''\'']['\"''\"']}{[ !][#&][(~]}{['\'''\'']['\"''\"']}{[,,][;;]}";
char	b_print_v[]="{print}{ }{#}{[09]}{[,,][;;]}{['\'''\'']['\"''\"']}{[az][09][__][AZ]}{[#&]}{[,,][;;]}";
char	b_arg_s[]="{['\'''\'']['\"''\"']}{[ !][#&][(~]}{['\'''\'']['\"''\"']}{[,,][;;]}";
char	b_arg_v[]="{[az][09][__][AZ]}{[#&]}{[,,][;;]}";
//
char	b_l_exp[]="{[az][09][__][AZ][#&]}{=(}{[az][09][__][AZ][#&]}{[==][>>][<<]}{[az][09][__][AZ][#&]}{ }{[az]}{ }{[az][09][__][AZ][#&]}{[==][>>][<<]}{[az][09][__][AZ][#&]}{)}";
//
//
char	p_exp[]="{[az][09][__][AZ]}{[$$][##][%%][&&]}{[==][((]}{['\'''\'']['\"''\"'][..][az][09][__][AZ][++][--]}{[$$][##][%%][&&]}{[++][--][//][**][^^][==][>>][<<]}{[,,]}";
//
//
//
char	p_exp_[]="{[az][09][__][AZ][$$][##][%%][&&][==][((][))][..][--][++][**][^^][//]['\'''\'']['\"''\"'][>>][<<][,,][  ]}";
char	p_kw_[]="{for}{to}{next}{while}{wend}{if}{then}{end}{and}{or}{xor}{print}{rem}{open}{input}{output}{close}";
char	p_fn_[]="{mid$}{len$}{right$}{left$}{trim$}{val$}{format$}{round$}";
//
char	cml[256]="{[--][++]}{[hh][ll][ee][oo][??][ff]}{[AZ][az][09][__][  ][..][\'\'][\"\"]}";
//

int		exp_t[50][5];
int		exp_l[5][2];
int		exp_m[5];
//
char	rlc[256];
//
int p_strlen(char arr0[plinel])
{
	int	i,j=0,k=0;

	for (i=0;i<strlen(arr0);++i)
	{
		if 
		(
			(int)arr0[i]>=32&&
			(int)arr0[i]<=255
		)
		{if ((int)arr0[i]==32){++j;}else{++k;}}else{break;}
	}
	return(k);
}

int p_comp_(char arr1[plinel],char arr2[plinel])
{
	int	i,l1,l2;
	int	a=0;

	for (i=0;i<vnaml;++i)
	{
		if (arr1[i]==arr2[i]){++a;}else{a=0;}
	}
	if(a==vnaml){return(1);}else{/*printf("%s %s %d\n",arr1,arr2,a);*/return(-1);}

}

int p_comp(char arr1[plinel],char arr2[plinel])
{
	int	i,l1,l2;
	int	rv=0;

	if ((l1=p_strlen(arr1))!=(l2=p_strlen(arr2)))
	{
		if (l1>l2)
		{
			for (i=0;i<l2;++i)
			{
				if (arr1[i]!=arr2[i])
				{
					if (arr1[i]>arr2[i]){rv=3;return(rv);}
					if (arr1[i]<arr2[i]){rv=2;return(rv);}
				}
			}
			return(i);							
		}else{
			for (i=0;i<l1;++i)
			{
				if (arr1[i]!=arr2[i])
				{
					if (arr1[i]>arr2[i]){rv=3;return(rv);}
					if (arr1[i]<arr2[i]){rv=2;return(rv);}
				}
			}
			return(i);					
		}
	}else{
		for (i=0;i<l1;++i)
		{
			if (arr1[i]!=arr2[i])
			{
				if (arr1[i]>arr2[i]){rv=3;return(rv);}
				if (arr1[i]<arr2[i]){rv=2;return(rv);}
			}
		}
		return(1);
	}
}

int p_ccomp(char arr1[plinel],char arr2[plinel],char c_o1,char c_o2)
{
	int	i,l1,l2,lt;

	if((l1=p_strlen(arr1))>(l2=p_strlen(arr2))){lt=l2;}else{lt=l1;}
	for (i=0;i<lt;++i){if ((int)arr1[i]!=(int)arr2[i]){break;}}
	if(i!=lt)
	{
		if ((int)arr1[i]>(int)arr2[i])
		{
			if(c_o1=='<'&&c_o2=='>'){return(1);}
			if(c_o1=='>'){return(1);}
			if(c_o1=='<'){return(0);}
			if(c_o1=='='){return(0);}
		}
		if ((int)arr1[i]<(int)arr2[i])
		{
			if(c_o1=='<'&&c_o2=='>' ){return(1);}
			if(c_o1=='<'){return(1);}
			if(c_o1=='>'){return(0);}
			if(c_o1=='='){return(0);}
		}
	}
	if(l1==l2)
	{
		if(c_o1=='<'&&c_o2=='>' ){return(0);}
		if(c_o1=='<'&&c_o2=='=' ){return(1);}
		if(c_o1=='>'&&c_o2=='=' ){return(1);}
		if(c_o1=='<'&&c_o2=='\0'){return(0);}
		if(c_o1=='>'&&c_o2=='\0'){return(0);}
		if(c_o1=='='&&c_o2=='\0'){return(1);}
	}else{
		if(c_o1=='<'&&c_o2=='>' ){return(1);}
		if(l1>l2)
		{
			if(c_o1=='>'){return(1);}			
			if(c_o1=='<'){return(0);}			
		}else{
			if(c_o1=='<'){return(1);}
			if(c_o1=='>'){return(0);}
		}
	}
	return(0);
}


int p_ex_(char arr11[plinel],char arr12[plinel],int sp)
{
		int		i,j,k,l;
		char		ca[plinel];

		for (i=sp;i<strlen(arr11);++i)
		{
			for (k=0;k<plinel;++k){ca[k]='\0';}
			k=0;for (j=i;j<i+strlen(arr12);++j){ca[k]=arr11[j];++k;}
			for (l=0;l<strlen(arr12);++l){if(ca[l]==arr12[l]){}else{break;}}
			if (l==strlen(arr12)){break;}
		}
		if (i!=strlen(arr11)){return(i+strlen(arr12));}
		return(0);
}

int	c_p(char cl_a[256],int ci,int tf,char r_a[256])
{

	int		a,b,c,d=0;
	
	for(a=0;a<256;++a){r_a[a]='\0';}

	if(tf)
	{
		for(a=0;a<strlen(cl_a);++a){
			if(cl_a[a]=='{'){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]=='}'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}

	}else{
		for(a=0;a<strlen(cl_a);++a){
			if(cl_a[a]=='['){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]==']'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}

	}

	d=0;for(c=a+1;c<b;++c){r_a[d]=cl_a[c];++d;/*printf("%c",cl_a[c]);*/}

	if(b==strlen(cl_a)){return(1);}else{return(0);}

}

int p_syntax_(char i_l[plinel],char c_l[plinel])
{

	int			a,b,c,ci,d;
	int			i,j,k,l,m,r,s;

	char		c_1[256];
	char		c_2[256];

	char		fn[10][2];	int	fi=0;

	int			op=0,si=1,ssi=1,i_li=0;

	
	for(i=0;i<50;++i){for(j=0;j<plinel;++j){r_s[i][j]='\0';}}r_si=0;
	s=0;
	while(s==0)
	{

		ci=si;
		for(i=0;i<256;++i){c_1[i]='\0';}
		s=c_p(c_l,ci,1,c_1);
		//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

		for(i=0;i<strlen(c_1);++i){if(c_1[i]=='['){break;}}
		if(i!=strlen(c_1))
		{
			fi=0;r=0;
			while(r==0)
			{
				ci=ssi;
				for(i=0;i<256;++i){c_2[i]='\0';}
				r=c_p(c_1,ci,0,c_2);
				//for(i=0;i<strlen(c_2);++i){printf("%c",c_2[i]);}
				fn[fi][0]=c_2[0];fn[fi][1]=c_2[1];++fi;
				++ssi;
			}

			k=0;ssi=1;
			for(i=0;i<256;++i){r_s[r_si][i]='\0';}
			for(i=i_li;i<strlen(i_l);++i)
			{
				for(j=0;j<fi;++j)
				{
					if(((int)i_l[i]>=(int)fn[j][0])&&((int)i_l[i]<=(int)fn[j][1])){break;}
				}
				if(j!=fi){r_s[r_si][k]=i_l[i];++k;}else{break;}
			}
			++r_si;
			i_li=i;

		}else{

			for(i=0;i<256;++i){r_s[r_si][i]='\0';}
			j=0;for(i=0;i<strlen(c_1);++i){if(i_l[i_li]!=c_1[i]){break;}else{r_s[r_si][j]=c_1[i];++j;}++i_li;}
			++r_si;

		}
		++si;
	}	

	
	//printf("?0?%s??\n",r_s[0]);
	//printf("?1?%s??\n",r_s[1]);
	//printf("?2?%s??\n",r_s[2]);
	//printf("?3?%s??\n",r_s[3]);
	//printf("?4?%s??\n",r_s[4]);
	//printf("?5?%s??\n",r_s[5]);
	//printf("?6?%s??\n",r_s[6]);
	//printf("?7?%s??\n",r_s[7]);
	//printf("?8?%s??\n",r_s[8]);
	//printf("?9?%s??\n",r_s[9]);
	//printf("?10?%s??\n",r_s[10]);
	//printf("?11?%s??\n",r_s[11]);
	

	return(0);

}

int r_ac(char arr11[plinel],int l)
{

int		i,j=0;
int		a,b;
int 	arr12[plinel];

int	c0=0;
int	c1=0;
int	c2=0;
int	c3=0;
int	c4=0;
int	c5=0;
int	c6=0;
int	c7=0;
int	c8=0;
int	c9=0;
int	c10=0;
int	c11=0;
int	c12=0;
int	c13=0;
int	c14=0;
int	c15=0;
int	c16=0;
int	c17=0;
int	c18=0;
int	c19=0;
int	c20=0;
int	c21=0;
int	c22=0;
int	c23=0;
int	c24=0;

	if(arr11[0]=='\0'||strlen(arr11)==0){return(0);}
	
	a=0;
	for(i=0;i<strlen(arr11);++i)
	{
		arr12[a]=-1;
		if(arr11[i]>='a'&&arr11[i]<='z'){arr12[a]=1; ++a;continue;}
		if(arr11[i]>='A'&&arr11[i]<='Z'){arr12[a]=2; ++a;continue;}
		if(arr11[i]>='0'&&arr11[i]<='9'){arr12[a]=3; ++a;continue;}
		if(arr11[i]>='#'&&arr11[i]<='&'){arr12[a]=4; ++a;continue;}
		if(arr11[i]>='_'&&arr11[i]<='_'){arr12[a]=5; ++a;continue;}
		if(arr11[i]>='.'&&arr11[i]<='.'){arr12[a]=6; ++a;continue;}
		if(arr11[i]>=','&&arr11[i]<=','){arr12[a]=7; ++a;continue;}
		if(arr11[i]>=' '&&arr11[i]<=' '){arr12[a]=8; ++a;continue;}
		if(arr11[i]>='='&&arr11[i]<='='){arr12[a]=9; ++a;continue;}
		if(arr11[i]>='>'&&arr11[i]<='>'){arr12[a]=10;++a;continue;}
		if(arr11[i]>='<'&&arr11[i]<='<'){arr12[a]=11;++a;continue;}		
		if(arr11[i]>='+'&&arr11[i]<='+'){arr12[a]=12;++a;continue;}				
		if(arr11[i]>='-'&&arr11[i]<='-'){arr12[a]=13;++a;continue;}				
		if(arr11[i]>='*'&&arr11[i]<='*'){arr12[a]=14;++a;continue;}				
		if(arr11[i]>='^'&&arr11[i]<='^'){arr12[a]=15;++a;continue;}				
		if(arr11[i]>='('&&arr11[i]<='('){arr12[a]=16;++a;continue;}						
		if(arr11[i]>=')'&&arr11[i]<=')'){arr12[a]=17;++a;continue;}						
		if(arr11[i]>='$'&&arr11[i]<='$'){arr12[a]=18;++a;continue;}						
		if(arr11[i]>='!'&&arr11[i]<='!'){arr12[a]=19;++a;continue;}						
		if(arr11[i]>='?'&&arr11[i]<='?'){arr12[a]=20;++a;continue;}						
		if(arr11[i]>='-'&&arr11[i]<='-'){arr12[a]=21;++a;continue;}						
		if(arr11[i]>=':'&&arr11[i]<=':'){arr12[a]=22;++a;continue;}						
		if(arr11[i]>='\''&&arr11[i]<='\''){arr12[a]=23;++a;continue;}						
		if(arr11[i]>='"'&&arr11[i]<='"'){arr12[a]=24;++a;continue;}								
		++a;
	}
	
	for(i=0;i<a;++i)
	{
		if(!c0&&arr12[i]==-1 ){c0=1; continue;}
		if(!c1&&arr12[i]==1  ){c1=1; continue;}
		if(!c2&&arr12[i]==2  ){c2=1; continue;}
		if(!c3&&arr12[i]==3  ){c3=1; continue;}
		if(!c4&&arr12[i]==4  ){c4=1; continue;}
		if(!c5&&arr12[i]==5  ){c5=1; continue;}
		if(!c6&&arr12[i]==6  ){c6=1; continue;}
		if(!c7&&arr12[i]==7  ){c7=1; continue;}
		if(!c8&&arr12[i]==8  ){c8=1; continue;}
		if(!c9&&arr12[i]==9  ){c9=1; continue;}
		if(!c10&&arr12[i]==10){c10=1;continue;}
		if(!c11&&arr12[i]==11){c11=1;continue;}
		if(!c12&&arr12[i]==12){c12=1;continue;}
		if(!c13&&arr12[i]==13){c13=1;continue;}
		if(!c14&&arr12[i]==14){c14=1;continue;}
		if(!c15&&arr12[i]==15){c15=1;continue;}
		if(!c16&&arr12[i]==16){c16=1;continue;}
		if(!c17&&arr12[i]==17){c17=1;continue;}
		if(!c18&&arr12[i]==18){c18=1;continue;}
		if(!c19&&arr12[i]==19){c19=1;continue;}
		if(!c20&&arr12[i]==20){c20=1;continue;}
		if(!c21&&arr12[i]==21){c21=1;continue;}		
		if(!c21&&arr12[i]==22){c22=1;continue;}				
		if(!c21&&arr12[i]==23){c23=1;continue;}				
		if(!c21&&arr12[i]==24){c24=1;continue;}						
	}
	//printf("%d %d\n",a,c3);
	//for(i=0;i<a;++i){printf("|%d",arr12[i]);}printf("\n");
	
	if(l==1)
	{
		if(!c0&&(c1||c2||c3||c4)&&(c4||c18)){j=1;}else{j=0;}
		for(i=0;i<a;++i){if(!(arr12[i]==1||arr12[i]==2||arr12[i]==3||arr12[i]==4&&(arr12[i]==4||arr12[i]==18))){break;}}
		if(i!=a){j=0;}
	}
	if(l==2)
	{
		if(!c0&&c3){j=1;}else{j=0;}
		for(i=0;i<a;++i){if(!(arr12[i]==3)){break;}}
		if(i!=a){j=0;}		
	}	
	if(l==3)
	{
		if(!c0&&c9||c10||c11){j=1;}else{j=0;}
		for(i=0;i<a;++i){if(!(arr12[i]==9||arr12[i]==10||arr12[i]==11)){break;}}
		if(i!=a){j=0;}				
	}	
	if(l==4)
	{
		if(!c0&&c12||c13||c14||c15){j=1;}else{j=0;}
		for(i=0;i<a;++i){if(!(arr12[i]==12||arr12[i]==13||arr12[i]==14)){break;}}
		if(i!=a){j=0;}						
	}	
	if(l==5)
	{
		if(!c0){j=1;}else{j=0;}
	}	
	if(l==6)
	{
		if(!c0&&c3&&(c23||c24)){j=1;}else{j=0;}
		for(i=0;i<a;++i){if(!(arr12[i]==3||arr12[i]==23||arr12[i]==44)){break;}}
		if(i!=a){j=0;}								
	}
	if(l==7)
	{
		if(!c0&&c3&&(c3||c4||c6||c7||c23)){j=1;}else{j=0;}
		for(i=0;i<a;++i){if(!(arr12[i]==3||arr12[i]==4||arr12[i]==6||arr12[i]==7||arr12[i]==23)){break;}}
		if(i!=a){j=0;}								
	}

	//printf("r_ac( %s %d %d\n",arr11,strlen(arr11),j);	
	return(j);
}

int	c_syntax(char infn[vnaml],char outfn[vnaml])
{

	FILE		*f1,*f2;

	char	cmd[256][256];

	char	fn[256][2];int	fi=0;
	int	op=0;
	long	pos=0;
	
	int	cc=0;
	int	a1f=0;
	int	a2f=0;

	char	t_a[256][plinel];int	rti=0,cti=0;
	char	a1a[plinel];
	char	a2a[plinel];
	int	aia=0;

	int	i,j,k,l,m,n,p,q,r;
	int	fbyte;
	int	a,b,c,ci,d,e;
	int	errC_=0;

	int	df=0;
	int	sf=0;	
	
	char	c_l[256];
	char	cl_[256];int 	cl_i;
	char	cl[256];
	
	char	c_1[256];
	char	c_2[256];

	int	lc=0;

	//0-kw;1-fn;2-exp;
	int		ln_1[256],ln_1i=0;	//kw
	int		ln_2[256],ln_2i=0;	//fn
	int		ln_3[256][2],ln_3i=0;	//exp
	
	if(strlen(outfn)>0){of=1;}
	if(of){fout=fopen(outfn,"w");}

	f1=fopen(infn,"rb");
	if(f1==NULL){printf("Nothing to do!\n");return(0);}else{fclose(f1);}
	for(i=0;i<plinel;++i){cl[i]='\0';}
	
	f1=fopen(infn,"rb");
	f2=fopen("code.mar","wb");

	fbyte=getc(f1);
	while(!feof(f1))
	{
		
		cl_i=0;for(i=0;i<plinel;++i){cl[i]='\0';cl_[i]='\0';}
		while(!feof(f1)&&fbyte!=13&&fbyte!=10){cl_[cl_i]=fbyte;++cl_i;fbyte=getc(f1);}
		while(!feof(f1)&&(fbyte==13||fbyte==10)){fbyte=getc(f1);}

		for(i=0;i<strlen(cl_);++i){if(cl_[i]!=' '&&cl_[i]!='\t'){break;}}
		cl_i=0;for(j=i;j<strlen(cl_);++j){cl[cl_i]=cl_[j];++cl_i;}

		if(strlen(cl)==0){continue;}
		if(0!=p_ex_(cl,"rem",1)){continue;}

		for(j=0;j<50;++j){for(i=0;i<plinel;++i){t_a[j][i]='\0';}}
		a=0;b=0;c=0;j=0;ci=1;d=0;
		++lc;

		//printf("%s\n",cl);

		sf=1;
		//keyw ---------------------------------------------------------------------------------------------------------
		p_syntax_(cl,p_kw_);
		j=0;while(!strlen(r_s[j])>0&&j<50){++j;}if(j>=50){j=0;}
		if(j!=0)
		{

			//i=1;c_p(p_kw_,i,1,c_1);++i;
			//while(strlen(c_1)>0){c_p(p_kw_,i,1,c_1);++i;if(p_comp(r_s[j],c_1)==1){printf("1!%s!%s!\n",r_s[j],c_1);break;}}

			if(p_comp(r_s[j],"for")==1)
			{
				p_syntax_(cl,b_for);
				k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?keyw?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1){errC_=0;}else{errC_=1;}
			}
			if(p_comp(r_s[j],"to")==1)
			{
			}
			if(p_comp(r_s[j],"next")==1)
			{
			}
			if(p_comp(r_s[j],"while")==1)
			{
				p_syntax_(cl,b_while_1);
				k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?keyw?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1){errC_=0;}else{errC_=1;}
			}
			if(p_comp(r_s[j],"wend")==1)
			{
			}
			if(p_comp(r_s[j],"if")==1)
			{
				p_syntax_(cl,b_if);
				k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?keyw?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1){errC_=0;}else{errC_=1;}
			}
			if(p_comp(r_s[j],"then")==1)
			{
			}
			if(p_comp(r_s[j],"end")==1)
			{
			}
			if(p_comp(r_s[j],"and")==1)
			{
			}
			if(p_comp(r_s[j],"or")==1)
			{
			}
			if(p_comp(r_s[j],"xor")==1)
			{
			}
			if(p_comp(r_s[j],"print")==1)
			{
				p_syntax_(cl,b_print_s);
				k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?keyw?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1){errC_=0;}
			}
			if(p_comp(r_s[j],"rem")==1)
			{
				continue;
			}
			if(p_comp(r_s[j],"open")==1)
			{
				p_syntax_(cl,b_fopen_i);
				k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?keyw?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1){errC_=0;}
				p_syntax_(cl,b_fopen_o);
				k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?keyw?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1){errC_=0;}

			}
			if(p_comp(r_s[j],"input")==1)
			{
				p_syntax_(cl,b_finput);
				k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?keyw?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1){errC_=0;}
			}
			if(p_comp(r_s[j],"output")==1)
			{
			}
			if(p_comp(r_s[j],"close")==1)
			{
				p_syntax_(cl,b_fclose);
				k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?keyw?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1){errC_=0;}
			}

			if(errC_==0){for(i=0;i<strlen(cl);++i){fprintf(f2,"%c",cl[i]);}fprintf(f2,"%c%c",(char)13,(char)10);}
			continue;
		}

		//exp ---------------------------------------------------------------------------------------------------------
		p_syntax_(cl,p_exp);
		j=0;while(strlen(r_s[j])>0&&j<50){++j;}if(j>=50){j=0;}
		if(j!=0)
		{
			if((r_s[1][0]=='$')&&(r_s[2][0]=='=')&&(r_s[4][0]=='$'))
			{
				//fns ---------------------------------------------------------------------------------------------------------
				if(p_comp(r_s[3],"mid")==1)
				{
					p_syntax_(cl,b_mid);
					k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?fns?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1)	{errC_=0;}else{errC_=1;}
				}
				if(p_comp(r_s[3],"len")==1)
				{
					p_syntax_(cl,b_len);
					k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?fns?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1)	{errC_=0;}else{errC_=1;}
				}
				if(p_comp(r_s[3],"right")==1)
				{
					p_syntax_(cl,b_right);
					k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?fns?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1)	{errC_=0;}else{errC_=1;}
				}
				if(p_comp(r_s[3],"left")==1)
				{
					p_syntax_(cl,b_left);
					k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?fns?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1)	{errC_=0;}else{errC_=1;}
				}
				if(p_comp(r_s[3],"trim")==1)
				{
					p_syntax_(cl,b_trim);
					k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?fns?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1){errC_=0;}else{errC_=1;}
				}
				if(p_comp(r_s[3],"val")==1)
				{
					p_syntax_(cl,b_val);
					k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?fns?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1)	{errC_=0;}else{errC_=1;}
				}
				if(p_comp(r_s[3],"format")==1)
				{
					p_syntax_(cl,b_format);
					k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?fns?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1)	{errC_=0;}else{errC_=1;}
				}
				if(p_comp(r_s[3],"round")==1)
				{
					p_syntax_(cl,b_round);
					k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?fns?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1){errC_=0;}else{errC_=1;}
				}
			}else{
				k=-1;for(j=0;j<12;++j){if(strlen(r_s[j])>0){if(!sf){printf("?%d?exp?%d?%s?\n",lc,j,r_s[j]);}++k;}}if(k!=-1){errC_=0;}else{errC_=1;}
			}
			
			if(errC_==0){for(i=0;i<strlen(cl);++i){fprintf(f2,"%c",cl[i]);}fprintf(f2,"%c%c",(char)13,(char)10);}
			continue;

		}
	}
	fclose(f1);
	fclose(f2);

	return(errC_);

}

double p_v(char pv_a1[256])
{

	int	df=0;
	int	i,l;
	double	p_v;

	p_v=0;l=0;
	for(i=-1+strlen(pv_a1);i>=0;--i)
	{
		p_v+=(double)(-48+(int)pv_a1[i])*pow(10,l);
		if(df){printf("%d %e\n",-48+(int)pv_a1[i],pow(10,l));}
		++l;
	}
	return(p_v);

}

long p_v_(char na[256])
{

__int64 	lv=0;
int			i,j,l;

for(i=0;i<strlen(na);++i){if(na[i]=='.'){break;}}
	
l=0;lv=0;
for(j=i-1;j>=0;--j){lv+=(na[j]-48)*pow(10,l);++l;}
	
return((long)lv);

}

int p_f_(double seql)
{
	int		i,j,k,l;
	long 	n,m;
	long 	mult[10];
	char	la_[256];int la_i=0;

	if(!seql){i=0;rlc[i]='0';++i;rlc[i]='\0';return(0);}
	if(seql-pow(10,0)<0){i=0;rlc[i]='0';++i;rlc[i]='\0';return(0);}

	for(i=0;i<256;++i){la_[i]='\0';}
	for(i=0;i<10;++i){mult[i]=-1;}

	j=0;i=0;
	while(seql-pow(10,i)>=0)
	{
		//printf("%d ",(int)pow(10,i));
		mult[j]=(long)pow(10,i);
		++j;++i;
	}
	//printf("\n");

	m=-1;
	while(j>0)
	{
		--j;
		n=seql/(double)mult[j];
		if(m!=-1)
		{
			//printf("%d\n",n-m*10);
			la_[la_i]=48+(n-m*10);++la_i;m=n;
		}else{
			if(n==10)
			{
				//printf("1");
				la_[la_i]='1';++la_i;
			}else{
				//printf("%d\n",n);
				la_[la_i]=48+n;++la_i;
			}
			m=n;
		}
		n=seql-(double)mult[j]*n;
	}
	j=i;
	for(i=0;i<j;++i){rlc[i]='0';}
	for(i=j;i<256;++i){rlc[i]='\0';}
	for(i=j;i>=0;--i){rlc[j]=la_[i];--j;}
	//printf("\n!rlc !%s!\n",rlc);
	return(0);
}

int p_format(double ar1,char fm[256],char ar2[256])
{

	int		i,j,k,l,m,n,c;
	int		sig=0;
	char 		ar_[256];
	int		ar_i;
	int		ar2i;
	char 		fm_[256];

	char		lfm[256]="0000000000";
	int		li=1;
	double		fr;
	int		ex;
	
	//0.00
	//#.00
	//#.##
	//000000
	//######
	//#,###,##0.00
	//

	//printf("\nPara: !%s! %e\n",fm,ar1);

	for(i=0;i<256;++i){fm_[i]='\0';}
	if(ar1<0){ar1*=(double)-1;sig=1;}
	i=0;c=0;for(j=0;j<strlen(fm);++j){fm_[i]=fm[j];if(fm[j]==','){++c;}++i;}
	if(strlen(fm)!=0)
	{
		l=0;for(j=-1+strlen(fm);j>=0;--j){if(fm[j]=='.'){break;}else{++l;}}
		if(j==-1){m=0;}else{m=l;}
	}else{m=2;}
	//decimal point point

	fr=0;if(m){p_f_(ar1);p_f_((ar1-p_v(rlc))*pow(10,m));ex=m;fr=p_v(rlc);}
	
	//fr=0;i=0;while(i<m){++i;fr=(double)(ar1*pow(10,i)-((__int64)ar1*(__int64)pow(10,i)));}ex=i;

	if(strlen(fm)!=0)
	{
		p_f_(ar1);//if(ar1>1){p_f_(ar1);}else{i=0;rlc[i]='0';++i;rlc[i]='\0';}
		if(m){k=1+m;}else{k=0;}
		
		if(strlen(rlc)<(strlen(fm_)-k))
		{
			j=strlen(fm_);l=strlen(rlc);
			for(i=l-1;i>=0;--i){rlc[i+((j-k)-l)]=rlc[i];}
			for(i=0;i<((j-k)-l);++i){rlc[i]=' ';}
		}else{
			if(strlen(rlc)>(strlen(fm_)-(k+c)))
			{
				j=strlen(fm_);l=strlen(rlc);
				for(i=j-1;i>=0;--i){fm_[i+(l-(j-(k+c)))]=fm_[i];}
				for(i=0;i<(l-(j-(k+c)));++i){fm_[i]=' ';}
				j=strlen(fm_);
				for(i=-1+j;i>=0;--i){rlc[i+c]=rlc[i];}
				for(i=0;i<c;++i){rlc[i]=' ';}
			}
		}
		
		//printf("\n!%s!\n!%s! %d %e\n",rlc,fm_,m,fr);

		for(j=0;j<256;++j){ar_[j]='\0';}ar_i=0;
		for(j=-1+strlen(fm_);j>=0;--j){if(fm_[j]=='.'){break;}}if(j==-1){j=strlen(fm_);}
		ar_i=0;for(i=0;i<j;++i){if(fm_[i]=='#'){ar_[ar_i]=' ';++ar_i;}else{ar_[ar_i]=fm_[i];++ar_i;}}
		l=-1+strlen(ar_);for(i=-1+strlen(ar_);i>=0;--i)
		{
			if(ar_[i]!=','){if(rlc[l]!=' '){ar_[i]=rlc[l];--l;}else{--l;}}
			if(ar_[i]==','){if(rlc[l]==' '){ar_[i]=' ';--l;}}
		}
		
		if(fr>1){p_f_(fr);}else{i=0;rlc[i]='0';++i;rlc[i]='0';++i;rlc[i]='\0';}
		if(m){ar_[ar_i]='.';++ar_i;while(strlen(rlc)<m){ar_[ar_i]='0';++ar_i;--m;}l=0;while(l<strlen(rlc)){ar_[ar_i]=rlc[l];++ar_i;++l;}}
		for(j=0;j<256;++j){ar2[j]='\0';}ar2i=0;
		if(sig==1){ar2[ar2i]='-';++ar2i;}
		for(j=0;j<strlen(ar_);++j){ar2[ar2i]=ar_[j];++ar2i;}
		//printf("\nOut: !%s!\n",ar2);
	}else{

		for(j=0;j<256;++j){ar_[j]='\0';}ar_i=0;
		p_f_(ar1);//if(ar1>1){p_f_(ar1);}else{i=0;rlc[i]='0';++i;rlc[i]='\0';}
		k=0;while(k<strlen(rlc)){ar_[ar_i]=rlc[k];++k;++ar_i;}

		if(fr>1){p_f_(fr);}else{i=0;rlc[i]='0';++i;rlc[i]='0';++i;rlc[i]='\0';}
		if(m){ar_[ar_i]='.';++ar_i;while(strlen(rlc)<m){ar_[ar_i]='0';++ar_i;--m;}l=0;while(l<strlen(rlc)){ar_[ar_i]=rlc[l];++ar_i;++l;}}
		for(j=0;j<256;++j){ar2[j]='\0';}ar2i=0;
		if(sig==1){ar2[ar2i]='-';++ar2i;}
		for(j=0;j<strlen(ar_);++j){ar2[ar2i]=ar_[j];++ar2i;}
		//printf("\nOut: !%s!\n",ar2);	
	}

	return(0);

}

double p_val(char arr0[256])
{

	int		sg=1;
	int		i,j=0,k=0,l;
	char 	arr1[256];

	double		rv;
	__int64	rvf;
	__int64	rvd;

	for(j=0;j<256;++j){arr1[j]='\0';}
	l=0;for(j=0;j<256;++j){if((arr0[j]>='0'&&arr0[j]<='9')||(arr0[j]=='.')||(arr0[j]=='+')||(arr0[j]=='-'))
	{arr1[l]=arr0[j];++l;}}for(j=0;j<256;++j){arr0[j]=arr1[j];}
	
	if((arr0[0]=='-')||(arr0[0]=='+'))
	{
		if(arr0[0]=='-'){sg=-1;}
		l=0;for(j=1;j<strlen(arr0);++j){arr0[l]=arr0[j];++l;}arr0[l]='\0';
	}
	if(arr0[0]=='.')
	{
		l=strlen(arr0);for(j=strlen(arr0)-1;j>=0;--j){arr0[l]=arr0[j];--l;}
		arr0[l]='0';
	}
	for(j=0;j<strlen(arr0);++j){i=j;if(arr0[j]=='.'){break;}}
	if(j==strlen(arr0))
	{

		i=strlen(arr0);
		rvd=0;l=-1;
		for(j=-1+i;j>=0;--j)
		{
			++l;rvd+=(__int64)(-48+arr0[j])*(__int64)pow(10,l);
		}
		
		rv=(double)rvd;
		
	}else{
	
		rvd=0;l=-1;
		for(j=-1+i;j>=0;--j)
		{
			++l;rvd+=(__int64)(-48+arr0[j])*(__int64)pow(10,l);
		}
		
		rvf=0;l=-1;
		for(j=-1+strlen(arr0);j>i;--j)
		{
			++l;rvf+=(__int64)(-48+arr0[j])*(__int64)pow(10,l);
		}
		
		rv=(double)rvd;
		rv+=(double)rvf/pow(10,-1+strlen(arr0)-i);
	
	}

	return((double)sg*rv);

}

double p_round(double basev)
{

	char	f_s[256];
	char	d_s[256];
	char	fd_s[256];

	int		i,j,k;
	double	n;

	for(j=0;j<256;++j){f_s[j]='\0';}
	for(j=0;j<256;++j){d_s[j]='\0';}
	for(j=0;j<256;++j){fd_s[j]='\0';}

	p_format(basev,"0.0000",f_s);

	for(i=0;i<strlen(f_s);++i){if(f_s[i]=='.'){break;}}
	
	k=0;for(j=i+1;j<strlen(f_s);++j){d_s[k]=f_s[j];++k;}

	n=p_val(d_s);
	p_format(n,"###0",fd_s);

	if(strlen(fd_s)==4)
	{

		if(fd_s[2]>='5'&&fd_s[3]>='0')
		{

			if(fd_s[0]>='4'&&fd_s[1]>='9')
			{
				for(j=0;j<256;++j){d_s[j]='\0';}
				k=0;for(j=0;j<i;++j){d_s[k]=f_s[j];++k;}
				return(1+p_val(d_s));
			}else{
				for(j=0;j<256;++j){d_s[j]='\0';}
				k=0;for(j=0;j<i;++j){d_s[k]=f_s[j];++k;}
				return(p_val(d_s));
			}

		}else{

			if(fd_s[0]>='5'&&fd_s[1]>='0')
			{
				for(j=0;j<256;++j){d_s[j]='\0';}
				k=0;for(j=0;j<i;++j){d_s[k]=f_s[j];++k;}
				return(1+p_val(d_s));
			}else{
				for(j=0;j<256;++j){d_s[j]='\0';}
				k=0;for(j=0;j<i;++j){d_s[k]=f_s[j];++k;}
				return(p_val(d_s));
			}

		}

	}else{

		if(strlen(fd_s)==3)
		{

			if(fd_s[2]>='5')
			{

				if(fd_s[0]>='4'&&fd_s[1]>='9')
				{
					for(j=0;j<256;++j){d_s[j]='\0';}
					k=0;for(j=0;j<i;++j){d_s[k]=f_s[j];++k;}
					return(1+p_val(d_s));
				}else{
					for(j=0;j<256;++j){d_s[j]='\0';}
					k=0;for(j=0;j<i;++j){d_s[k]=f_s[j];++k;}
					return(p_val(d_s));
				}

			}else{

				if(fd_s[0]>='5')
				{
					for(j=0;j<256;++j){d_s[j]='\0';}

					k=0;for(j=0;j<i;++j){d_s[k]=f_s[j];++k;}
					return(1+p_val(d_s));
				}else{
					for(j=0;j<256;++j){d_s[j]='\0';}
					k=0;for(j=0;j<i;++j){d_s[k]=f_s[j];++k;}
					return(p_val(d_s));
				}
			}

		}else{

				if(fd_s[0]>='5')
				{

					for(j=0;j<256;++j){d_s[j]='\0';}
					k=0;for(j=0;j<i;++j){d_s[k]=f_s[j];++k;}
					return(1+p_val(d_s));
				}else{
					for(j=0;j<256;++j){d_s[j]='\0';}
					k=0;for(j=0;j<i;++j){d_s[k]=f_s[j];++k;}
					return(p_val(d_s));
				}
		}
	}

	return(0);
}

int p_len(char arr0[plinel])
{
	int		i,j,k=0;

	for (i=-1+plinel;i>=0&&arr0[i]=='\0';--i){}
	for (j=0;j<=i;++j){if(arr0[j]=='\''||arr0[j]=='\"'){++k;}}++i;
	return(i-k);
}

int p_left(char arr0[plinel],int b,char arr1[plinel])
{
	int	i,j,k=0,l;

	for(i=0;i<plinel;++i){arr1[i]='\0';}
	j=p_len(arr0);l=j-b;
	if((arr0[0]=='\''||arr0[0]=='\"'))
	{
		arr1[k]=arr0[k];++k;
		for (i=1;k-1<l;++i){arr1[k]=arr0[i];++k;}arr1[k]='\'';++k;
		if(arr1[-1+k]=='\''){}else{arr1[k]='\'';++k;}
	}else{
		arr1[k]='\'';++k;
		for (i=0;k-1<l;++i){arr1[k]=arr0[i];++k;}
		if(arr1[-1+k]=='\''){}else{arr1[k]='\'';++k;}
	}
	return(0);
}

int p_right(char arr0[plinel],int b,char arr1[plinel])
{
	int	i,j,k=0,l;

	for(i=0;i<plinel;++i){arr1[i]='\0';}
	j=p_len(arr0);l=j-b;
	if((arr0[0]=='\''||arr0[0]=='\"'))
	{
		arr1[k]=arr0[k];++k;
		for (i=l;k-1<b;++i){arr1[k]=arr0[i];++k;}
		if(arr1[-1+k]=='\''){}else{arr1[k]='\'';++k;}
	}else{
		arr1[k]='\'';++k;
		for (i=l-1;k-1<b;++i){arr1[k]=arr0[i];++k;}
		if(arr1[-1+k]=='\''){}else{arr1[k]='\'';++k;}
	}
	return(0);
}

int p_mid(char arr0[plinel],int a,int b,char arr1[plinel])
{
	char 	p0[plinel];
	char 	p1[plinel];

	int	i,j,k=0,l;

	for(i=0;i<plinel;++i){p0[i]='\0';}
	for(i=0;i<plinel;++i){p1[i]='\0';}

	p_left(arr0,-1+strlen(arr0)-(a+b),p0);
	//p_right(arr0,strlen(p0)-a,p1);

	for(i=0;i<plinel;++i){arr1[i]='\0';}
	k=0;arr1[k]='\'';++k;
	l=b;for(i=a;i<strlen(p0)&&l>0;++i){arr1[k]=p0[i];++k;--l;}
	arr1[k]='\'';++k;

	return(0);
}

int p_trim(char arr0[plinel],char arr1[plinel])
{

	int		i,j,k=0,l;
	int		a=0,b=0;
	char 	p0[plinel];
	char 	p1[plinel];

	for(j=0;j<plinel;++j){p0[j]='\0';}
	for(j=0;j<plinel;++j){p1[j]='\0';}
	for(j=0;j<plinel;++j){arr1[j]='\0';}

	for (i=strlen(arr0)-1;i>=0;--i)
	{
		if
		(
			arr0[i]=='\"'	||
			arr0[i]=='\''	||
			arr0[i]==' '	||
			arr0[i]==(char)9

		){}else{b=i;break;}
	}
	k=b;for(j=b;j>=0;--j){p0[k]=arr0[j];--k;}

	for (i=0;i<strlen(p0);++i)
	{
		if
		(
			p0[i]=='\"'	||
			p0[i]=='\''	||
			p0[i]==' '	||
			p0[i]==(char)9

		){}else{a=i;break;}
	}
	k=0;for(j=a;j<strlen(p0);++j){p1[k]=p0[j];++k;}
	
	k=0;arr1[k]='\'';++k;for(i=0;i<strlen(p1);++i){arr1[k]=p1[i];++k;}arr1[k]='\'';++k;

	return(0);
}

int r_strlen(char arr0[plinel])
{
	int		i,j=0,k=0;

	for (i=0;i<strlen(arr0);++i)
	{
		if 
		(
			(int)arr0[i]>=32&&
			(int)arr0[i]<=255
		)
		{if ((int)arr0[i]==32){++j;}else{++k;}}else{break;}
	}
	return(k+j);
}

int p_r_s_(int rs_i)
{

int		i,j,k;

char		tvarnl[vnaml];
int		rvi=0;

	for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
	k=0;
	for(j=0;j<-1+strlen(r_s[rs_i]);++j){tvarnl[k]=r_s[rs_i][j];++k;}
	
	for(j=0;j<vi;++j)
	{
		if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
	}
	if(j==vi){printf("reference err...%s\n",tvarnl);return(-1);}

	return(rvi);
}

int p_r_s_iv_(int rs_i,int pvi,long pvl,double pvd)
{

int		i,j,k;

char	tvarnl[vnaml];
int		rvi=0;

	for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
	k=0;
	for(j=0;j<-1+strlen(r_s[rs_i]);++j){tvarnl[k]=r_s[rs_i][j];++k;}
	
	for(j=0;j<vi;++j)
	{
		if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
	}
	if(j==vi){printf("reference err...%s\n",tvarnl);return(-1);}

	if(tarv[rvi][1]==2)
	{
		nvarv[tarv[rvi][0]][0]=pvi;

	}else{
		if(tarv[rvi][1]==3)
		{
			nvarv[tarv[rvi][0]][0]=((long)pvl&0xffff0000)>>16;
			nvarv[tarv[rvi][0]][1]=(long)pvl&0x0000ffff;

		}else{
			if(tarv[rvi][1]==4)
			{
				dvarv[tarv[rvi][0]]=(double)pvd;
			}
		}
	}

	return(0);

}

int p_ex(char arr11[plinel],char arr12[plinel])
{
		int		i,j,k,l;
		char		ca[plinel];
				
		for (i=0;i<strlen(arr11);++i)
		{
			for (k=0;k<plinel;++k){ca[k]='\0';}
			k=0;for (j=i;j<i+strlen(arr12);++j){ca[k]=arr11[j];++k;}
			for (l=0;l<strlen(arr12);++l){if(ca[l]==arr12[l]){}else{break;}}
			if (l==strlen(arr12)){break;}
		}
		if (i!=strlen(arr11)){return(i+strlen(arr12));}
		return(0);
}

void cmput()
{

	int			i,j,k,l;
	double		m;
	double		topa[vnaml][2];
	int			topi=0;

	//for(j=0;j<opi;++j){printf("%e\t%e\t\n",opa[j][0],opa[j][1]);}

	while(opi>1)
	{

		m=-1;for(i=0;i<opi-1;++i){if(m==-1){m=opa[i][1];l=i;}else{if(m>opa[i][1]){m=opa[i][1];l=i;}}}i=l;

		if(m==1)
		{
			opa[i][0]=pow(opa[i][0],opa[i+1][0]);opa[i][1]=opa[i+1][1];opa[i+1][0]=0;opa[i+1][1]=0;
//printf("^ %e\n",opa[i][0]);
		}

		if(m==2)
		{
			opa[i][0]=opa[i][0]*opa[i+1][0];opa[i][1]=opa[i+1][1];opa[i+1][0]=0;opa[i+1][1]=0;
//printf("* %e\n",opa[i][0]);
		}

		if(m==3)
		{
			opa[i][0]=opa[i][0]/opa[i+1][0];opa[i][1]=opa[i+1][1];opa[i+1][0]=0;opa[i+1][1]=0;
//printf("/ %e\n",opa[i][0]);
		}

		if(m==4)
		{
			opa[i][0]=opa[i][0]+opa[i+1][0];opa[i][1]=opa[i+1][1];opa[i+1][0]=0;opa[i+1][1]=0;
//printf("+ %e\n",opa[i][0]);
		}

		if(m==5)
		{
			opa[i][0]=opa[i][0]+(-1)*opa[i+1][0];opa[i][1]=opa[i+1][1];opa[i+1][0]=0;opa[i+1][1]=0;
//printf("- %e\n",opa[i][0]);
		}

		if(m==6)
		{
			opa[i][0]=opa[i+1][0];opa[i][1]=opa[i+1][1];opa[i+1][0]=0;opa[i+1][1]=0;
//printf("%e\n",opa[i][0]);
		}

		topi=0;
		for(j=0;j<opi;++j)
		{
			if(opa[j][1]!=0)
			{
				topa[topi][0]=opa[j][0];
				topa[topi][1]=opa[j][1];
				++topi;
			}
		}
		opi=topi;
		for(j=0;j<opi;++j)
		{
			opa[j][0]=topa[j][0];
			opa[j][1]=topa[j][1];

		}
	}

	//printf("=====================%d %d\n",opa[opi-1][0]);

}

//!!!

int vdcl_(int iline)
{	
	int	i,j,k,l,l1,m;

	int	sig=0;
	int	rvi;
	int	mp=0;
	char	il[plinel];int	ili=0;

	char	tvarnl[vnaml];
	long	fr=0;
	long	tv=0;
	double	dtv=0;

	linen=iline;
	for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
	for(i=0;i<strlen(pf[linen]);++i){il[ili]=pf[linen][i];++ili;}

	for(j=0;j<mc;++j){if (1<=p_ex(il,kw[j])){break;}}if(j!=mc){return(0);}
	
	//printf("%s\n",il);

	p_syntax_(il,p_exp);

	if(r_s[1][0]=='$'&&(r_s[3][0]=='\''||r_s[3][0]=='\"'))
	{

			i=p_syntax_(il,b_var_s);

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[0]);++j){tvarnl[j]=r_s[0][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j==vi)
			{
				for(j=0;j<vnaml;++j){varnl[vi][j]='\0';}
				for(j=0;j<-1+strlen(r_s[0]);++j){varnl[vi][j]=r_s[0][j];}

				for(i=0;i<plinel;++i){cvarv[ci][i]='\0';}

				i=0;cvarv[ci][0]=r_s[2][0];++i;
				for(j=0;j<strlen(r_s[3]);++j)
				{
					if
					(
						r_s[3][j]=='\''||
						r_s[3][j]=='"'
					)
					{}else{cvarv[ci][i]=r_s[3][j];++i;}
				}
				cvarv[ci][i]=r_s[4][0];++i;
				tarv[vi][0]=ci;
				tarv[vi][1]=1;
				++ci;
				++vi;

			}else{

				for(i=0;i<plinel;++i){cvarv[tarv[rvi][0]][i]='\0';}

				i=0;cvarv[tarv[rvi][0]][i]=r_s[2][0];++i;
				for(j=0;j<strlen(r_s[3]);++j)
				{
					if
					(
						r_s[3][j]=='\''||
						r_s[3][j]=='"'
					)
					{}else{cvarv[tarv[rvi][0]][i]=r_s[3][j];++i;}
				}
				cvarv[tarv[rvi][0]][i]=r_s[4][0];++i;
			}	

			return(0);
		
	}else{

		if((r_s[1][0]=='%'||r_s[1][0]=='&'||r_s[1][0]=='#')&&(!(r_s[2][0]=='(')))
		{

		for(i=0;i<strlen(r_s[3]);++i)
		{
			if
			(

				(r_s[3][i]=='+')||
				(r_s[3][i]=='-')||
				(r_s[3][i]=='*')||
				(r_s[3][i]=='/')||
				(r_s[3][i]=='^')

			){break;}
		}
		if(i!=strlen(r_s[3])){return(-1);}

		i=p_syntax_(il,b_var_n);

		if((r_s[3][0]=='\0')||(r_s[4][0]!='\0'&&r_s[4][0]!='+'&&r_s[4][0]!='-')){return(-1);}

		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		for(j=0;j<-1+strlen(r_s[0]);++j){tvarnl[j]=r_s[0][j];}

		for(j=0;j<vi;++j)
		{
			if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
		}
		if(j==vi)
		{
			for(j=0;j<vnaml;++j){varnl[vi][j]='\0';}
			for(j=0;j<-1+strlen(r_s[0]);++j){varnl[vi][j]=r_s[0][j];}

			for(j=0;j<strlen(r_s[3]);++j)
			{
				if
				(!(
					(r_s[3][j]>='0'&&r_s[3][j]<='9')||
					(r_s[3][j]==',')||
					(r_s[3][j]=='.')||
					(r_s[3][j]=='-')

				)){break;}
			}

			if(j==strlen(r_s[3]))
			{

				if(r_s[2][0]=='-'){sig=1;}
				if(r_s[4][0]=='-'){sig=1;}

				if(r_s[2][0]=='+'){sig=0;}
				if(r_s[4][0]=='+'){sig=0;}

				dtv=p_val(r_s[3]);
				if(sig==1){dtv*=-1;}

				p_syntax_(il,p_exp);

				if(r_s[1][0]=='%')
				{
					nvarv[ni][0]=dtv;
					nvarv[ni][1]=0;
					tarv[vi][0]=ni;
					tarv[vi][1]=2;
					++ni;
					++vi;
				}
				if(r_s[1][0]=='&')
				{
					nvarv[ni][0]=((long)dtv&0xffff0000)>>16;
					nvarv[ni][1]=(long)dtv&0x0000ffff;
					tarv[vi][0]=ni;					
					tarv[vi][1]=3;					
					++ni;
					++vi;				
				}
				if(r_s[1][0]=='#')
				{
					dvarv[dni]=dtv;
					tarv[vi][0]=dni;					
					tarv[vi][1]=4;
					++dni;
					++vi;
				}

				return(0);

			}else{return(-1);}

		}else{

			if(r_s[2][0]=='-'){sig=1;}
			if(r_s[4][0]=='-'){sig=1;}

			if(r_s[2][0]=='+'){sig=0;}
			if(r_s[4][0]=='+'){sig=0;}

			for(j=0;j<strlen(r_s[3]);++j)
			{
				if
				(!(
					(r_s[3][j]>='0'&&r_s[3][j]<='9')||
					(r_s[3][j]==',')||
					(r_s[3][j]=='.')||
					(r_s[3][j]=='-')

				)){break;}
			}

			if(j==strlen(r_s[3]))
			{

				dtv=p_val(r_s[3]);
				if(sig==1){dtv*=-1;}

				if(tarv[rvi][1]==2)
				{
					nvarv[tarv[rvi][0]][0]=(int)dtv;
					nvarv[tarv[rvi][0]][1]=0;
				}
				if(tarv[rvi][1]==3)
				{
					nvarv[tarv[rvi][0]][0]=((long)dtv&0xffff0000)>>16;
					nvarv[tarv[rvi][0]][1]=(long)dtv&0x0000ffff;
				}
				if(tarv[rvi][1]==4)
				{
					dvarv[tarv[rvi][0]]=dtv;
				}

				return(0);

			}else{return(-1);}

		}

		}else{

				p_syntax_(il,p_exp);

				if(r_s[2][0]=='='&&(strlen(r_s[2])>1)){return(-1);}
		}
	}

	return(0);
}

//!!!

int exc(int linn)
{
	int			i,j,k,l,m,p1,p2;
	int			fbyte;
	int			rvi;
	int			fvi;

	int			lcL,lcR;
	int			ll,lr;
	int			ciL;
	int			ciR;

	long		clL;
	long		clR;

	double		cdL;
	double		cdR;

	char		il[plinel];int	ili=0;
	
	char		tvarnl[vnaml];
	char		svarnl[plinel];
	int			cp[50][6];int cpi=0;

	char		rvarnl[vnaml];

	long		t,tv;
	int		el,cl;
	int		bf;
	int			lc=1;
	double		dtv;
	long		fr;
	char		rsvarnl[plinel];int	rsvarnli=0;


	for(i=0;i<plinel;++i){rsvarnl[i]='\0';}rsvarnli=0;
	for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
	for(i=0;i<r_strlen(pf[linn]);++i){il[ili]=pf[linn][i];++ili;}

	cl=0;
	if 
	(

			(
				1<=p_ex(il,"print ")   ||
				1<=p_ex(il,"=mid$(")   ||
				1<=p_ex(il,"=trim$(")  ||
				1<=p_ex(il,"=left$(")  ||
				1<=p_ex(il,"=right$(") ||
				1<=p_ex(il,"=len$(")   ||
				1<=p_ex(il,"=val$(")   ||
				1<=p_ex(il,"=format$(")||
				1<=p_ex(il,"=round$(")
			)
			||
			(
				1<=p_ex(il,"input #")       ||
				1<=p_ex(il,"for input as")  ||
				1<=p_ex(il,"for output as") ||
				1<=p_ex(il,"close #")
			)

	){cl=1;}

	if (cl)
	{

		if (1<=(l=p_ex(il,"print")))
		{
			i=p_syntax_(il,b_print_v);

			fvi=-1;
			if(r_s[2][0]=='#')
			{

				p1=0;l=-1;
				for(j=-1+strlen(r_s[3]);j>=0;--j)
				{
					++l;p1+=(-48+r_s[3][j])*pow(10,l);
				}
					
				for(j=0;j<fni;++j)
				{
					if(p1==fvarc[j]){fvi=j;break;}
				}
				if(j==fni){printf("reference err...%d\n",p1);return(0);}
				
				if(strlen(r_s[4])==0){return(0);}
				for(j=l;j<strlen(il);++j){if(il[j]==r_s[4][0]){break;}}
				if(j==strlen(il)){return(0);}else{++l;}
				
			}

			if(strlen(r_s[5])||strlen(r_s[6]))
			{
				if(strlen(r_s[5]))
				{
					for(j=l;j<strlen(il);++j){if(il[j]==r_s[5][0]){break;}}
					if(j==strlen(il)){return(0);}
					for(i=0;i<plinel;++i){svarnl[i]='\0';}
					k=0;for(i=j;i<strlen(il);++i){svarnl[k]=il[i];++k;}					
				}else{
					if(strlen(r_s[6]))
					{
						for(j=l;j<strlen(il);++j){if(il[j]==r_s[6][0]){break;}}
						if(j==strlen(il)){return(0);}
						for(i=0;i<plinel;++i){svarnl[i]='\0';}
						k=0;for(i=j;i<strlen(il);++i){svarnl[k]=il[i];++k;}					
					}
				}	
			}
			
			int a,b,c;
			
			while(strlen(svarnl)>1)
			{
				
				i=p_syntax_(svarnl,b_arg_s);
				if(strlen(r_s[0]))
				{
					if(!of)
					{
						if(fvi!=-1){fprintf(fvars[fvi],"%s",r_s[1]);}else{
						printf("%s",r_s[1]);}
					}else{
						if(fvi!=-1){fprintf(fvars[fvi],"%s",r_s[1]);}else{
						fprintf(fout,"%s",r_s[1]);}
					}
					if(!strlen(r_s[3])){break;}
					b=0;for(j=0;j<strlen(svarnl);++j){if(svarnl[j]==r_s[3][0]){break;}}
					if(j==strlen(svarnl)){break;}
					b=1+j;i=0;a=strlen(svarnl);
				
					for(j=b;j<a;++j){svarnl[i]=svarnl[j];++i;}
					for(j=i;j<plinel;++j){svarnl[j]='\0';}
				}

				i=p_syntax_(svarnl,b_arg_v);
				if(strlen(r_s[0]))
				{
					for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
					k=0;
					for(j=0;j<strlen(r_s[0]);++j){tvarnl[k]=r_s[0][j];++k;}
					//printf("%s\n",tvarnl);
					for(j=0;j<vi;++j)
					{
						if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
					}
					if(j!=vi)
					{
						if (tarv[rvi][1]==2)
						{

							if(!of)
							{
								if(fvi!=-1){fprintf(fvars[fvi],"%ld",nvarv[tarv[rvi][0]][0]);}else{
									printf("%ld",nvarv[tarv[rvi][0]][0]);}
							}else{
								if(fvi!=-1){fprintf(fvars[fvi],"%ld",nvarv[tarv[rvi][0]][0]);}else{
									fprintf(fout,"%ld",nvarv[tarv[rvi][0]][0]);}
							}


						}

						if(tarv[rvi][1]==3)
						{
							if(!of)
							{
								if(fvi!=-1){fprintf(fvars[fvi],"%ld",(nvarv[tarv[rvi][0]][0]<<16)|nvarv[tarv[rvi][0]][1]);}else{
									printf("%ld",(nvarv[tarv[rvi][0]][0]<<16)|nvarv[tarv[rvi][0]][1]);}
							}else{
								if(fvi!=-1){fprintf(fvars[fvi],"%ld",(nvarv[tarv[rvi][0]][0]<<16)|nvarv[tarv[rvi][0]][1]);}else{
									fprintf(fout,"%ld",(nvarv[tarv[rvi][0]][0]<<16)|nvarv[tarv[rvi][0]][1]);}
							}
						}

						if(tarv[rvi][1]==4)
						{

							if(!of)
							{
								if(fvi!=-1){fprintf(fvars[fvi],"%e",dvarv[tarv[rvi][0]]);}else{
									printf("%e",dvarv[tarv[rvi][0]]);}
							}else{
								if(fvi!=-1){fprintf(fvars[fvi],"%e",dvarv[tarv[rvi][0]]);}else{
									fprintf(fout,"%e",dvarv[tarv[rvi][0]]);}
							}
						}

						if (tarv[rvi][1]==1)
						{
							for(j=0;j<strlen(cvarv[tarv[rvi][0]]);++j)
							{
								if
								(
									cvarv[tarv[rvi][0]][j]=='\''||
									cvarv[tarv[rvi][0]][j]=='"'
								)
								{}else{
									if(r_s[1][0]=='$')
									{
										if(!of)
										{
											if(fvi!=-1){fprintf(fvars[fvi],"%c",cvarv[tarv[rvi][0]][j]);}else{
												printf("%c",cvarv[tarv[rvi][0]][j]);}
										}else{
											if(fvi!=-1){fprintf(fvars[fvi],"%c",cvarv[tarv[rvi][0]][j]);}else{
												fprintf(fout,"%c",cvarv[tarv[rvi][0]][j]);}
										}
									}
								}
							}

						}
						
						if(!strlen(r_s[2])){break;}
						b=0;for(j=0;j<strlen(svarnl);++j){if(svarnl[j]==r_s[2][0]){break;}}
						if(j==strlen(svarnl)){break;}
						b=1+j;i=0;a=strlen(svarnl);
				
						for(j=b;j<a;++j){svarnl[i]=svarnl[j];++i;}
						for(j=i;j<plinel;++j){svarnl[j]='\0';}

					}else{printf("???reference err...%s\n",tvarnl);return(0);}
				}
			}

			if(il[-1+strlen(il)]!=';')
			{
				if(fvi!=-1){fprintf(fvars[fvi],"%c%c",(char)13,(char)10);}
				if(!of){printf("\n");}else{fprintf(fout,"%c%c",(char)13,(char)10);}
			}
			//printf("%s\t!\t%s\t%s\t%s\t%s\n",svarnl,r_s[0],r_s[1],r_s[2],r_s[3],r_s[4]);

			return(0);

		}else{

			if(1<=p_ex(il,"=mid$("))

			{
				i=p_syntax_(il,b_mid);

				if
				(
					(r_s[6][0]=='%'||r_s[6][0]=='&')&&
					(r_s[9][0]=='%'||r_s[9][0]=='&')
				)
				{
					r_s[5][strlen(r_s[5])]=r_s[6][0];
					r_s[8][strlen(r_s[8])]=r_s[9][0];

					p1=(int)nvarv[tarv[p_r_s_(5)][0]][0]&0x00ff;
					p2=(int)nvarv[tarv[p_r_s_(8)][0]][0]&0x00ff;
					
					p_mid(cvarv[tarv[p_r_s_(3)][0]],p1,p2,svarnl);
					i=p_r_s_(0);k=0;
					for(j=0;j<plinel;++j)
					{cvarv[tarv[i][0]][k]=svarnl[j];++k;}

					return(0);
				}

				if
				(
					(strlen(r_s[6])==0)&&(strlen(r_s[9])==0)
				)
				{

					p1=(int)p_val(r_s[5]);
					p2=(int)p_val(r_s[8]);
					
					p_mid(cvarv[tarv[p_r_s_(3)][0]],p1,p2,svarnl);
					i=p_r_s_(0);k=0;
					for(j=0;j<plinel;++j){cvarv[tarv[i][0]][k]=svarnl[j];++k;}

					return(0);
				}

				if
				(
					(strlen(r_s[6])==0)&&
					(r_s[9][0]=='%'||r_s[9][0]=='&')
				)
				{

					r_s[8][strlen(r_s[8])]=r_s[9][0];

					p1=(int)p_val(r_s[5]);
					p2=(int)nvarv[tarv[p_r_s_(8)][0]][0]&0x00ff;
					
					p_mid(cvarv[tarv[p_r_s_(3)][0]],p1,p2,svarnl);
					i=p_r_s_(0);k=0;
					for(j=0;j<plinel;++j){cvarv[tarv[i][0]][k]=svarnl[j];++k;}

					return(0);
				}

				if
				(
					(strlen(r_s[9])==0)&&
					(r_s[6][0]=='%'||r_s[6][0]=='&')
				)
				{
					r_s[5][strlen(r_s[5])]=r_s[6][0];

					p1=(int)nvarv[tarv[p_r_s_(5)][0]][0]&0x00ff;
					p2=(int)p_val(r_s[8]);
					
					p_mid(cvarv[tarv[p_r_s_(3)][0]],p1,p2,svarnl);
					i=p_r_s_(0);k=0;
					for(j=0;j<plinel;++j){cvarv[tarv[i][0]][k]=svarnl[j];++k;}

					return(0);
				}

				return(0);

			}else{
//===============================
			if(1<=p_ex(il,"=left$("))
			{
				i=p_syntax_(il,b_left);

				p1=(int)p_val(r_s[5]);
					
				p_left(cvarv[tarv[p_r_s_(3)][0]],p1,svarnl);
				i=p_r_s_(0);k=0;
				for(j=0;j<plinel;++j){cvarv[tarv[i][0]][k]=svarnl[j];++k;}

				return(0);
			}else{
//===============================
			if(1<=p_ex(il,"=right$("))
			{

				i=p_syntax_(il,b_right);

				p1=(int)p_val(r_s[5]);
					
				p_right(cvarv[tarv[p_r_s_(3)][0]],p1,svarnl);
				i=p_r_s_(0);k=0;
				for(j=0;j<plinel;++j){cvarv[tarv[i][0]][k]=svarnl[j];++k;}

				return(0);

			}else{
//===============================
			if(1<=p_ex(il,"=trim$("))
			{
				i=p_syntax_(il,b_trim);

				p_trim(cvarv[tarv[p_r_s_(3)][0]],svarnl);
				i=p_r_s_(0);k=0;
				for(j=0;j<plinel;++j){cvarv[tarv[i][0]][k]=svarnl[j];++k;}

				return(0);
			}else{
//===============================
			if(1<=p_ex(il,"=len$("))
			{
				i=p_syntax_(il,b_len);

				l=p_len(cvarv[tarv[p_r_s_(3)][0]]);
				p_r_s_iv_(0,(int)l,(long)l,(double)l);

				return(0);
			}else{
//===============================
			if(1<=p_ex(il,"=val$("))
			{
				i=p_syntax_(il,b_val);

				dtv=p_val(cvarv[tarv[p_r_s_(3)][0]]);
				p_r_s_iv_(0,(int)dtv,(long)dtv,dtv);

				return(0);

			}else{
//===============================
			if(1<=p_ex(il,"=round$("))
			{
				i=p_syntax_(il,b_round);

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				k=0;
				for(j=0;j<strlen(r_s[3]);++j)
				{
					if
					(
						r_s[3][j]=='#'||
						r_s[3][j]=='%'||
						r_s[3][j]=='&'||
						r_s[3][j]=='$'

					){}else{tvarnl[k]=r_s[3][j];++k;}
				}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					if(tarv[rvi][1]==2)
					{
						dtv=(double)nvarv[tarv[rvi][0]][0];

					}else{
						if(tarv[rvi][1]==3)
						{
							dtv=(double)(nvarv[tarv[rvi][0]][0]<<16);
							dtv+=(double)nvarv[tarv[rvi][0]][1];

						}else{
							if(tarv[rvi][1]==4)
							{
								dtv=dvarv[tarv[rvi][0]];
							}
						}
					}

				}else{printf("reference err...%s\n",tvarnl);return(0);}

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				k=0;
				for(j=0;j<strlen(r_s[0]);++j)
				{
					if
					(
						r_s[3][j]=='#'||
						r_s[3][j]=='%'||
						r_s[3][j]=='&'||
						r_s[3][j]=='$'

					){}else{tvarnl[k]=r_s[0][j];++k;}
				}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					if(tarv[rvi][1]==2)
					{
						nvarv[tarv[rvi][0]][0]=(int)p_round(dtv);

					}else{
						if(tarv[rvi][1]==3)
						{
							nvarv[tarv[rvi][0]][0]=(((long)p_round(dtv))&0xffff0000)<<16;
							nvarv[tarv[rvi][0]][1]=((long)p_round(dtv))&0x0000ffff;

						}else{
							if(tarv[rvi][1]==4)
							{
								dvarv[tarv[rvi][0]]=p_round(dtv);
							}
						}
					}

				}else{printf("reference err...%s\n",tvarnl);return(0);}

				return(0);

			}else{
//===============================
			if(1<=p_ex(il,"=format$("))
			{
				i=p_syntax_(il,b_format);

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				k=0;
				for(j=0;j<strlen(r_s[3]);++j)
				{
					if
					(
						r_s[3][j]=='#'||
						r_s[3][j]=='%'||
						r_s[3][j]=='&'||
						r_s[3][j]=='$'

					){}else{tvarnl[k]=r_s[3][j];++k;}
				}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					if(tarv[rvi][1]==2)
					{
						dtv=(double)nvarv[tarv[rvi][0]][0];

					}else{
						if(tarv[rvi][1]==3)
						{
							dtv=(double)(nvarv[tarv[rvi][0]][0]<<16);
							dtv+=(double)nvarv[tarv[rvi][0]][1];

						}else{
							if(tarv[rvi][1]==4)
							{
								dtv=dvarv[tarv[rvi][0]];
							}
						}
					}

				}else{printf("reference err...%s\n",tvarnl);return(0);}

				for(j=0;j<plinel;++j){svarnl[j]='\0';}k=0;
				for(j=0;j<strlen(r_s[6]);++j){svarnl[k]=r_s[6][j];++k;}

				p_format(dtv,svarnl,rsvarnl);

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				k=0;
				for(j=0;j<strlen(r_s[0]);++j)
				{
					if
					(
						r_s[0][j]=='#'||
						r_s[0][j]=='%'||
						r_s[0][j]=='&'||
						r_s[0][j]=='$'
	
					){}else{tvarnl[k]=r_s[0][j];++k;}
				}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					for(j=0;j<plinel;++j){cvarv[tarv[rvi][0]][j]='\0';}
					k=0;
					for(j=0;j<plinel;++j){cvarv[tarv[rvi][0]][k]=rsvarnl[j];++k;}

				}else{printf("reference err...%s\n",tvarnl);return(0);}

				return(0);

			}else{
//===============================
			if(1<=p_ex(il,"for input as")||1<=p_ex(il,"for output as"))
			{
				if(1<=p_ex(il,"for input as")){i=p_syntax_(il,b_fopen_i);}
				if(1<=p_ex(il,"for output as")){i=p_syntax_(il,b_fopen_o);}

				p1=0;l=-1;
				for(j=-1+strlen(r_s[9]);j>=0;--j)
				{
					++l;p1+=(-48+r_s[9][j])*pow(10,l);
				}

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				k=0;
				for(j=0;j<strlen(r_s[2]);++j)
				{
					if
					(
						r_s[2][j]=='#'||
						r_s[2][j]=='%'||
						r_s[2][j]=='&'||
						r_s[2][j]=='$'

					){}else{tvarnl[k]=r_s[2][j];++k;}

				}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					for(j=0;j<fni;++j)
					{
						if (fvarc[j]==p1)
						{
							if (1==p_comp(fvarn[j],cvarv[tarv[rvi][0]])){rvi=j;break;}else{

								printf("reference err...\n",fvarn[j]);
								return(0);
							}
						}
					}
					if(j!=fni)
					{
						if(1<=p_ex(il,"for input as")){fp=fopen(fvarn[rvi],"r");}
						if(1<=p_ex(il,"for output as")){fp=fopen(fvarn[rvi],"wb");}

						if(fp==NULL)
						{printf("reference err...\n",fvarn[rvi]);return(0);}else{fclose(fp);}

						if(1<=p_ex(il,"for input as")){fvars[rvi]=fopen(fvarn[rvi],"r");}
						if(1<=p_ex(il,"for output as")){fvars[rvi]=fopen(fvarn[rvi],"wb");}

						fvarp[rvi]=0;
						fvarc[rvi]=p1;

					}else{
						k=0;
						for(j=0;j<strlen(cvarv[tarv[rvi][0]]);++j)
						{
							if
							(
								cvarv[tarv[rvi][0]][j]=='\''||
								cvarv[tarv[rvi][0]][j]=='\"'
							){}else{fvarn[fni][k]=cvarv[tarv[rvi][0]][j];++k;}
						}

						if(1<=p_ex(il,"for input as")){fp=fopen(fvarn[fni],"r");}
						if(1<=p_ex(il,"for output as")){fp=fopen(fvarn[fni],"wb");}

						if(fp==NULL)
						{printf("reference err...\n",fvarn[fni]);return(0);}else{fclose(fp);}

						if(1<=p_ex(il,"for input as")){fvars[fni]=fopen(fvarn[fni],"r");}
						if(1<=p_ex(il,"for output as")){fvars[fni]=fopen(fvarn[fni],"wb");}
						
						fvarp[fni]=0;
						fvarc[fni]=p1;
						++fni;
					}

				}else{printf("reference err...\n",tvarnl);return(0);}

				return(0);
			}else{
//===============================
			if(1<=p_ex(il,"input #"))
			{
				i=p_syntax_(il,b_finput);

				p1=0;l=-1;
				for(j=-1+strlen(r_s[3]);j>=0;--j)
				{
					++l;p1+=(-48+r_s[3][j])*pow(10,l);
				}

				for(j=0;j<fni;++j)
				{
					if(p1==fvarc[j]){rvi=j;break;}
				}
				if(j==fni){printf("reference err...%d\n",p1);return(0);}

				if(fvarp[rvi]!=-1)
				{
					fseek(fvars[rvi],fvarp[rvi],SEEK_SET);
					for(j=0;j<plinel;++j){svarnl[j]='\0';}k=0;
					fbyte=getc(fvars[rvi]);
					while(!feof(fvars[rvi])&&fbyte!=13&&fbyte!=10){svarnl[k]=fbyte;++k;fbyte=getc(fvars[rvi]);}
					while(!feof(fvars[rvi])&&(fbyte==13||fbyte==10)){fbyte=getc(fvars[rvi]);}
					if(!feof(fvars[rvi])){fvarp[rvi]=ftell(fvars[rvi])-1;}else{fvarp[rvi]=-1;}

				}else{
					for(j=0;j<plinel;++j){svarnl[j]='\0';}
				}

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				k=0;
				for(j=0;j<strlen(r_s[5]);++j)
				{
					if
					(
						r_s[5][j]=='#'||
						r_s[5][j]=='%'||
						r_s[5][j]=='&'||
						r_s[5][j]=='$'

					){}else{tvarnl[k]=r_s[5][j];++k;}
				}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					for(j=0;j<plinel;++j){cvarv[tarv[rvi][0]][j]='\0';}
					k=0;
					for(j=0;j<strlen(svarnl);++j)
					{cvarv[tarv[rvi][0]][k]=svarnl[j];++k;}

				}else{printf("reference err...%s\n",tvarnl);return(0);}

				return(0);
			}else{
//===============================
			if(1<=p_ex(il,"close #"))
			{
				i=p_syntax_(il,b_fclose);

				p1=0;l=-1;
				for(j=-1+strlen(r_s[3]);j>=0;--j)
				{
					++l;p1+=(-48+r_s[3][j])*pow(10,l);
				}

				for(j=0;j<fni;++j)
				{
					if(p1==fvarc[j]){rvi=j;break;}
				}
				if(j==fni){printf("reference err...%d\n",p1);return(0);}

				fclose(fvars[rvi]);

				fvars[rvi]=NULL;
				fvarc[rvi]=-1;
				fvarp[rvi]=-1;
				fvarn[rvi][0]='\0';
				
				return(0);

				}
				}
				}
				}
				}
				}
				}
				}
				}
				}
				}
		}

	}else{

//===================================
		
	p_syntax_(il,p_exp);

	if
	(
			r_s[2][0]=='='&&
			r_s[2][1]=='('&&
			(
				r_s[5][0]=='=' ||
				r_s[5][0]=='>' ||
				r_s[5][0]=='<'
			)
	)
	{

				i=p_syntax_(il,b_l_exp);

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					if (tarv[rvi][1]==2)
					{
						ciL=nvarv[tarv[rvi][0]][0];
						lcL=2;
					}else{
							if (tarv[rvi][1]==3)
							{
								clL=nvarv[tarv[rvi][0]][0]<<16;
								clL+=nvarv[tarv[rvi][0]][1];
								lcL=3;

							}else{
									if (tarv[rvi][1]==1)
									{
										k=0;
										for(j=0;j<strlen(cvarv[tarv[rvi][0]]);++j)
										{
											if
											(
												cvarv[tarv[rvi][0]][j]=='\''||
												cvarv[tarv[rvi][0]][j]=='"'
											)
											{}else{csL[k]=cvarv[tarv[rvi][0]][j];++k;}
										}for(j=k;j<plinel;++j){csL[k]='\0';++k;}
										lcL=1;
									}
							}
					}

				}else{printf("reference err...%s\n",tvarnl);}

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				for(j=0;j<-1+strlen(r_s[4]);++j){tvarnl[j]=r_s[4][j];}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					if (tarv[rvi][1]==2)
					{
						ciR=nvarv[tarv[rvi][0]][0];
						lcR=2;
					}else{
							if (tarv[rvi][1]==3)
							{
								clR=nvarv[tarv[rvi][0]][0]<<16;
								clR+=nvarv[tarv[rvi][0]][1];
								lcR=3;
							}else{
								if (tarv[rvi][1]==1)
								{
									k=0;
									for(j=0;j<strlen(cvarv[tarv[rvi][0]]);++j)
									{
										if
										(
											cvarv[tarv[rvi][0]][j]=='\''||
											cvarv[tarv[rvi][0]][j]=='"'
										)
										{}else{csR[k]=cvarv[tarv[rvi][0]][j];++k;}
									}for(j=k;j<plinel;++j){csR[k]='\0';++k;}
									lcR=1;
								}
							}
					}

				}else{printf("reference err...%s\n",tvarnl);}



				if (r_s[3][0]=='='&&r_s[3][1]=='\0')
				{
					if(lcL==1&&lcR==1){ll=p_ccomp(csL,csR,r_s[3][0],r_s[3][1]);}
					if(lcL==2&&lcR==2){if (ciL==ciR){ll=1;}else{ll=0;}}
					if(lcL==3&&lcR==3){if (clL==clR){ll=1;}else{ll=0;}}
				}

				if (r_s[3][0]=='<'&&r_s[3][1]=='>')
				{
					if(lcL==1&&lcR==1){ll=p_ccomp(csL,csR,r_s[3][0],r_s[3][1]);}
					if(lcL==2&&lcR==2){if (ciL!=ciR){ll=1;}else{ll=0;}}
					if(lcL==3&&lcR==3){if (clL!=clR){ll=1;}else{ll=0;}}
				}

				if(r_s[3][0]=='>'&&r_s[3][1]=='\0')
				{
					if(lcL==1&&lcR==1){ll=p_ccomp(csL,csR,r_s[3][0],r_s[3][1]);}
					if(lcL==2&&lcR==2){if (ciL>ciR){ll=1;}else{ll=0;}}
					if(lcL==3&&lcR==3){if (clL>clR){ll=1;}else{ll=0;}}
				}

				if (r_s[3][0]=='<'&&r_s[3][1]=='\0')
				{
					if(lcL==1&&lcR==1){ll=p_ccomp(csL,csR,r_s[3][0],r_s[3][1]);}
					if(lcL==2&&lcR==2){if (ciL<ciR){ll=1;}else{ll=0;}}
					if(lcL==3&&lcR==3){if (clL<clR){ll=1;}else{ll=0;}}
				}

				if (r_s[3][0]=='>'&&r_s[3][1]=='=')
				{
					if(lcL==1&&lcR==1){ll=p_ccomp(csL,csR,r_s[3][0],r_s[3][1]);}
					if(lcL==2&&lcR==2){if (ciL>=ciR){ll=1;}else{ll=0;}}
					if(lcL==3&&lcR==3){if (clL>=clR){ll=1;}else{ll=0;}}
				}

				if (r_s[3][0]=='<'&&r_s[3][1]=='=')
				{
					if(lcL==1&&lcR==1){ll=p_ccomp(csL,csR,r_s[3][0],r_s[3][1]);}
					if(lcL==2&&lcR==2){if (ciL<=ciR){ll=1;}else{ll=0;}}
					if(lcL==3&&lcR==3){if (clL<=clR){ll=1;}else{ll=0;}}
				}
			
//==============================

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				for(j=0;j<-1+strlen(r_s[8]);++j){tvarnl[j]=r_s[8][j];}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					if (tarv[rvi][1]==2)
					{
						ciL=nvarv[tarv[rvi][0]][0];
						lcL=2;
					}else{
							if (tarv[rvi][1]==3)
							{
								clL=nvarv[tarv[rvi][0]][0]<<16;
								clL+=nvarv[tarv[rvi][0]][1];
								lcL=3;

							}else{
									if (tarv[rvi][1]==1)
									{
										k=0;
										for(j=0;j<strlen(cvarv[tarv[rvi][0]]);++j)
										{
											if
											(
												cvarv[tarv[rvi][0]][j]=='\''||
												cvarv[tarv[rvi][0]][j]=='"'
											)
											{}else{csL[k]=cvarv[tarv[rvi][0]][j];++k;}

										}for(j=k;j<plinel;++j){csL[k]='\0';++k;}
										lcL=1;
									}
							}
					}

				}else{printf("reference err...%s\n",tvarnl);}

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				for(j=0;j<-1+strlen(r_s[10]);++j){tvarnl[j]=r_s[10][j];}
	
				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					if (tarv[rvi][1]==2)
					{
						ciR=nvarv[tarv[rvi][0]][0];
						lcR=2;
					}else{
							if (tarv[rvi][1]==3)
							{
								clR=nvarv[tarv[rvi][0]][0]<<16;
								clR+=nvarv[tarv[rvi][0]][1];
								lcR=3;
							}else{
									if (tarv[rvi][1]==1)
									{
										k=0;
										for(j=0;j<strlen(cvarv[tarv[rvi][0]]);++j)
										{
											if
											(
												cvarv[tarv[rvi][0]][j]=='\''||
												cvarv[tarv[rvi][0]][j]=='"'
											)
											{}else{csR[k]=cvarv[tarv[rvi][0]][j];++k;}
										}for(j=k;j<plinel;++j){csR[k]='\0';++k;}
										lcR=1;
									}
							}
					}

				}else{printf("reference err...%s\n",tvarnl);}



				if (r_s[9][0]=='='&&r_s[9][1]=='\0')
				{
					if(lcL==1&&lcR==1){lr=p_ccomp(csL,csR,r_s[9][0],r_s[9][1]);}
					if(lcL==2&&lcR==2){if (ciL==ciR){lr=1;}else{lr=0;}}
					if(lcL==3&&lcR==3){if (clL==clR){lr=1;}else{lr=0;}}
				}

				if (r_s[9][0]=='<'&&r_s[9][1]=='>')
				{
					if(lcL==1&&lcR==1){lr=p_ccomp(csL,csR,r_s[9][0],r_s[9][1]);}
					if(lcL==2&&lcR==2){if (ciL!=ciR){lr=1;}else{lr=0;}}
					if(lcL==3&&lcR==3){if (clL!=clR){lr=1;}else{lr=0;}}
				}

				if(r_s[9][0]=='>'&&r_s[9][1]=='\0')
				{
					if(lcL==1&&lcR==1){lr=p_ccomp(csL,csR,r_s[9][0],r_s[9][1]);}
					if(lcL==2&&lcR==2){if (ciL>ciR){lr=1;}else{lr=0;}}
					if(lcL==3&&lcR==3){if (clL>clR){lr=1;}else{lr=0;}}
				}

				if (r_s[9][0]=='<'&&r_s[9][1]=='\0')
				{
					if(lcL==1&&lcR==1){lr=p_ccomp(csL,csR,r_s[9][0],r_s[9][1]);}
					if(lcL==2&&lcR==2){if (ciL<ciR){lr=1;}else{lr=0;}}
					if(lcL==3&&lcR==3){if (clL<clR){lr=1;}else{lr=0;}}
				}

				if (r_s[9][0]=='>'&&r_s[9][1]=='=')
				{
					if(lcL==1&&lcR==1){lr=p_ccomp(csL,csR,r_s[9][0],r_s[9][1]);}
					if(lcL==2&&lcR==2){if (ciL>=ciR){lr=1;}else{lr=0;}}
					if(lcL==3&&lcR==3){if (clL>=clR){lr=1;}else{lr=0;}}
				}

				if (r_s[9][0]=='<'&&r_s[9][1]=='=')
				{
					if(lcL==1&&lcR==1){lr=p_ccomp(csL,csR,r_s[9][0],r_s[9][1]);}
					if(lcL==2&&lcR==2){if (ciL<=ciR){lr=1;}else{lr=0;}}
					if(lcL==3&&lcR==3){if (clL<=clR){lr=1;}else{lr=0;}}
				}

//==============================

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				for(j=0;j<-1+strlen(r_s[0]);++j){tvarnl[j]=r_s[0][j];}
	
				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					if (tarv[rvi][1]==2)
					{
						nvarv[tarv[rvi][0]][0]=0;

						if(1<=p_ex(r_s[6],"xor")){if(((ll^lr)&0x01)==1){nvarv[tarv[rvi][0]][0]=1;}}else{
						
							if(1<=p_ex(r_s[6],"and")){if(((ll&lr)&0x01)==1){nvarv[tarv[rvi][0]][0]=1;}}else{
							
								if(1<=p_ex(r_s[6],"or")) {if(((ll|lr)&0x01)==1){nvarv[tarv[rvi][0]][0]=1;}}}}
					
					}else{
							if (tarv[rvi][1]==3)
							{
								nvarv[tarv[rvi][0]][0]=0;
								nvarv[tarv[rvi][0]][1]=0;

								if(1<=p_ex(r_s[6],"xor")){if(((ll^lr)&0x01)==1){nvarv[tarv[rvi][0]][1]=1;}}else{
						
									if(1<=p_ex(r_s[6],"and")){if(((ll&lr)&0x01)==1){nvarv[tarv[rvi][0]][1]=1;}}else{
							
										if(1<=p_ex(r_s[6],"or")) {if(((ll|lr)&0x01)==1){nvarv[tarv[rvi][0]][1]=1;}}}}
							}
					}
					
				}else{printf("reference err...%s\n",tvarnl);}
		
	
		return(0);	
	}
	
//=================================== +EXP+
	
	for(j=0;j<mc;++j){if (1<=p_ex(il,kw[j])){break;}}if(j!=mc){return(0);}

	j=0;for(i=0;i<ili;++i){if ((il[i]=='=')||(il[i]=='*')||(il[i]=='/')||(il[i]=='+')||(il[i]=='-')){++j;}}
	i=p_syntax_(il,p_exp);

	if(r_s[1][0]=='$')
	{
			
		for(i=0;i<strlen(il);++i){if(il[i]==r_s[2][0]){break;}}
		for(j=0;j<plinel;++j){svarnl[j]='\0';}
		k=0;for(j=1+i;j<strlen(il);++j){svarnl[k]=il[j];++k;}
		
		rsvarnli=0;for(i=0;i<plinel;++i){rsvarnl[i]='\0';}
		for(j=0;j<strlen(svarnl);)
		{
			++j;
			if((svarnl[j]=='+')||(j==strlen(svarnl)))
			{
				if(svarnl[-1+j]=='$')
				{
					for(i=0;i<vnaml;++i){tvarnl[i]='\0';}
					k=-1-1+j;for(i=-1-1+j;i>=0&&(svarnl[i]!='+');--i){k=i;}
					l=0;for(i=k;i<=-1-1+j;++i){tvarnl[l]=svarnl[i];++l;}

					for(i=0;i<vi;++i){if (1==p_comp_(varnl[i],tvarnl)){rvi=i;break;}}

					if(i!=vi)
					{
						for(i=0;i<strlen(cvarv[tarv[rvi][0]]);++i)
						{
							if
							(
								cvarv[tarv[rvi][0]][i]=='\''||
								cvarv[tarv[rvi][0]][i]=='\"'
							)
							{}else{rsvarnl[rsvarnli]=cvarv[tarv[rvi][0]][i];++rsvarnli;}
						}
						++cpi;
					}else{printf("reference err...2%s\n",tvarnl);}
				}
				//printf("%s\n",rsvarnl);
			}
		}

		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		k=0;
		for(i=0;i<strlen(il);++i)
		{
			if
			(
				il[i]!='='&&
				il[i]!='$'
			){tvarnl[k]=il[i];++k;}else{break;}
		}

		for(j=0;j<vi;++j){if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}}

		if (j!=vi)
		{
			for(j=0;j<plinel;++j){cvarv[tarv[rvi][0]][j]='\0';}
			k=0;cvarv[tarv[rvi][0]][k]='\'';++k;
			for(j=0;j<strlen(rsvarnl);++j)
			{
				if
				(
					rsvarnl[j]=='\''||
					rsvarnl[j]=='\"'
				)
				{}else{cvarv[tarv[rvi][0]][k]=rsvarnl[j];++k;}

			}cvarv[tarv[rvi][0]][k]='\'';++k;

		}else{printf("reference err...%s\n",tvarnl);}
						
		opi=0;cpi=0;

	}else{

		opi=0;cpi=0;

		i=p_syntax_(il,p_exp);

		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		k=0;
		for(j=0;j<strlen(r_s[0]);++j){tvarnl[k]=r_s[0][j];++k;}
		
		for(j=0;j<vi;++j)
		{
			if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
		}
		if(j!=vi)
		{
			cp[cpi][3]=tarv[rvi][0];
			cp[cpi][4]=tarv[rvi][1];
			cp[cpi][2]=6;
			++cpi;

		}else{		
		
			if(cp[cpi][2]!=6)
			{
				printf("reference err %s...\n",tvarnl);
			}else{

			for(i=0;i<strlen(tvarnl);++j){varnl[vi][i]=tvarnl[i];}
	
			if(r_s[1][0]=='%')
			{
					nvarv[ni][0]=0;
					nvarv[ni][1]=0;
					tarv[vi][0]=ni;
					tarv[vi][1]=2;
					++ni;
					++vi;
			}
			if(r_s[1][0]=='&')
			{
					nvarv[ni][0]=((long)0&0xffff0000)>>16;
					nvarv[ni][1]=(long)0&0x0000ffff;
					tarv[vi][0]=ni;					
					tarv[vi][1]=3;					
					++ni;
					++vi;				
			}
			if(r_s[1][0]=='#')
			{

					dvarv[dni]=0;
					tarv[vi][0]=dni;					
					tarv[vi][1]=4;
					++dni;
					++vi;
			}
	
			for(k=0;k<vi;++k)
			{
				if (1==p_comp(varnl[k],tvarnl)){rvi=k;break;}
			}
			if(k!=vi){cp[cpi][3]=tarv[rvi][0];cp[cpi][4]=tarv[rvi][1];cp[cpi][2]=6;++cpi;}else{printf("reference err %s...\n",tvarnl);}
			}
		}

		for(i=0;i<strlen(il);++i){if(il[i]==r_s[2][0]){break;}}

		for(j=0;j<plinel;++j){svarnl[j]='\0';}
		k=0;for(j=1+i;j<strlen(il);++j){svarnl[k]=il[j];++k;}m=k;

		//printf("%s\n",svarnl);

		for(j=0;j<strlen(svarnl);)
		{
			cp[cpi][2]=-1;

			if(svarnl[j]=='^'){cp[cpi][2]=1;}
			if(svarnl[j]=='*'){cp[cpi][2]=2;}
			if(svarnl[j]=='/'){cp[cpi][2]=3;}
			if(svarnl[j]=='+'){cp[cpi][2]=4;}
			if(svarnl[j]=='-'){cp[cpi][2]=5;}
			if(svarnl[j]=='='){cp[cpi][2]=6;}

			if (cp[cpi][2]==-1){++j;continue;}

			if (cp[cpi][2]!=-1)
			{	
				if((svarnl[-1+j]>='0'&&svarnl[-1+j]<='9')||(svarnl[-1+j]=='.'))
				{
				l=-1;dvarv[dni]=0;m=-1;
				for(i=-1+j;i>=0&&((svarnl[i]>='0'&&svarnl[i]<='9')||(svarnl[i]=='.'));--i)
				{
					if(svarnl[i]!='.'){++l;dvarv[dni]+=(-48+svarnl[i])*pow(10,l);}else{m=l;}
				}

				//printf("%e\n",dvarv[dni]/pow(10,1+m));
				cp[cpi][1]=dvarv[dni];
				cp[cpi][3]=-1;
				cp[cpi][4]=2;
				++cpi;
                                cp[cpi][2]=3;
                                cp[cpi][1]=pow(10,1+m);
				cp[cpi][3]=-1;
				cp[cpi][4]=-1;
				++cpi;

				}else{
				
				for(i=0;i<vnaml;++i){tvarnl[i]='\0';}
				k=-1-1+j;
				for(i=-1-1+j;i>=0&&(svarnl[i]!='+'&&svarnl[i]!='-'&&svarnl[i]!='*'&&svarnl[i]!='/'&&svarnl[i]!='^');--i){k=i;}
				l=0;for(i=k;i<=-1-1+j;++i){tvarnl[l]=svarnl[i];++l;}

				for(i=0;i<vi;++i)
				{
					if (1==p_comp_(varnl[i],tvarnl)){rvi=i;break;}
				}
				if(i!=vi)
				{
					cp[cpi][3]=tarv[rvi][0];cp[cpi][4]=tarv[rvi][1];
					++cpi;
		
				}else{printf("reference err...%s\n",tvarnl);}				

				}
				++j;
				continue;
			}
			++j;

		}
			
		for(i=-1+strlen(svarnl);(svarnl[i]!='+'&&svarnl[i]!='-'&&svarnl[i]!='*'&&svarnl[i]!='/'&&svarnl[i]!='^');--i){}

                                if(svarnl[i]=='^'){cp[cpi][2]=1;}
                                if(svarnl[i]=='*'){cp[cpi][2]=2;}
                                if(svarnl[i]=='/'){cp[cpi][2]=3;}
                                if(svarnl[i]=='+'){cp[cpi][2]=4;}
				if(svarnl[i]=='-'){cp[cpi][2]=5;}
				if(svarnl[i]=='='){cp[cpi][2]=6;}
                                ++i;

				if((svarnl[i]>='0'&&svarnl[i]<='9')||(svarnl[i]=='.'))
				{
				l=-1;dvarv[dni]=0;m=-1;
				for(i=-1+strlen(svarnl);i>=0&&((svarnl[i]>='0'&&svarnl[i]<='9')||(svarnl[i]=='.'));--i)
				{
					if(svarnl[i]!='.'){++l;dvarv[dni]+=(-48+svarnl[i])*pow(10,l);}else{m=l;}
				}

				//printf("%e\n",dvarv[dni]/pow(10,1+m));
				cp[cpi][1]=dvarv[dni];
				cp[cpi][3]=-1;
				cp[cpi][4]=2;
				++cpi;
                                cp[cpi][2]=3;
                                cp[cpi][1]=pow(10,1+m);
				cp[cpi][3]=-1;
				cp[cpi][4]=-1;
				++cpi;

				}else{
				
				for(i=0;i<vnaml;++i){tvarnl[i]='\0';}
				k=-1-1+strlen(svarnl);
				for(i=-1-1+strlen(svarnl);i>=0&&(svarnl[i]!='+'&&svarnl[i]!='-'&&svarnl[i]!='*'&&svarnl[i]!='/'&&svarnl[i]!='^');--i){k=i;}
				l=0;for(i=k;i<=-1-1+strlen(svarnl);++i){tvarnl[l]=svarnl[i];++l;}

				for(i=0;i<vi;++i)
				{
					if (1==p_comp_(varnl[i],tvarnl)){rvi=i;break;}
				}
				if(i!=vi)
				{
			
					cp[cpi][3]=tarv[rvi][0];cp[cpi][4]=tarv[rvi][1];
					++cpi;
		
				}else{printf("reference err...%s\n",tvarnl);}

				}
                                
		//for(i=0;i<cpi;++i){printf("+++++++++++++++%d %d %d %d\n",cp[i][1],cp[i][2],cp[i][3],cp[i][4]);}

		for (i=0;i<cpi;++i)
		{
			if(cp[i][3]!=-1)
			{

				if(cp[i][4]==2)
				{
					opa[opi][0]=(double)nvarv[cp[i][3]][0];
					opa[opi][1]=cp[i][2];
					++opi;
				}else{
					if(cp[i][4]==3)
					{
						opa[opi][0]=(double)(nvarv[cp[i][3]][0]<<16);
						opa[opi][0]+=(double)nvarv[cp[i][3]][1];
						opa[opi][1]=cp[i][2];
						++opi;
					}else{
						if(cp[i][4]==4)
						{
							opa[opi][0]=dvarv[cp[i][3]];
							opa[opi][1]=cp[i][2];
							++opi;                                  
						}
					}
				}

			}else{
				if(cp[i+1][3]==-1&&cp[i+1][4]==-1)
				{
				opa[opi][0]=(double)cp[i][1]/(double)cp[i+1][1];
				opa[opi][1]=cp[i][2];
				++opi;++i;
				}else{
				opa[opi][0]=cp[i][1];
				opa[opi][1]=cp[i][2];
				++opi;
				}
			}

			//printf("%e\t%e\t\n",opa[opi-1][0],opa[opi-1][1]);
		}

		}
		
//===================================

		if(opi>0)
		{

			//for(i=0;i<opi;++i){printf("------------------%e %e\n",opa[i][0],opa[i][1]);}

			cmput();
			
			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			k=0;
			for(i=0;i<strlen(il);++i)
			{
				if
				(
					il[i]!='='&&
					il[i]!='%'&&
					il[i]!='&'&&
					il[i]!='#'&&
					il[i]!='$'

				){tvarnl[k]=il[i];++k;}else{break;}
			}
			
			for(j=0;j<vi;++j){if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}}

			if (j!=vi)
			{
				if(tarv[rvi][1]==2)
				{
					nvarv[tarv[rvi][0]][0]=opa[0][0];
				}else{
					if(tarv[rvi][1]==3)
					{
						nvarv[tarv[rvi][0]][0]=(((long)opa[0][0]&0xffff0000)>>16);
						nvarv[tarv[rvi][0]][1]=((long)opa[0][0]&0x0000ffff);
					}else{
						if(tarv[rvi][1]==4)
						{
							dvarv[tarv[rvi][0]]=opa[0][0];
						}
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}

			for(j=0;j<vnaml;++j){opa[j][0]=0;opa[j][1]=0;}
			opi=0;
		}
	}
	
}

//!!!

int	pif_(int start,int end)
{
	int			i,j,k,l,rvi,lr;

	char			il[plinel];int	ili=0;
	char			tvarnl[vnaml];

	int			lcL,lcR;
	long			cnL,cnR;
	
	double			fr;


	for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
	for(i=0;i<strlen(pf[start]);++i){il[ili]=pf[start][i];++ili;}

	j=0;
	for(i=0;i<ili-1;++i)
	{
		if
		(
			(il[0]=='i'&&il[1]=='f'&&il[i]=='#'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='%'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='&'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='$'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))
			||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='#'&&il[i+1]==')')||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='%'&&il[i+1]==')')||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='&'&&il[i+1]==')')||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='$'&&il[i+1]==')')
		)
		{++j;}
	}

	if(j==1)
	{
			i=p_syntax_(il,b_if_1);

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				if (tarv[rvi][1]==2||tarv[rvi][1]==4)
				{
					if (tarv[rvi][1]==2)
					{
						cnL=nvarv[tarv[rvi][0]][0];
						lcL=tarv[rvi][1];
					}else{
						cnL=(long)dvarv[tarv[rvi][0]];
						lcL=tarv[rvi][1];
					}
				}else{
					if (tarv[rvi][1]==3)
					{
						cnL=nvarv[tarv[rvi][0]][0]<<16;
						cnL+=nvarv[tarv[rvi][0]][1];
						lcL=tarv[rvi][1];
					}else{
						if (tarv[rvi][1]==1)
						{
							k=0;
							for(j=0;j<strlen(cvarv[tarv[rvi][0]]);++j)
							{
								if
								(
									cvarv[tarv[rvi][0]][j]=='\''||
									cvarv[tarv[rvi][0]][j]=='"'
								)
								{}else{csL[k]=cvarv[tarv[rvi][0]][j];++k;}
							}for(j=k;j<plinel;++j){csL[k]='\0';++k;}
							lcL=tarv[rvi][1];
						}
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}

			cnR=(long)p_val(r_s[4]);
			lcR=2;

	}else{
		if(j==2)
		{

			i=p_syntax_(il,b_if);

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				if (tarv[rvi][1]==2||tarv[rvi][1]==4)
				{
					if (tarv[rvi][1]==2)
					{
						cnL=nvarv[tarv[rvi][0]][0];
						lcL=tarv[rvi][1];
					}else{
						cnL=(long)dvarv[tarv[rvi][0]];
						lcL=tarv[rvi][1];
					}
				}else{
					if (tarv[rvi][1]==3)
					{
						cnL=nvarv[tarv[rvi][0]][0]<<16;
						cnL+=nvarv[tarv[rvi][0]][1];
						lcL=tarv[rvi][1];
					}else{
						if (tarv[rvi][1]==1)
						{
							k=0;
							for(j=0;j<strlen(cvarv[tarv[rvi][0]]);++j)
							{
								if
								(
									cvarv[tarv[rvi][0]][j]=='\''||
									cvarv[tarv[rvi][0]][j]=='"'
								)
								{}else{csL[k]=cvarv[tarv[rvi][0]][j];++k;}
							}for(j=k;j<plinel;++j){csL[k]='\0';++k;}
							lcL=tarv[rvi][1];
						}
					}
				}
			}else{printf("reference err...%s\n",tvarnl);}

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[4]);++j){tvarnl[j]=r_s[4][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				if (tarv[rvi][1]==2||tarv[rvi][1]==4)

				{
					if (tarv[rvi][1]==2)
					{
						cnR=nvarv[tarv[rvi][0]][0];
						lcR=tarv[rvi][1];
					}else{
						cnR=(long)dvarv[tarv[rvi][0]];
						lcR=tarv[rvi][1];
					}
				}else{
					if (tarv[rvi][1]==3)
					{
						cnR=nvarv[tarv[rvi][0]][0]<<16;
						cnR+=nvarv[tarv[rvi][0]][1];
						lcR=tarv[rvi][1];
					}else{
						if (tarv[rvi][1]==1)
						{
							k=0;
							for(j=0;j<strlen(cvarv[tarv[rvi][0]]);++j)
							{
								if
								(
									cvarv[tarv[rvi][0]][j]=='\''||
									cvarv[tarv[rvi][0]][j]=='"'
								)
								{}else{csR[k]=cvarv[tarv[rvi][0]][j];++k;}
							}for(j=k;j<plinel;++j){csR[k]='\0';++k;}
							lcR=tarv[rvi][1];
						}
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}

		}
	}

	lr=-1;
	if (r_s[3][0]=='='&&r_s[3][1]=='\0')
	{
		if(lcL==1&&lcR==1){lr=p_ccomp(csL,csR,r_s[3][0],r_s[3][1]);}
		if((lcL==2||lcL==4)&&(lcR==2||lcR==4)){if (cnL==cnR){lr=1;}else{lr=0;}}
		if(lcL==3&&lcR==3){if (cnL==cnR){lr=1;}else{lr=0;}}
	}

	if (r_s[3][0]=='<'&&r_s[3][1]=='>')
	{
		if(lcL==1&&lcR==1){lr=p_ccomp(csL,csR,r_s[3][0],r_s[3][1]);}
		if((lcL==2||lcL==4)&&(lcR==2||lcR==4)){if (cnL!=cnR){lr=1;}else{lr=0;}}
		if(lcL==3&&lcR==3){if (cnL!=cnR){lr=1;}else{lr=0;}}
	}

	if(r_s[3][0]=='>'&&r_s[3][1]=='\0')
	{
		if(lcL==1&&lcR==1){lr=p_ccomp(csL,csR,r_s[3][0],r_s[3][1]);}
		if((lcL==2||lcL==4)&&(lcR==2||lcR==4)){if (cnL>cnR){lr=1;}else{lr=0;}}
		if(lcL==3&&lcR==3){if (cnL>cnR){lr=1;}else{lr=0;}}
	}

	if (r_s[3][0]=='<'&&r_s[3][1]=='\0')
	{
		if(lcL==1&&lcR==1){lr=p_ccomp(csL,csR,r_s[3][0],r_s[3][1]);}
		if((lcL==2||lcL==4)&&(lcR==2||lcR==4)){if (cnL<cnR){lr=1;}else{lr=0;}}
		if(lcL==3&&lcR==3){if (cnL<cnR){lr=1;}else{lr=0;}}
	}

	if (r_s[3][0]=='>'&&r_s[3][1]=='=')
	{
		if(lcL==1&&lcR==1){lr=p_ccomp(csL,csR,r_s[3][0],r_s[3][1]);}
		if((lcL==2||lcL==4)&&(lcR==2||lcR==4)){if (cnL>=cnR){lr=1;}else{lr=0;}}
		if(lcL==3&&lcR==3){if (cnL>=cnR){lr=1;}else{lr=0;}}
	}

	if (r_s[3][0]=='<'&&r_s[3][1]=='=')
	{
		if(lcL==1&&lcR==1){lr=p_ccomp(csL,csR,r_s[3][0],r_s[3][1]);}
		if((lcL==2||lcL==4)&&(lcR==2||lcR==4)){if (cnL<=cnR){lr=1;}else{lr=0;}}
		if(lcL==3&&lcR==3){if (cnL<=cnR){lr=1;}else{lr=0;}}
	}

	//printf("%s %d %d %d %d %d %d %d\n",r_s[3],lcL,lcR,cnL,cnR,lr,start,end);
	if (lr==1){for (j=start+1;j<end;++j){exc(j);}}

	return(0);
}

//!!!

int pwhile_(int start,int end)
{
	int		i,j,k,l,rvi;

	char		il[plinel];int	ili=0;
	char		tvarnl[vnaml];

	int		ci;
	long		tvs[4];
	int		rv0,rvi0,rvt0;
	int		rv1,rvi1,rvt1;

	double		fr;


	for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
	for(i=0;i<strlen(pf[start]);++i){il[ili]=pf[start][i];++ili;}

	j=0;
	for(i=0;i<ili-1;++i)
	{
		if
		(
			(il[0]=='w'&&il[1]=='h'&&il[i]=='#'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))||
			(il[0]=='w'&&il[1]=='h'&&il[i]=='%'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))||
			(il[0]=='w'&&il[1]=='h'&&il[i]=='&'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))
			||
			(il[0]=='w'&&il[1]=='h'&&il[i]=='#'&&il[i+1]==')')||
			(il[0]=='w'&&il[1]=='h'&&il[i]=='%'&&il[i+1]==')')||
			(il[0]=='w'&&il[1]=='h'&&il[i]=='&'&&il[i+1]==')')
		)
		{++j;}
	}

	if(j==1)
	{
		i=p_syntax_(il,b_while);

		if (1<=p_ex(il,">="))
		{
			ci=3;
		}else{
			if (1<=p_ex(il,"<="))
			{
				ci=4;
			}else{
				if (1<=p_ex(il,"="))
				{
					ci=0;
				}else{
					if (1<=p_ex(il,"<>"))
					{
						ci=5;
					}else{
						if (1<=p_ex(il,">"))
						{
							ci=1;
						}else{
							if (1<=p_ex(il,"<"))
							{
								ci=2;
							}
						}
					}
				}
			}
		}

		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		for(j=0;j<-1+strlen(r_s[1]);++j){tvarnl[j]=r_s[1][j];}

		for(j=0;j<vi;++j)
		{
			if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
		}
		if(j!=vi)
		{
			rvt0=tarv[rvi][1];
			rvi0=tarv[rvi][0];

			if(tarv[rvi][1]==2)
			{
				tvs[0]=nvarv[tarv[rvi][0]][0];
				tvs[1]=2;
			}else{
				if(tarv[rvi][1]==3)
				{
					tvs[0]=nvarv[tarv[rvi][0]][0]<<16;
					tvs[0]+=nvarv[tarv[rvi][0]][1];
					tvs[1]=3;
				}
			}

		}else{printf("reference err...%s\n",tvarnl);}

		tvs[2]=0;l=-1;
		for(j=-1+strlen(r_s[3]);j>=0;--j)
		{
			++l;tvs[2]+=(-48+r_s[3][j])*pow(10,l);

		}
		tvs[3]=-1;

		rvt1=-1;
		rvi1=-1;

	}else{
		if(j==2)
		{

			i=p_syntax_(il,b_while_1);

			if (1<=p_ex(il,">="))
			{
				ci=3;
			}else{
				if (1<=p_ex(il,"<="))
				{
					ci=4;
				}else{
					if (1<=p_ex(il,"="))
					{
						ci=0;
					}else{
						if (1<=p_ex(il,"<>"))
						{
							ci=5;
						}else{
							if (1<=p_ex(il,">"))
							{
								ci=1;
							}else{
								if (1<=p_ex(il,"<"))
								{
									ci=2;
								}
							}
						}
					}
				}
			}

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[1]);++j){tvarnl[j]=r_s[1][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				rvt0=tarv[rvi][1];
				rvi0=tarv[rvi][0];

				if(tarv[rvi][1]==2)
				{
					tvs[0]=nvarv[tarv[rvi][0]][0];
					tvs[1]=2;
				}else{
					if(tarv[rvi][1]==3)
					{
						tvs[0]=nvarv[tarv[rvi][0]][0]<<16;
						tvs[0]+=nvarv[tarv[rvi][0]][1];
						tvs[1]=3;
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[3]);++j){tvarnl[j]=r_s[3][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				rvt1=tarv[rvi][1];
				rvi1=tarv[rvi][0];

				if(tarv[rvi][1]==2)
				{
					tvs[2]=nvarv[tarv[rvi][0]][0];
					tvs[3]=2;
				}else{
						if(tarv[rvi][2]==3)
						{
							tvs[2]=nvarv[tarv[rvi][0]][0]<<16;
							tvs[2]+=nvarv[tarv[rvi][0]][1];
							tvs[3]=3;
						}
				}

			}else{printf("reference err...%s\n",tvarnl);}

		}else{return(0);}
	}
	//printf("%d %d %d %d %d %d %d\n",ci,tvs[0],tvs[1],tvs[2],tvs[3],rvi0,rvi1);

	if (ci==0)
	{
		while (tvs[1]==tvs[2])
		{
			for (j=start+1;j<end;++j){exc(j);}
			if(rvt1==2)
			{
				tvs[1]=nvarv[rvi1][0];
			}else{
					if(rvt1==3)
					{
						tvs[1]=nvarv[rvi1][0]<<16;
						tvs[1]+=nvarv[rvi1][1];
					}
			}
			if(rvt0==2)
			{
				tvs[1]=nvarv[rvi0][0];
			}else{
					if(rvt0==3)
					{
						tvs[1]=nvarv[rvi0][0]<<16;
						tvs[1]+=nvarv[rvi0][1];
					}
			}
		}
	}

	if (ci==5)
	{
		while (tvs[0]!=tvs[2])
		{
			for (j=start+1;j<end;++j){exc(j);}
			if(rvt0==2)
			{
				tvs[0]=nvarv[rvi0][0];
			}else{
					if(rvt0==3)
					{
						tvs[0]=nvarv[rvi0][0]<<16;
						tvs[0]+=nvarv[rvi0][1];
					}
			}
			if(rvt1==2)
			{
				tvs[2]=nvarv[rvi1][0];
			}else{
					if(rvt0==3)
					{
						tvs[2]=nvarv[rvi1][0]<<16;
						tvs[2]+=nvarv[rvi1][1];
					}
			}
		}
	}

	if (ci==1)
	{
		while (tvs[0]>tvs[2])
		{
			for (j=start+1;j<end;++j){exc(j);}
			if(rvt0==2)
			{
				tvs[0]=nvarv[rvi0][0];
			}else{
					if(rvt0==3)
					{
						tvs[0]=nvarv[rvi0][0]<<16;
						tvs[0]+=nvarv[rvi0][1];
					}
			}
			if(rvt1==2)
			{
				tvs[2]=nvarv[rvi1][0];
			}else{
					if(rvt0==3)
					{
						tvs[2]=nvarv[rvi1][0]<<16;
						tvs[2]+=nvarv[rvi1][1];
					}
			}
		}
	}

	if (ci==2)
	{
		while (tvs[0]<tvs[2])
		{
			for (j=start+1;j<end;++j){exc(j);}
			if(rvt0==2)
			{
				tvs[0]=nvarv[rvi0][0];
			}else{
					if(rvt0==3)
					{
						tvs[0]=nvarv[rvi0][0]<<16;
						tvs[0]+=nvarv[rvi0][1];
					}
			}
			if(rvt1==2)
			{
				tvs[2]=nvarv[rvi1][0];
			}else{
					if(rvt0==3)
					{
						tvs[2]=nvarv[rvi1][0]<<16;
						tvs[2]+=nvarv[rvi1][1];
					}
			}
		}
	}

	if (ci==3)
	{
		while (tvs[0]>=tvs[2])
		{
			for (j=start+1;j<end;++j){exc(j);}
			if(rvt0==2)
			{
				tvs[0]=nvarv[rvi0][0];
			}else{
					if(rvt0==3)
					{
						tvs[0]=nvarv[rvi0][0]<<16;
						tvs[0]+=nvarv[rvi0][1];
					}
			}
			if(rvt1==2)
			{
				tvs[2]=nvarv[rvi1][0];
			}else{
					if(rvt0==3)
					{
						tvs[2]=nvarv[rvi1][0]<<16;
						tvs[2]+=nvarv[rvi1][1];
					}
			}
		}

	}

	if (ci==4)
	{
		while (tvs[0]<=tvs[2])
		{
			for (j=start+1;j<end;++j){exc(j);}

			if(rvt0==2)
			{
				tvs[0]=nvarv[rvi0][0];
			}else{
					if(rvt0==3)
					{
						tvs[0]=nvarv[rvi0][0]<<16;
						tvs[0]+=nvarv[rvi0][1];
					}
			}
			if(rvt1==2)
			{
				tvs[2]=nvarv[rvi1][0];
			}else{
					if(rvt0==3)
					{
						tvs[2]=nvarv[rvi1][0]<<16;
						tvs[2]+=nvarv[rvi1][1];
					}
			}
		}
	}
	return(0);
}

//!!!

int pfor_(int start,int end)
{
	int		i,j,k,l,rvi;

	int		rv0,rvi0,rvt0;
	long		tvs[4];

	char		il[plinel];int	ili=0;
	char		tvarnl[vnaml];
	

	for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
	for(i=0;i<strlen(pf[start]);++i){il[ili]=pf[start][i];++ili;}

	j=0;
	for(i=0;i<ili;++i)
	{
		if
		(
			(il[0]=='f'&&il[1]=='o'&&il[i]=='#'&&il[i+1]=='=')||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='%'&&il[i+1]=='=')||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='&'&&il[i+1]=='=')
			||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='#'&&il[i+1]==' ')||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='%'&&il[i+1]==' ')||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='&'&&il[i+1]==' ')
			||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='#'&&il[i+1]=='\0')||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='%'&&il[i+1]=='\0')||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='&'&&il[i+1]=='\0')
		)
		{++j;}
	}

	if(j==1)
	{

		i=p_syntax_(il,b_for);

		tvs[0]=0;l=-1;
		for(j=-1+strlen(r_s[4]);j>=0;--j)
		{
			++l;tvs[0]+=(-48+r_s[4][j])*pow(10,l);
		}

		tvs[1]=0;l=-1;
		for(j=-1+strlen(r_s[8]);j>=0;--j)
		{
			++l;tvs[1]+=(-48+r_s[8][j])*pow(10,l);
		}

		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

		for(j=0;j<vi;++j)
		{
			if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
		}
		if(j!=vi)
		{
			if (tarv[rvi][1]==2||tarv[rvi][1]==3)
			{
				rvi0=tarv[rvi][0];
				if (tarv[rvi][1]==2)
				{
					rv0=nri[inri][0];
					rvt0=2;
				}
				if(tarv[rvi][1]==3)
				{
					rv0=(nri[inri][0]&0xffff0000)>>16;
					rv0+=(nri[inri][0]&0x00ffff)<<0;
					rvt0=3;
				}
			}

		}else{printf("reference err...%s\n",tvarnl);}
	
		for (i=tvs[0];i<=tvs[1];++i)
		{
			for(j=start+1;j<end;++j)
			{
				if(rvt0==2)
				{
					nvarv[rvi0][0]=tvs[0];
				}else{
						if(rvt0==3)
						{
							nvarv[rvi0][0]=((long)tvs[0]&0xffff0000)>>16;
							nvarv[rvi0][1]=(long)tvs[0]&0x0000ffff;
						}
				}
				//printf("%d %d %d %d\n",tvs[0],tvs[1],tvs[2],tvs[3]);
				exc(j);
			}	
			++tvs[0];
		}

		return(0);

	}

	if(j==2)
	{

		j=0;
		for(i=0;i<ili;++i)
		{
			if
			(
				(il[0]=='f'&&il[1]=='o'&&(il[i]>='0'&&il[i]<='9')&&il[i+1]==' ')||
				(il[0]=='f'&&il[1]=='o'&&(il[i]>='0'&&il[i]<='9')&&il[i+1]==' ')||
				(il[0]=='f'&&il[1]=='o'&&(il[i]>='0'&&il[i]<='9')&&il[i+1]==' ')
			){j=2;break;}

			if
			(
				(il[0]=='f'&&il[1]=='o'&&(il[i]>='0'&&il[i]<='9')&&il[i+1]=='\0')||
				(il[0]=='f'&&il[1]=='o'&&(il[i]>='0'&&il[i]<='9')&&il[i+1]=='\0')||
				(il[0]=='f'&&il[1]=='o'&&(il[i]>='0'&&il[i]<='9')&&il[i+1]=='\0')
			){j=1;break;}
		}

		if(j==1)
		{
			i=p_syntax_(il,b_for_1);

			tvs[1]=0;l=-1;
			for(j=-1+strlen(r_s[8]);j>=0;--j)
			{
				++l;tvs[1]+=(-48+r_s[8][j])*pow(10,l);
			}

			tvs[0]=0;
			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[4]);++j){tvarnl[j]=r_s[4][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				if (tarv[rvi][1]==2||tarv[rvi][1]==3)
				{
					if (tarv[rvi][1]==2)
					{
						tvs[0]=nvarv[tarv[rvi][0]][0];
					}
					if(tarv[rvi][1]==3)
					{
						tvs[0]=nvarv[tarv[rvi][0]][0]<<16;
						tvs[0]+=nvarv[tarv[rvi][0]][1];
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				if (tarv[rvi][1]==2||tarv[rvi][1]==3)
				{
					rvi0=tarv[rvi][0];
					if (tarv[rvi][1]==2)
					{
						nvarv[tarv[rvi][0]][0]=tvs[0];
						rv0=tvs[0];
						rvt0=2;
					}
					if(tarv[rvi][1]==3)
					{
						nvarv[tarv[rvi][0]][0]=((long)tvs[0]&0xffff0000)>>16;
						nvarv[tarv[rvi][0]][1]=(long)tvs[0]&0x0000ffff;
						rv0=tvs[0];
						rvt0=3;
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}

			for (i=tvs[0];i<=tvs[1];++i)
			{
				for(j=start+1;j<end;++j)
				{
					if(rvt0==2)
					{
						nvarv[rvi0][0]=tvs[0];
					}else{
							if(rvt0==3)
							{
								nvarv[rvi0][0]=((long)tvs[0]&0xffff0000)>>16;
								nvarv[rvi0][1]=(long)tvs[0]&0x0000ffff;
							}
					}
					//printf("%d %d %d %d\n",tvs[0],tvs[1],tvs[2],tvs[3]);
					exc(j);
				}	
				++tvs[0];
			}

			return(0);

		}else{

				i=p_syntax_(il,b_for_3);

				tvs[0]=0;l=-1;
				for(j=-1+strlen(r_s[4]);j>=0;--j)
				{
					++l;tvs[0]+=(-48+r_s[4][j])*pow(10,l);
				}

				tvs[1]=0;
				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				for(j=0;j<-1+strlen(r_s[8]);++j){tvarnl[j]=r_s[8][j];}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					if (tarv[rvi][1]==2||tarv[rvi][1]==3)
					{
						if (tarv[rvi][1]==2)
						{
							tvs[1]=nvarv[tarv[rvi][0]][0];
						}
						if(tarv[rvi][1]==3)
						{
							tvs[1]=nvarv[tarv[rvi][0]][0]<<16;
							tvs[1]+=nvarv[tarv[rvi][0]][1];
						}
					}

				}else{printf("reference err...%s\n",tvarnl);}

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					if (tarv[rvi][1]==2||tarv[rvi][1]==3)
					{
						rvi0=tarv[rvi][0];
						if (tarv[rvi][1]==2)
						{
							nvarv[tarv[rvi][0]][0]=tvs[0];
							rv0=tvs[0];
							rvt0=2;
						}
						if(tarv[rvi][1]==3)
						{
							nvarv[tarv[rvi][0]][0]=((long)tvs[0]&0xffff0000)>>16;
							nvarv[tarv[rvi][0]][1]=(long)tvs[0]&0x0000ffff;
							rv0=tvs[0];
							rvt0=3;
						}
					}

				}else{printf("reference err...%s\n",tvarnl);}

				for (i=tvs[0];i<=tvs[1];++i)
				{
					for(j=start+1;j<end;++j)
					{
						if(rvt0==2)
						{
							nvarv[rvi0][0]=tvs[0];
						}else{
								if(rvt0==3)
								{
									nvarv[rvi0][0]=((long)tvs[0]&0xffff0000)>>16;
									nvarv[rvi0][1]=(long)tvs[0]&0x0000ffff;
								}
						}
						//printf("%d %d %d %d\n",tvs[0],tvs[1],tvs[2],tvs[3]);
						exc(j);
					}	
					++tvs[0];
				}

				return(0);
		}
	}

	if(j==3)
	{

		i=p_syntax_(il,b_for_2);

		tvs[0];
		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		for(j=0;j<-1+strlen(r_s[4]);++j){tvarnl[j]=r_s[4][j];}

		for(j=0;j<vi;++j)
		{
			if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
		}
		if(j!=vi)
		{
			if (tarv[rvi][1]==2||tarv[rvi][1]==3)
			{
				if (tarv[rvi][1]==2)
				{
					tvs[0]=nvarv[tarv[rvi][0]][0];
				}
				if(tarv[rvi][1]==3)
				{
					tvs[0]=nvarv[tarv[rvi][0]][0]<<16;
					tvs[0]+=nvarv[tarv[rvi][0]][1];
				}
			}

		}else{printf("reference err...%s\n",tvarnl);}

		tvs[1]=0;
		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		for(j=0;j<-1+strlen(r_s[8]);++j){tvarnl[j]=r_s[8][j];}

		for(j=0;j<vi;++j)
		{
			if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
		}
		if(j!=vi)
		{
			if (tarv[rvi][1]==2||tarv[rvi][1]==3)
			{
				if (tarv[rvi][1]==2)
				{
					tvs[1]=nvarv[tarv[rvi][0]][0];
				}
				if(tarv[rvi][1]==3)
				{
					tvs[1]=nvarv[tarv[rvi][0]][0]<<16;
					tvs[1]+=nvarv[tarv[rvi][0]][1];
				}
			}

		}else{printf("reference err...%s\n",tvarnl);}

		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

		for(j=0;j<vi;++j)
		{
			if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
		}
		if(j!=vi)
		{
			if (tarv[rvi][1]==2||tarv[rvi][1]==3)
			{
				rvi0=tarv[rvi][0];
				if (tarv[rvi][1]==2)
				{
					nvarv[tarv[rvi][0]][0]=tvs[0];
					rv0=tvs[0];
					rvt0=2;
				}
				if(tarv[rvi][1]==3)
				{
					nvarv[tarv[rvi][0]][0]=((long)tvs[0]&0xffff0000)>>16;
					nvarv[tarv[rvi][0]][1]=(long)tvs[0]&0x0000ffff;
					rv0=tvs[0];
					rvt0=3;
				}
			}

		}else{printf("reference err...%s\n",tvarnl);}
	
		for (i=tvs[0];i<=tvs[1];++i)
		{
			for(j=start+1;j<end;++j)
			{
				if(rvt0==2)
				{
					nvarv[rvi0][0]=tvs[0];
				}else{
						if(rvt0==3)
						{
							nvarv[rvi0][0]=((long)tvs[0]&0xffff0000)>>16;
							nvarv[rvi0][1]=(long)tvs[0]&0x0000ffff;
						}
				}
				//printf("%d %d %d %d\n",tvs[0],tvs[1],tvs[2],tvs[3]);
				exc(j);
			}	
			++tvs[0];
		}

		return(0);

	}

}

//!!!

int p_while_(int start,int end)
{

	int			i,j,k,l,rvi;

	char			il[plinel];int	ili=0;
	char			tvarnl[vnaml];

	double			fr;

	for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
	for(i=0;i<strlen(pf[start]);++i){il[ili]=pf[start][i];++ili;}

	nri[inri][3]=start;
	nri[inri][4]=end;

	j=0;
	for(i=0;i<ili-1;++i)
	{
		if
		(
			(il[0]=='w'&&il[1]=='h'&&il[i]=='#'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))||
			(il[0]=='w'&&il[1]=='h'&&il[i]=='%'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))||
			(il[0]=='w'&&il[1]=='h'&&il[i]=='&'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))
			||
			(il[0]=='w'&&il[1]=='h'&&il[i]=='#'&&il[i+1]==')')||
			(il[0]=='w'&&il[1]=='h'&&il[i]=='%'&&il[i+1]==')')||
			(il[0]=='w'&&il[1]=='h'&&il[i]=='&'&&il[i+1]==')')
		)
		{++j;}
	}

	if(j==1)
	{
		i=p_syntax_(il,b_while);

		if (1<=p_ex(il,">="))
		{
			nri[inri][2]=3;
		}else{
			if (1<=p_ex(il,"<="))
			{
				nri[inri][2]=4;
			}else{
				if (1<=p_ex(il,"="))
				{
					nri[inri][2]=0;
				}else{
					if (1<=p_ex(il,"<>"))
					{
						nri[inri][2]=5;
					}else{
						if (1<=p_ex(il,">"))
						{
							nri[inri][2]=1;
						}else{
							if (1<=p_ex(il,"<"))
							{
								nri[inri][2]=2;
							}
						}
					}
				}
			}
		}

		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		for(j=0;j<-1+strlen(r_s[1]);++j){tvarnl[j]=r_s[1][j];}

		for(j=0;j<vi;++j)
		{
			if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
		}
		if(j!=vi)
		{
			nri[inri][6]=tarv[rvi][1];
			nri[inri][5]=tarv[rvi][0];

			if(tarv[rvi][1]==2)
			{
				nri[inri][0]=nvarv[tarv[rvi][0]][0];
			}else{
				if(tarv[rvi][1]==3)
				{
					nri[inri][0]=nvarv[tarv[rvi][0]][0]<<16;
					nri[inri][0]+=nvarv[tarv[rvi][0]][1];
				}
			}

		}else{printf("reference err...%s\n",tvarnl);}

		nri[inri][1]=0;l=-1;
		for(j=-1+strlen(r_s[3]);j>=0;--j)
		{
			++l;nri[inri][1]+=(-48+r_s[3][j])*pow(10,l);
		}
		nri[inri][9]=15;
		++inri;
	}else{
		if(j==2)
		{

			i=p_syntax_(il,b_while_1);

			if (1<=p_ex(il,">="))
			{
				nri[inri][2]=3;
			}else{
				if (1<=p_ex(il,"<="))
				{
					nri[inri][2]=4;
				}else{
					if (1<=p_ex(il,"="))
					{
						nri[inri][2]=0;
					}else{
						if (1<=p_ex(il,"<>"))
						{
							nri[inri][2]=5;
						}else{
							if (1<=p_ex(il,">"))
							{
								nri[inri][2]=1;
							}else{
								if (1<=p_ex(il,"<"))
								{
									nri[inri][2]=2;
								}
							}
						}
					}
				}
			}

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[1]);++j){tvarnl[j]=r_s[1][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				nri[inri][6]=tarv[rvi][1];
				nri[inri][5]=tarv[rvi][0];

				if(tarv[rvi][1]==2)
				{
					nri[inri][0]=nvarv[tarv[rvi][0]][0];
				}else{
					if(tarv[rvi][1]==3)
					{
						nri[inri][0]=nvarv[tarv[rvi][0]][0]<<16;
						nri[inri][0]+=nvarv[tarv[rvi][0]][1];
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[3]);++j){tvarnl[j]=r_s[3][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{

				nri[inri][8]=tarv[rvi][1];
				nri[inri][7]=tarv[rvi][0];

				if(tarv[rvi][1]==2)
				{
					nri[inri][1]=nvarv[tarv[rvi][0]][0];
				}else{
					if(tarv[rvi][1]==3)
					{
						nri[inri][1]=nvarv[tarv[rvi][0]][0]<<16;
						nri[inri][1]+=nvarv[tarv[rvi][0]][1];
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}
			nri[inri][9]=15;
			++inri;

		}else{return(0);}
	}
	return(0);

}

//!!!

int	p_for_(int start,int end)
{
	int			i,j,k,l,rvi;

	char			il[plinel];int	ili=0;
	char			tvarnl[vnaml];
	
	for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
	for(i=0;i<strlen(pf[start]);++i){il[ili]=pf[start][i];++ili;}

	j=0;
	for(i=0;i<ili;++i)
	{
		if
		(
			(il[0]=='f'&&il[1]=='o'&&il[i]=='#'&&il[i+1]=='=')||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='%'&&il[i+1]=='=')||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='&'&&il[i+1]=='=')
			||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='#'&&il[i+1]==' ')||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='%'&&il[i+1]==' ')||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='&'&&il[i+1]==' ')
			||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='#'&&il[i+1]=='\0')||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='%'&&il[i+1]=='\0')||
			(il[0]=='f'&&il[1]=='o'&&il[i]=='&'&&il[i+1]=='\0')
		)
		{++j;}
	}

	if(j==1)
	{

		nri[inri][3]=start;
		nri[inri][4]=end;

		i=p_syntax_(il,b_for);

		nri[inri][0]=0;l=-1;
		for(j=-1+strlen(r_s[4]);j>=0;--j)
		{
			++l;nri[inri][0]+=(-48+r_s[4][j])*pow(10,l);
		}
		cv[cvi]=nri[inri][0];
		iv[cvi][0]=-1;
		iv[cvi][1]=-1;

		nri[inri][1]=0;l=-1;
		for(j=-1+strlen(r_s[8]);j>=0;--j)
		{
			++l;nri[inri][1]+=(-48+r_s[8][j])*pow(10,l);
		}
		iv[cvi][2]=-1;
		iv[cvi][3]=-1;
		++cvi;

		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

		for(j=0;j<vi;++j)
		{
			if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
		}
		if(j!=vi)
		{
			if (tarv[rvi][1]==2||tarv[rvi][1]==3)
			{
				if (tarv[rvi][1]==2)
				{
					nvarv[tarv[rvi][0]][0]=nri[inri][0];
					nri[inri][6]=2;
				}
				if(tarv[rvi][1]==3)
				{
					nvarv[tarv[rvi][0]][0]=(nri[inri][0]&0xffff0000)>>16;
					nvarv[tarv[rvi][0]][1]=(nri[inri][0]&0x0000ffff)<<0;
					nri[inri][6]=3;
				}
			}

		}else{printf("reference err...%s\n",tvarnl);}

		nri[inri][2]=4;
		nri[inri][5]=tarv[rvi][0];
		nri[inri][9]=12;
		++inri;
	
		return(0);
	}

	if(j==2)
	{

		j=0;
		for(i=0;i<ili;++i)
		{
			if
			(
				(il[0]=='f'&&il[1]=='o'&&(il[i]>='0'&&il[i]<='9')&&il[i+1]==' ')||
				(il[0]=='f'&&il[1]=='o'&&(il[i]>='0'&&il[i]<='9')&&il[i+1]==' ')||
				(il[0]=='f'&&il[1]=='o'&&(il[i]>='0'&&il[i]<='9')&&il[i+1]==' ')
			){j=2;break;}

			if
			(
				(il[0]=='f'&&il[1]=='o'&&(il[i]>='0'&&il[i]<='9')&&il[i+1]=='\0')||
				(il[0]=='f'&&il[1]=='o'&&(il[i]>='0'&&il[i]<='9')&&il[i+1]=='\0')||
				(il[0]=='f'&&il[1]=='o'&&(il[i]>='0'&&il[i]<='9')&&il[i+1]=='\0')
			){j=1;break;}
		}

		if(j==1)
		{

			nri[inri][3]=start;
			nri[inri][4]=end;

			i=p_syntax_(il,b_for_1);

			nri[inri][1]=0;l=-1;
			for(j=-1+strlen(r_s[8]);j>=0;--j)
			{
				++l;nri[inri][1]+=(-48+r_s[8][j])*pow(10,l);
			}
			iv[cvi][2]=-1;
			iv[cvi][3]=-1;

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[4]);++j){tvarnl[j]=r_s[4][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				if (tarv[rvi][1]==2||tarv[rvi][1]==3)
				{
					if (tarv[rvi][1]==2)
					{
						nri[inri][0]=nvarv[tarv[rvi][0]][0];
						nri[inri][6]=2;
						cv[cvi]=nri[inri][0];
						iv[cvi][0]=tarv[rvi][0];
						iv[cvi][1]=tarv[rvi][1];
						++cvi;
					}
					if(tarv[rvi][1]==3)
					{
						nri[inri][0]=nvarv[tarv[rvi][0]][0]<<16;
						nri[inri][0]+=nvarv[tarv[rvi][0]][1];
						nri[inri][6]=3;
						cv[cvi]=nri[inri][0];
						iv[cvi][0]=tarv[rvi][0];
						iv[cvi][1]=tarv[rvi][1];
						++cvi;
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				if (tarv[rvi][1]==2||tarv[rvi][1]==3)
				{
					if (tarv[rvi][1]==2)
					{
						nvarv[tarv[rvi][0]][0]=nri[inri][0];
						nri[inri][6]=2;
					}
					if(tarv[rvi][1]==3)
					{
						nvarv[tarv[rvi][0]][0]=(nri[inri][0]&0xffff0000)>>16;
						nvarv[tarv[rvi][0]][1]=(nri[inri][0]&0x0000ffff)<<0;
						nri[inri][6]=3;
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}

			nri[inri][2]=4;
			nri[inri][5]=tarv[rvi][0];
			nri[inri][9]=12;
			++inri;
	
			return(0);

		}else{

				nri[inri][3]=start;
				nri[inri][4]=end;

				i=p_syntax_(il,b_for_3);

				nri[inri][0]=0;l=-1;
				for(j=-1+strlen(r_s[4]);j>=0;--j)
				{
					++l;nri[inri][0]+=(-48+r_s[4][j])*pow(10,l);
				}
				cv[cvi]=nri[inri][0];
				iv[cvi][0]=-1;
				iv[cvi][1]=-1;

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				for(j=0;j<-1+strlen(r_s[8]);++j){tvarnl[j]=r_s[8][j];}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					iv[cvi][2]=tarv[rvi][0];
					iv[cvi][3]=tarv[rvi][1];
					++cvi;

					if (tarv[rvi][1]==2||tarv[rvi][1]==3)
					{
						if (tarv[rvi][1]==2)
						{
							nri[inri][1]=nvarv[tarv[rvi][0]][0];
						}
						if(tarv[rvi][1]==3)
						{
							nri[inri][1]=nvarv[tarv[rvi][0]][0]<<16;
							nri[inri][1]+=nvarv[tarv[rvi][0]][1];
						}
					}

				}else{printf("reference err...%s\n",tvarnl);}

				for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
				for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

				for(j=0;j<vi;++j)
				{
					if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
				}
				if(j!=vi)
				{
					if (tarv[rvi][1]==2||tarv[rvi][1]==3)
					{
						if (tarv[rvi][1]==2)
						{
							nvarv[tarv[rvi][0]][0]=nri[inri][0];
							nri[inri][6]=2;
						}
						if(tarv[rvi][1]==3)
						{
							nvarv[tarv[rvi][0]][0]=(nri[inri][0]&0xffff0000)>>16;
							nvarv[tarv[rvi][0]][1]=(nri[inri][0]&0x0000ffff)<<0;
							nri[inri][6]=3;
						}
					}

				}else{printf("reference err...%s\n",tvarnl);}

				nri[inri][2]=4;
				nri[inri][5]=tarv[rvi][0];
				nri[inri][9]=12;
				++inri;

				return(0);

		}

	}


	if(j==3)
	{
		nri[inri][3]=start;
		nri[inri][4]=end;

		i=p_syntax_(il,b_for_2);

		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		for(j=0;j<-1+strlen(r_s[8]);++j){tvarnl[j]=r_s[8][j];}

		for(j=0;j<vi;++j)
		{
			if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
		}
		if(j!=vi)
		{
			iv[cvi][2]=rvi;
			iv[cvi][3]=tarv[rvi][1];

			if (tarv[rvi][1]==2||tarv[rvi][1]==3)
			{
				if (tarv[rvi][1]==2)
				{
					nri[inri][1]=nvarv[tarv[rvi][0]][0];
				}
				if(tarv[rvi][1]==3)
				{
					nri[inri][1]=nvarv[tarv[rvi][0]][0]<<16;
					nri[inri][1]+=nvarv[tarv[rvi][0]][1];
				}
			}

		}else{printf("reference err...%s\n",tvarnl);}

		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		for(j=0;j<-1+strlen(r_s[4]);++j){tvarnl[j]=r_s[4][j];}

		for(j=0;j<vi;++j)
		{
			if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
		}
		if(j!=vi)
		{
			if (tarv[rvi][1]==2||tarv[rvi][1]==3)
			{
				if (tarv[rvi][1]==2)
				{
					nri[inri][0]=nvarv[tarv[rvi][0]][0];
					nri[inri][6]=2;
					cv[cvi]=nri[inri][0];
					iv[cvi][0]=tarv[rvi][0];
					iv[cvi][1]=tarv[rvi][1];
					++cvi;

				}
				if(tarv[rvi][1]==3)
				{
					nri[inri][0]=nvarv[tarv[rvi][0]][0]<<16;
					nri[inri][0]+=nvarv[tarv[rvi][0]][1];
					nri[inri][6]=3;
					cv[cvi]=nri[inri][0];
					iv[cvi][0]=tarv[rvi][0];
					iv[cvi][1]=tarv[rvi][1];
					++cvi;

				}
			}

		}else{printf("reference err...%s\n",tvarnl);}

		for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
		for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

		for(j=0;j<vi;++j)
		{
			if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
		}
		if(j!=vi)
		{
			if (tarv[rvi][1]==2||tarv[rvi][1]==3)
			{
				if (tarv[rvi][1]==2)
				{
					nvarv[tarv[rvi][0]][0]=nri[inri][0];
					nri[inri][6]=2;
				}
				if(tarv[rvi][1]==3)
				{
					nvarv[tarv[rvi][0]][0]=(nri[inri][0]&0xffff0000)>>16;
					nvarv[tarv[rvi][0]][1]=(nri[inri][0]&0x0000ffff)<<0;
					nri[inri][6]=3;
				}
			}

		}else{printf("reference err...%s\n",tvarnl);}

		nri[inri][2]=4;
		nri[inri][5]=tarv[rvi][0];
		nri[inri][9]=12;
		++inri;
	
		return(0);
	}

	return(0);
}

//!!!

int	p_if_(int start,int end)
{
	int			i,j,k,l,rvi;

	char			il[plinel];int	ili=0;
	char			tvarnl[vnaml];
	
	double			fr;


	for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
	for(i=0;i<strlen(pf[start]);++i){il[ili]=pf[start][i];++ili;}

	nri[inri][3]=start;
	nri[inri][4]=end;

	j=0;
	for(i=0;i<ili-1;++i)
	{
		if
		(
			(il[0]=='i'&&il[1]=='f'&&il[i]=='#'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='%'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='&'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='$'&&(il[i+1]=='='||il[i+1]=='>'||il[i+1]=='<'))
			||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='#'&&il[i+1]==')')||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='%'&&il[i+1]==')')||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='&'&&il[i+1]==')')||
			(il[0]=='i'&&il[1]=='f'&&il[i]=='$'&&il[i+1]==')')
		)
		{++j;}
	}

	if(j==1)
	{
			i=p_syntax_(il,b_if_1);

			if (1<=p_ex(il,">="))
			{
				nri[inri][2]=3;
			}else{
				if (1<=p_ex(il,"<="))
				{
					nri[inri][2]=4;
				}else{
					if (1<=p_ex(il,"="))
					{
						nri[inri][2]=0;
					}else{
						if (1<=p_ex(il,"<>"))
						{
							nri[inri][2]=5;
						}else{
							if (1<=p_ex(il,">"))
							{
								nri[inri][2]=1;
							}else{
								if (1<=p_ex(il,"<"))
								{
									nri[inri][2]=2;
							}	}
						}
					}
				}
			}

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				if (tarv[rvi][1]==2||tarv[rvi][1]==4)
				{
					//nri[inri][0]=nvarv[tarv[rvi][0]][0];
					//nri[inri][5]=tarv[rvi][0];
					//nri[inri][6]=2;

					if (tarv[rvi][1]==2)
					{
						nri[inri][0]=nvarv[tarv[rvi][0]][0];
						nri[inri][5]=tarv[rvi][0];
						nri[inri][6]=2;
					}else{
						nri[inri][0]=(long)dvarv[tarv[rvi][0]];
						nri[inri][5]=tarv[rvi][0];
						nri[inri][6]=4;
					}

				}else{
					if (tarv[rvi][1]==3)
					{
						nri[inri][0]=nvarv[tarv[rvi][0]][0]<<16;
						nri[inri][0]+=nvarv[tarv[rvi][0]][1];
						nri[inri][5]=tarv[rvi][0];
						nri[inri][6]=3;
					}else{
						if (tarv[rvi][1]==1)
						{
							k=0;
							for(j=0;j<strlen(cvarv[tarv[rvi][0]]);++j)
							{
								if
								(
									cvarv[tarv[rvi][0]][j]=='\''||
									cvarv[tarv[rvi][0]][j]=='"'
								)
								{}else{csL[k]=cvarv[tarv[rvi][0]][j];++k;}
							}for(j=k;j<plinel;++j){csL[k]='\0';++k;}
							nri[inri][5]=tarv[rvi][0];
							nri[inri][6]=1;
						}
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}

			nri[inri][1]=(long)p_val(r_s[4]);

			nri[inri][7]=nri[inri][1];
			nri[inri][8]=-1;
			nri[inri][9]=13;	

			++inri;

	}else{
		if(j==2)
		{

			i=p_syntax_(il,b_if);

			if (1<=p_ex(il,">="))
			{
				nri[inri][2]=3;
			}else{
				if (1<=p_ex(il,"<="))
				{
					nri[inri][2]=4;
				}else{
					if (1<=p_ex(il,"="))
					{
						nri[inri][2]=0;
					}else{
						if (1<=p_ex(il,"<>"))
						{
							nri[inri][2]=5;
						}else{
							if (1<=p_ex(il,">"))
							{
								nri[inri][2]=1;
							}else{
								if (1<=p_ex(il,"<"))
								{
									nri[inri][2]=2;
								}
							}
						}
					}
				}
			}

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[2]);++j){tvarnl[j]=r_s[2][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				if (tarv[rvi][1]==2||tarv[rvi][1]==4)
				{
					//nri[inri][0]=nvarv[tarv[rvi][0]][0];
					//nri[inri][5]=tarv[rvi][0];
					//nri[inri][6]=2;

					if (tarv[rvi][1]==2)
					{
						nri[inri][0]=nvarv[tarv[rvi][0]][0];
						nri[inri][5]=tarv[rvi][0];
						nri[inri][6]=2;
					}else{
						nri[inri][0]=(long)dvarv[tarv[rvi][0]];
						nri[inri][5]=tarv[rvi][0];
						nri[inri][6]=4;
					}

				}else{
					if (tarv[rvi][1]==3)
					{
						nri[inri][0]=nvarv[tarv[rvi][0]][0]<<16;
						nri[inri][0]+=nvarv[tarv[rvi][0]][1];
						nri[inri][5]=tarv[rvi][0];
						nri[inri][6]=3;
					}else{
						if (tarv[rvi][1]==1)
						{
							k=0;
							for(j=0;j<strlen(cvarv[tarv[rvi][0]]);++j)
							{
								if
								(
									cvarv[tarv[rvi][0]][j]=='\''||
									cvarv[tarv[rvi][0]][j]=='"'
								)
								{}else{csL[k]=cvarv[tarv[rvi][0]][j];++k;}
							}for(j=k;j<plinel;++j){csL[k]='\0';++k;}
							nri[inri][5]=tarv[rvi][0];
							nri[inri][6]=1;
						}
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}

			for(j=0;j<vnaml;++j){tvarnl[j]='\0';}
			for(j=0;j<-1+strlen(r_s[4]);++j){tvarnl[j]=r_s[4][j];}

			for(j=0;j<vi;++j)
			{
				if (1==p_comp_(varnl[j],tvarnl)){rvi=j;break;}
			}
			if(j!=vi)
			{
				if (tarv[rvi][1]==2||tarv[rvi][1]==4)
				{

					//nri[inri][1]=nvarv[tarv[rvi][0]][0];
					//nri[inri][7]=tarv[rvi][0];
					//nri[inri][8]=2;

					if (tarv[rvi][1]==2)
					{
						nri[inri][1]=nvarv[tarv[rvi][0]][0];
						nri[inri][7]=tarv[rvi][0];
						nri[inri][8]=2;
					}else{
						nri[inri][1]=(long)dvarv[tarv[rvi][0]];
						nri[inri][7]=tarv[rvi][0];
						nri[inri][8]=4;
					}

				}else{
					if (tarv[rvi][1]==3)
					{
						nri[inri][1]=nvarv[tarv[rvi][0]][0]<<16;
						nri[inri][1]+=nvarv[tarv[rvi][0]][1];
						nri[inri][7]=tarv[rvi][0];
						nri[inri][8]=3;
					}else{
						if (tarv[rvi][1]==1)
						{
							k=0;
							for(j=0;j<strlen(cvarv[tarv[rvi][0]]);++j)
							{
								if
								(
									cvarv[tarv[rvi][0]][j]=='\''||
									cvarv[tarv[rvi][0]][j]=='"'
								)
								{}else{csR[k]=cvarv[tarv[rvi][0]][j];++k;}
							}for(j=k;j<plinel;++j){csR[k]='\0';++k;}
							nri[inri][7]=tarv[rvi][0];
							nri[inri][8]=1;
						}
					}
				}

			}else{printf("reference err...%s\n",tvarnl);}

			nri[inri][9]=13;	
			++inri;
		}
	}
	return(0);
}

//!!!

//parse -

int parse_d2(int start,int pid,int eid)
{

		int	exitF;
		int		i,i0,i1,j,k;
		long	t;

		exitF=0;
		i1=start;i0=pid;
		while(exitF==0)
		{
			if (i1==nri[i0][3])
			{
				if (nri[i0][6]==-1&&nri[i0][5]>=0)
				{
					t=nri[i0][5];
					nri[i0][0]=t;
				}
				if (nri[i0][6]==1&&nri[i0][5]>=0)
				{
					k=0;
					for(j=0;j<strlen(cvarv[nri[i0][5]]);++j)
					{
						if
						(
							cvarv[nri[i0][5]][j]=='\''||
							cvarv[nri[i0][5]][j]=='"'
						)
						{}else{csL[k]=cvarv[nri[i0][5]][j];++k;}
					}for(j=k;j<plinel;++j){csL[k]='\0';++k;}
				if (nri[i0][8]==1&&nri[i0][7]>=0)
				{
					k=0;
					for(j=0;j<strlen(cvarv[nri[i0][7]]);++j)
					{
						if
						(
							cvarv[nri[i0][7]][j]=='\''||
							cvarv[nri[i0][7]][j]=='"'
						)
						{}else{csR[k]=cvarv[nri[i0][7]][j];++k;}
					}for(j=k;j<plinel;++j){csR[k]='\0';++k;}
					if (nri[i0][2]==0)
					{if(1==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==5)
					{if(1!=p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==1)
					{if(3==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==2)
					{if(2==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
				}
				}
				if (nri[i0][6]==2&&nri[i0][5]>=0)
				{
					t=nvarv[nri[i0][5]][0];
					nri[i0][0]=t;
				}
				if (nri[i0][6]==3&&nri[i0][5]>=0)
				{
					t=nvarv[nri[i0][5]][0]<<16;
					t+=nvarv[nri[i0][5]][1];
					nri[i0][0]=t;
				}
				if (nri[i0][8]==-1&&nri[i0][7]>=0)
				{
					t=nri[i0][7];
					nri[i0][1]=t;
				}
				if (nri[i0][8]==2&&nri[i0][7]>=0)
				{
					t=nvarv[nri[i0][7]][0];
					nri[i0][1]=t;
				}
				if (nri[i0][8]==3&&nri[i0][7]>=0)
				{
					t=nvarv[nri[i0][7]][0]<<16;
					t+=nvarv[nri[i0][7]][1];
					nri[i0][1]=t;
				}
				if (nri[i0][2]==0)
				{
					if(nri[i0][0]==nri[i0][1]){++i1;}else{exitF=1;}
				}
				if (nri[i0][2]==5)
				{
					if(nri[i0][0]!=nri[i0][1]){++i1;}else{exitF=1;}
				}
				if (nri[i0][2]==1)
				{	
					if(nri[i0][0]>nri[i0][1]){++i1;}else{exitF=1;}
				}
				if (nri[i0][2]==2)
				{	
					if(nri[i0][0]<nri[i0][1]){++i1;}else{exitF=1;}
				}
				if (nri[i0][2]==3)
				{	
					if(nri[i0][0]>=nri[i0][1]){++i1;}else{exitF=1;}
				}
				if (nri[i0][2]==4)
				{	
					if(nri[i0][0]<=nri[i0][1]){++i1;}else{exitF=1;}
				}			
			}else{
				if (i1==nri[i0][4])
				{
					exitF=1;
				}else{
					exc(i1);
					++i1;
				}
			}
		}

		for (i=0;i<iri;++i){if (nri[pid][4]==ri[i][0]){break;}}
		return(i);
}

int parse_while_2(int start,int pid,int eid)
{
	int	exitF;
	int		i,i0,i1,j,k;
	long	t;

	exitF=0;
	i1=start;i0=pid;
	while(exitF==0)
	{
		if (i1==nri[i0][3])
		{
			if (nri[i0][6]==-1&&nri[i0][5]>=0)
			{
				t=nri[i0][5];
				nri[i0][0]=t;
			}
			if (nri[i0][6]==1&&nri[i0][5]>=0)
			{
				k=0;
				for(j=0;j<strlen(cvarv[nri[i0][5]]);++j)
				{
					if
					(
						cvarv[nri[i0][5]][j]=='\''||
						cvarv[nri[i0][5]][j]=='"'
					)
					{}else{csL[k]=cvarv[nri[i0][5]][j];++k;}
				}for(j=k;j<plinel;++j){csL[k]='\0';++k;}
				if (nri[i0][8]==1&&nri[i0][7]>=0)
				{
					k=0;
					for(j=0;j<strlen(cvarv[nri[i0][7]]);++j)
					{
						if
						(
							cvarv[nri[i0][7]][j]=='\''||
							cvarv[nri[i0][7]][j]=='"'
						)
						{}else{csR[k]=cvarv[nri[i0][7]][j];++k;}
					}for(j=k;j<plinel;++j){csR[k]='\0';++k;}
					if (nri[i0][2]==0)
					{if(1==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==5)
					{if(1!=p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==1)
					{if(3==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==2)
					{if(2==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
				}
			}
			if (nri[i0][6]==2&&nri[i0][5]>=0)
			{
				t=nvarv[nri[i0][5]][0];
				nri[i0][0]=t;
			}
			if (nri[i0][6]==3&&nri[i0][5]>=0)
			{
				t=nvarv[nri[i0][5]][0]<<16;
				t+=nvarv[nri[i0][5]][1];
				nri[i0][0]=t;
			}
			if (nri[i0][8]==-1&&nri[i0][7]>=0)
			{
				t=nri[i0][7];
				nri[i0][1]=t;
			}			
			if (nri[i0][8]==2&&nri[i0][7]>=0)
			{
				t=nvarv[nri[i0][7]][0];
				nri[i0][1]=t;
			}
			if (nri[i0][8]==3&&nri[i0][7]>=0)
			{
				t=nvarv[nri[i0][7]][0]<<16;
				t+=nvarv[nri[i0][7]][1];
				nri[i0][1]=t;
			}			
			if (nri[i0][2]==0)
			{						
				if(nri[i0][0]==nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==5)
			{						
				if(nri[i0][0]!=nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==1)
			{						
				if(nri[i0][0]>nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==2)
			{						
				if(nri[i0][0]<nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==3)
			{						
				if(nri[i0][0]>=nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==4)
			{						
				if(nri[i0][0]<=nri[i0][1]){++i1;}else{exitF=1;}
			}
		}else{
			if (i1==nri[i0][4])
			{
				i1=nri[i0][3];
			}else{
				for(j=pid+1;j<eid;++j)
				{
					if (i1==nri[j][3])
					{
						if(nri[j][9]==13)
						{
							i1=ri[parse_d2(i1,j,eid)][0];
							++i1;
							break;
						}
					}
				}
				if(j==eid)
				{
					exc(i1);
					++i1;
				}
			}
		}
	}

	for (i=0;i<iri;++i){if (nri[pid][4]==ri[i][0]){break;}}
	return(i);

}

int parse_if_2(int start,int pid,int eid)
{

	int	exitF;
	int		i,i0,i1,j,k;
	long	t;

	exitF=0;
	i1=start;i0=pid;
	while(exitF==0)
	{
		if (i1==nri[i0][3])
		{
			if (nri[i0][6]==-1&&nri[i0][5]>=0)
			{
				t=nri[i0][5];
				nri[i0][0]=t;
			}
			if (nri[i0][6]==1&&nri[i0][5]>=0)
			{
				k=0;
				for(j=0;j<strlen(cvarv[nri[i0][5]]);++j)
				{

					if
					(
						cvarv[nri[i0][5]][j]=='\''||
						cvarv[nri[i0][5]][j]=='"'
					)
					{}else{csL[k]=cvarv[nri[i0][5]][j];++k;}
				}for(j=k;j<plinel;++j){csL[k]='\0';++k;}
				if (nri[i0][8]==1&&nri[i0][7]>=0)
				{
					k=0;
					for(j=0;j<strlen(cvarv[nri[i0][7]]);++j)
					{
						if
						(
							cvarv[nri[i0][7]][j]=='\''||
							cvarv[nri[i0][7]][j]=='"'
						)
						{}else{csR[k]=cvarv[nri[i0][7]][j];++k;}
					}for(j=k;j<plinel;++j){csR[k]='\0';++k;}
					if (nri[i0][2]==0)
					{if(1==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==5)
					{if(1!=p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==1)
					{if(3==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==2)
					{if(2==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
				}
			}
			if (nri[i0][6]==2&&nri[i0][5]>=0)
			{
				t=nvarv[nri[i0][5]][0];
				nri[i0][0]=t;
			}
			if (nri[i0][6]==3&&nri[i0][5]>=0)
			{
				t=nvarv[nri[i0][5]][0]<<16;

				t+=nvarv[nri[i0][5]][1];
				nri[i0][0]=t;
			}
			if (nri[i0][8]==-1&&nri[i0][7]>=0)
			{
				t=nri[i0][7];
				nri[i0][1]=t;
			}
			if (nri[i0][8]==2&&nri[i0][7]>=0)
			{
				t=nvarv[nri[i0][7]][0];
				nri[i0][1]=t;
			}
			if (nri[i0][8]==3&&nri[i0][7]>=0)
			{
				t=nvarv[nri[i0][7]][0]<<16;
				t+=nvarv[nri[i0][7]][1];
				nri[i0][1]=t;
			}
			if (nri[i0][2]==0)
			{
				if(nri[i0][0]==nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==5)
			{
				if(nri[i0][0]!=nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==1)
			{	
				if(nri[i0][0]>nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==2)
			{	
				if(nri[i0][0]<nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==3)
			{	
				if(nri[i0][0]>=nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==4)
			{	
				if(nri[i0][0]<=nri[i0][1]){++i1;}else{exitF=1;}
			}			
		}else{
			if (i1==nri[i0][4])
			{
				exitF=1;
			}else{
				for(j=pid+1;j<eid;++j)
				{
					if (i1==nri[j][3])
					{
						if(nri[j][9]==13)
						{
							i1=ri[parse_d2(i1,j,eid)][0];
							++i1;
							break;
						}
					}
				}
				if(j==eid)
				{
					exc(i1);
					++i1;
				}
			}
		}
	}

	for (i=0;i<iri;++i){if (nri[pid][4]==ri[i][0]){break;}}
	return(i);
}

int parse_for_2(int start, long cv[10],int pid,int eid)
{

	int	exitF;
	int		i,j,l,i0,i1;
	long	t;


	i=0;for(j=pid;j<=eid;++j){if((nri[j][9]==12)||(nri[j][9]==0)){++i;}}--i;i=cvi-i;
	
	if(iv[i][0]!=-1&&iv[i][1]!=-1)
	{

		if (nri[pid][6]==2)
		{
			nri[pid][0]=nvarv[iv[i][0]][0];

			nvarv[nri[pid][5]][0]=nvarv[iv[i][0]][0];
		}
		if (nri[pid][6]==3)
		{
			nri[pid][0]=(nvarv[iv[i][0]][0]<<16)|nvarv[iv[i][0]][1];

			nvarv[nri[pid][5]][0]=nvarv[iv[i][0]][0];
			nvarv[nri[pid][5]][1]=nvarv[iv[i][0]][1];
		}

		if(iv[i][2]!=-1&&iv[i][3]!=-1)
		{
			nri[pid][1]=nvarv[iv[i][2]][0];
		}		

	}else{

		nri[pid][0]=cv[i];
		if (nri[pid][6]==2)
		{
			nvarv[nri[pid][5]][0]=cv[i];
		}
		if (nri[pid][6]==3)
		{
			nvarv[nri[pid][5]][0]=(cv[i]&0xffff0000)>>16;
			nvarv[nri[pid][5]][1]=(cv[i]&0x0000ffff);
		}

		if(iv[i][2]!=-1&&iv[i][3]!=-1)
		{
			nri[pid][1]=nvarv[iv[i][2]][0];
		}		
	}

	exitF=0;i1=start;i0=pid;
	while(exitF==0)
	{				
		if (i1==nri[i0][3])
		{
			if (nri[i0][2]==4)
			{						
				if(nri[i0][0]<=nri[i0][1]){++i1;}else{exitF=1;}
			}
		}
		else{
			if (i1==nri[i0][4])
			{
				if (nri[i0][6]==2)
				{
					t=nvarv[nri[i0][5]][0];
					nri[i0][0]=t+1;
					nvarv[nri[i0][5]][0]=t+1;
				}
				if (nri[i0][6]==3)
				{
					t=nvarv[nri[i0][5]][0]<<16;
					t+=nvarv[nri[i0][5]][1];
					++t;
					nri[i0][0]=t;
					nvarv[nri[i0][5]][0]=((long)t&0xffff0000)>>16;
					nvarv[nri[i0][5]][1]=((long)t&0x0000ffff);
				}			
				i1=nri[i0][3];
			}else{
				for(j=pid+1;j<eid;++j)
				{
					if (i1==nri[j][3])
					{
						if(nri[j][9]==13)
						{
							i1=ri[parse_d2(i1,j,eid)][0];
							++i1;
							break;
						}
					}
				}
				if(j==eid)
				{
					exc(i1);
					++i1;
				}
			}
		}
	}

	for (i=0;i<iri;++i){if (nri[pid][4]==ri[i][0]){break;}}
	return(i);
}

int parse_while_1(int start,int pid,int eid)
{
	int	exitF;
	int		i,i0,i1,j,k;
	long	t;

	exitF=0;
	i1=start;i0=pid;
	while(exitF==0)
	{
		if (i1==nri[i0][3])
		{
			if (nri[i0][6]==-1&&nri[i0][5]>=0)
			{
				t=nri[i0][5];
				nri[i0][0]=t;
			}
			if (nri[i0][6]==1&&nri[i0][5]>=0)
			{
				k=0;
				for(j=0;j<strlen(cvarv[nri[i0][5]]);++j)
				{
					if
					(
						cvarv[nri[i0][5]][j]=='\''||
						cvarv[nri[i0][5]][j]=='"'
					)
					{}else{csL[k]=cvarv[nri[i0][5]][j];++k;}
				}for(j=k;j<plinel;++j){csL[k]='\0';++k;}
				if (nri[i0][8]==1&&nri[i0][7]>=0)
				{
					k=0;
					for(j=0;j<strlen(cvarv[nri[i0][7]]);++j)
					{
						if
						(
							cvarv[nri[i0][7]][j]=='\''||
							cvarv[nri[i0][7]][j]=='"'
						)
						{}else{csR[k]=cvarv[nri[i0][7]][j];++k;}
					}for(j=k;j<plinel;++j){csR[k]='\0';++k;}
					if (nri[i0][2]==0)
					{if(1==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==5)
					{if(1!=p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==1)
					{if(3==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==2)
					{if(2==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
				}
			}
			if (nri[i0][6]==2&&nri[i0][5]>=0)
			{
				t=nvarv[nri[i0][5]][0];
				nri[i0][0]=t;
			}
			if (nri[i0][6]==3&&nri[i0][5]>=0)
			{
				t=nvarv[nri[i0][5]][0]<<16;
				t+=nvarv[nri[i0][5]][1];
				nri[i0][0]=t;
			}
			if (nri[i0][8]==-1&&nri[i0][7]>=0)
			{
				t=nri[i0][7];
				nri[i0][1]=t;
			}			
			if (nri[i0][8]==2&&nri[i0][7]>=0)
			{
				t=nvarv[nri[i0][7]][0];
				nri[i0][1]=t;
			}
			if (nri[i0][8]==3&&nri[i0][7]>=0)
			{
				t=nvarv[nri[i0][7]][0]<<16;
				t+=nvarv[nri[i0][7]][1];
				nri[i0][1]=t;
			}			
			if (nri[i0][2]==0)
			{						
				if(nri[i0][0]==nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==5)
			{						
				if(nri[i0][0]!=nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==1)
			{						
				if(nri[i0][0]>nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==2)
			{						
				if(nri[i0][0]<nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==3)
			{						
				if(nri[i0][0]>=nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==4)
			{						
				if(nri[i0][0]<=nri[i0][1]){++i1;}else{exitF=1;}
			}
		}else{
			if (i1==nri[i0][4])
			{
				i1=nri[i0][3];
			}else{
				for(j=pid+1;j<eid;++j)
				{
					if (i1==nri[j][3])
					{
						if(nri[j][9]==13)
						{
							i1=ri[parse_if_2(i1,j,eid)][0];
							++i1;
							break;
						}
						if(nri[j][9]==12)
						{
							i1=ri[parse_for_2(i1,cv,j,eid)][0];
							++i1;
							break;
						}
						if(nri[j][9]==15)
						{
							i1=ri[parse_while_2(i1,j,eid)][0];
							++i1;
							break;
						}
					}
				}
				if(j==eid)
				{
					exc(i1);
					++i1;
				}
			}
		}
	}

	for (i=0;i<iri;++i){if (nri[pid][4]==ri[i][0]){break;}}
	return(i);
}

int parse_if_1(int start,int pid,int eid)
{

	int	exitF;
	int		i,i0,i1,j,k;
	long	t;

	exitF=0;
	i1=start;i0=pid;
	while(exitF==0)
	{
		if (i1==nri[i0][3])
		{
			if (nri[i0][6]==-1&&nri[i0][5]>=0)
			{
				t=nri[i0][5];
				nri[i0][0]=t;
			}
			if (nri[i0][6]==1&&nri[i0][5]>=0)
			{
				k=0;
				for(j=0;j<strlen(cvarv[nri[i0][5]]);++j)
				{
					if
					(
						cvarv[nri[i0][5]][j]=='\''||
						cvarv[nri[i0][5]][j]=='"'
					)
					{}else{csL[k]=cvarv[nri[i0][5]][j];++k;}
				}for(j=k;j<plinel;++j){csL[k]='\0';++k;}
				if (nri[i0][8]==1&&nri[i0][7]>=0)
				{
					k=0;
					for(j=0;j<strlen(cvarv[nri[i0][7]]);++j)
					{
						if
						(
							cvarv[nri[i0][7]][j]=='\''||
							cvarv[nri[i0][7]][j]=='"'
						)
						{}else{csR[k]=cvarv[nri[i0][7]][j];++k;}
					}for(j=k;j<plinel;++j){csR[k]='\0';++k;}
					if (nri[i0][2]==0)
					{if(1==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==5)
					{if(1!=p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==1)
					{if(3==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
					if (nri[i0][2]==2)
					{if(2==p_comp(csL,csR)){++i1;}else{i1=nri[i0][4];}continue;}
				}
			}
			if (nri[i0][6]==2&&nri[i0][5]>=0)
			{
				t=nvarv[nri[i0][5]][0];
				nri[i0][0]=t;
			}
			if (nri[i0][6]==3&&nri[i0][5]>=0)
			{
				t=nvarv[nri[i0][5]][0]<<16;
				t+=nvarv[nri[i0][5]][1];
				nri[i0][0]=t;
			}
			if (nri[i0][8]==-1&&nri[i0][7]>=0)
			{
				t=nri[i0][7];
				nri[i0][1]=t;
			}
			if (nri[i0][8]==2&&nri[i0][7]>=0)
			{
				t=nvarv[nri[i0][7]][0];
				nri[i0][1]=t;
			}
			if (nri[i0][8]==3&&nri[i0][7]>=0)
			{
				t=nvarv[nri[i0][7]][0]<<16;
				t+=nvarv[nri[i0][7]][1];
				nri[i0][1]=t;
			}
			if (nri[i0][2]==0)
			{
				if(nri[i0][0]==nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==5)
			{
				if(nri[i0][0]!=nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==1)
			{	
				if(nri[i0][0]>nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==2)
			{	
				if(nri[i0][0]<nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==3)
			{	
				if(nri[i0][0]>=nri[i0][1]){++i1;}else{exitF=1;}
			}
			if (nri[i0][2]==4)
			{	
				if(nri[i0][0]<=nri[i0][1]){++i1;}else{exitF=1;}
			}			
		}else{
			if (i1==nri[i0][4])
			{
				exitF=1;
			}else{
				for(j=pid+1;j<eid;++j)
				{
					if (i1==nri[j][3])
					{
						if(nri[j][9]==13)
						{
							i1=ri[parse_if_2(i1,j,eid)][0];
							++i1;
							break;
						}
						if(nri[j][9]==12)
						{
							i1=ri[parse_for_2(i1,cv,j,eid)][0];
							++i1;
							break;
						}
						if(nri[j][9]==15)
						{
							i1=ri[parse_while_2(i1,j,eid)][0];
							++i1;
							break;
						}
					}
				}
				if(j==eid)
				{
					exc(i1);
					++i1;
				}
			}
		}
	}

	for (i=0;i<iri;++i){if (nri[pid][4]==ri[i][0]){break;}}
	return(i);
}

int parse_for_1(int start, long cv[10],int pid,int eid)
{

	int	exitF;
	int	i,j,l,i0,i1;
	long	t;

	//i=0;l=0;
	//for(j=pid;j>=0;--j){if(nri[j][9]==12){++i;if(!(-1+j<0)&&nri[-1+j][9]==12){--j;}}if(nri[j][9]==13){++l;}}
	//if(l!=0){--i;}

	i=pid;
	if(iv[i][0]!=-1&&iv[i][1]!=-1)
	{
		if (nri[pid][6]==2)
		{
			nri[pid][0]=nvarv[iv[i][0]][0];

			nvarv[nri[pid][5]][0]=nvarv[iv[i][0]][0];
		}
		if (nri[pid][6]==3)
		{
			nri[pid][0]=(nvarv[iv[i][0]][0]<<16)|nvarv[iv[i][0]][1];

			nvarv[nri[pid][5]][0]=nvarv[iv[i][0]][0];
			nvarv[nri[pid][5]][1]=nvarv[iv[i][0]][1];
		}

		if(iv[i][2]!=-1&&iv[i][3]!=-1)
		{
			nri[pid][1]=nvarv[iv[i][2]][0];
		}		

	}else{

		nri[pid][0]=cv[i];
		if (nri[pid][6]==2)
		{
			nvarv[nri[pid][5]][0]=cv[i];
		}
		if (nri[pid][6]==3)
		{
			nvarv[nri[pid][5]][0]=(cv[i]&0xffff0000)>>16;
			nvarv[nri[pid][5]][1]=(cv[i]&0x0000ffff);
		}

		if(iv[i][2]!=-1&&iv[i][3]!=-1)
		{
			nri[pid][1]=nvarv[iv[i][2]][0];
		}		
	}

	exitF=0;i1=start;i0=pid;
	while(exitF==0)
	{				
		if (i1==nri[i0][3])
		{
			if (nri[i0][2]==4)
			{						
				if(nri[i0][0]<=nri[i0][1]){++i1;}else{exitF=1;}
			}
		}
		else{
			if (i1==nri[i0][4])
			{
				if (nri[i0][6]==2)
				{
					t=nvarv[nri[i0][5]][0];
					nri[i0][0]=t+1;
					nvarv[nri[i0][5]][0]=t+1;
				}
				if (nri[i0][6]==3)
				{
					t=nvarv[nri[i0][5]][0]<<16;
					t+=nvarv[nri[i0][5]][1];
					++t;
					nri[i0][0]=t;
					nvarv[nri[i0][5]][0]=((long)t&0xffff0000)>>16;
					nvarv[nri[i0][5]][1]=((long)t&0x0000ffff);
				}			
				i1=nri[i0][3];
			}else{
				for(j=pid+1;j<eid;++j)
				{
					if (i1==nri[j][3])
					{
						if(nri[j][9]==13)
						{
							i1=ri[parse_if_2(i1,j,eid)][0];
							++i1;
							break;
						}
						if(nri[j][9]==12)
						{
							i1=ri[parse_for_2(i1,cv,j,eid)][0];
							++i1;
							break;
						}
						if(nri[j][9]==15)
						{
							i1=ri[parse_while_2(i1,j,eid)][0];
							++i1;
							break;
						}
					}
				}
				if(j==eid)
				{
					exc(i1);
					++i1;
				}
			}
		}
	}

	for (i=0;i<iri;++i){if (nri[pid][4]==ri[i][0]){break;}}
	return(i);

}

//parse -

int parse()
{
	int			i,j,k,l,m,n;
	char			il[plinel];int	ili=0;
	int			fbyte;
	int			cl;
	int			inb=0;
	int			inbt=0;
	int			inbri=0;
	int			linn=0;
	int			s,e,e1;
	int			forinbt=0;
	int			ifinbt=0;
	int			whileinbt=0;
	int			subinbt=0;
	int			exlin=0;
	int			in;

	linn=0;
	
	for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
	for(i=0;i<r_strlen(pf[linn]);++i){il[ili]=pf[linn][i];++ili;}

	inb=0;inbt=0;iri=0;eri=1;
	
	ri[iri][1]=0;ri[iri][2]=0;ri[iri][3]=0;
	ri[iri][4]=0;ri[iri][5]=0;ri[iri][6]=0;
	
	vi=0;ci=0;ni=0;dni=0;
	for(i=0;i<maxv;++i){for(j=0;j<vnaml;++j){varnl[i][j]='\0';}}
	for(i=0;i<maxv;++i){for(j=0;j<plinel;++j){cvarv[i][j]='\0';}}

	forinbt=0;ifinbt=0;whileinbt=0;
	subinbt=0;
	
	while(1!=p_comp(il,"end")&&linn<maxv)
	{
//exc
		//printf("%d-%d %d %d %d %d %d\n",linn,ri[iri-1][0],ri[iri-1][1],ri[iri-1][2],ri[iri-1][3],ri[iri-1][4],ri[iri-1][5]);
		if 
		(

			ifinbt>=1||
			forinbt>=1||
			whileinbt>=1

		){inb=1;}else{inb=0;}

		p_syntax_(il,p_exp);

		if
		(
			r_s[2][0]=='='&&
			r_s[2][1]=='\0'&&
			(
				r_s[3][0]=='-'||
				r_s[3][0]=='+'||
				r_s[3][0]=='\''||
				r_s[3][0]=='\"'||
				(r_s[3][0]>='0'&&r_s[3][0]<='9')||
				(r_s[3][0]>='#'&&r_s[3][0]<='&')
			)
			&&
			(
				r_s[4][0]=='\0'||
				r_s[4][0]=='-'||
				r_s[4][0]=='+'||
				(r_s[4][0]>='#'&&r_s[4][0]<='&')
			)
			&&
			(
				r_s[5][0]=='\0'||
				r_s[5][0]=='-'||
				r_s[5][0]=='+'
			)
		)
		{

				if (inb==0)
				{
					ri[iri][0]=linn;
					ri[iri][1]=0;
					ri[iri][2]=0;
					ri[iri][3]=0;
					ri[iri][4]=0;
					ri[iri][5]=0;
					ri[iri][6]=0;
					eri=1;
					ri[iri][eri]=11;
				}else{
						ri[iri][0]=linn;
						ri[iri][1]=ri[iri-1][1];
						ri[iri][2]=ri[iri-1][2];
						ri[iri][3]=ri[iri-1][3];
						ri[iri][4]=ri[iri-1][4];
						ri[iri][5]=ri[iri-1][5];
						ri[iri][6]=ri[iri-1][6];

						j=ifinbt+whileinbt+forinbt;
						if (j==0){j=1;}

						for (i=6;i>j;--i){ri[iri][i]=0;}
					
						if (ri[iri][j]==1)
						{
							eri=j;
						}else{
							if (ri[iri][j]==0)
							{
								ri[iri][j]=11;
								eri=j;
							}else{	
								ri[iri][j+1]=11;
								eri=j+1;
							}
						}
				}
				++iri;

				++linn;
				for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
				for(i=0;i<r_strlen(pf[linn]);++i){il[ili]=pf[linn][i];++ili;}
				continue;
	
		}

		if
		(
			r_s[2][0]=='='&&
			(r_s[2][1]=='\0'||r_s[2][1]=='(')&&
			(
				r_s[5][0]=='+'||
				r_s[5][0]=='-'||
				r_s[5][0]=='*'||
				r_s[5][0]=='/'||
				r_s[5][0]=='^'||
				r_s[5][0]=='>'||
				r_s[5][0]=='<'||
				r_s[5][0]=='='
			)
		)
		{
				if (inb==0)
				{
					ri[iri][0]=linn;
					ri[iri][1]=0;
					ri[iri][2]=0;
					ri[iri][3]=0;
					ri[iri][4]=0;
					ri[iri][5]=0;
					ri[iri][6]=0;
					eri=1;
					ri[iri][eri]=1;
				}else{
					ri[iri][0]=linn;
					ri[iri][1]=ri[iri-1][1];
					ri[iri][2]=ri[iri-1][2];
					ri[iri][3]=ri[iri-1][3];
					ri[iri][4]=ri[iri-1][4];
					ri[iri][5]=ri[iri-1][5];
					ri[iri][6]=ri[iri-1][6];

					j=ifinbt+whileinbt+forinbt;
					if (j==0){j=1;}

					for (i=6;i>j;--i){ri[iri][i]=0;}
					
					if (ri[iri][j]==1)
					{
						eri=j;
					}else{
						if (ri[iri][j]==0)
						{
							ri[iri][j]==1;
							eri=j;
						}else{	
							ri[iri][j+1]=1;
							eri=j+1;
						}
					}
				}
				++iri;

				++linn;
				for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
				for(i=0;i<r_strlen(pf[linn]);++i){il[ili]=pf[linn][i];++ili;}
				continue;
			
		}

		cl=0;k=-1;
		for(j=0;j<mc;++j){if (1<=p_ex(il,kw[j])){cl=1;k=j;break;}}

		if 
		(
			(
				cl&&
				(k!=-1)&&
				(
					1<=p_ex(kw[k],"print ")     ||
					1<=p_ex(kw[k],"=mid$(")     ||
					1<=p_ex(kw[k],"=trim$(")    ||
					1<=p_ex(kw[k],"=right$(")   ||
					1<=p_ex(kw[k],"=len$(")     ||
					1<=p_ex(kw[k],"=val$(")     ||
					1<=p_ex(kw[k],"=format$(")  ||
					1<=p_ex(kw[k],"=round$(")
				)
			)
			||
			(
				cl&&
				(k!=-1)&&
				(
					1<=p_ex(il,"input #")       ||
					1<=p_ex(il,"for input as")  ||
					1<=p_ex(il,"for output as") ||
					1<=p_ex(il,"close #")
				)
			)
		)
		{
			if (inb==0)
			{
				ri[iri][0]=linn;
				ri[iri][1]=0;
				ri[iri][2]=0;
				ri[iri][3]=0;
				ri[iri][4]=0;
				ri[iri][5]=0;
				ri[iri][6]=0;
				eri=1;
				ri[iri][eri]=1;
			}else{
				ri[iri][0]=linn;
				ri[iri][1]=ri[iri-1][1];
				ri[iri][2]=ri[iri-1][2];
				ri[iri][3]=ri[iri-1][3];
				ri[iri][4]=ri[iri-1][4];
				ri[iri][5]=ri[iri-1][5];
				ri[iri][6]=ri[iri-1][6];

				j=ifinbt+whileinbt+forinbt;
				if (j==0){j=1;}

				for (i=6;i>j;--i){ri[iri][i]=0;}
					
				if (ri[iri][j]==1)
				{
					eri=j;
				}else{
					if (ri[iri][j]==0)
					{
						ri[iri][j]==1;
						eri=j;
					}else{	
						ri[iri][j+1]=1;
						eri=j+1;
					}
				}
			}
			++iri;

			++linn;
			for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
			for(i=0;i<r_strlen(pf[linn]);++i){il[ili]=pf[linn][i];++ili;}
			continue;
		}

		if (cl)
		{
			if ((1<=p_ex(il,"for ")&&1<=p_ex(il," to "))||1<=p_ex(il,"next"))
			{
				if (inb==0)
				{
					ri[iri][1]=0;
					ri[iri][2]=0;
					ri[iri][3]=0;
					ri[iri][4]=0;
					ri[iri][5]=0;
					ri[iri][6]=0;
					eri=1;
				}else{
					ri[iri][1]=ri[iri-1][1];
					ri[iri][2]=ri[iri-1][2];
					ri[iri][3]=ri[iri-1][3];
					ri[iri][4]=ri[iri-1][4];
					ri[iri][5]=ri[iri-1][5];
					ri[iri][6]=ri[iri-1][6];
					j=ifinbt+whileinbt+forinbt;
					if (j==0){j=1;}
					for (i=6;i>j;--i){ri[iri][i]=0;}
				}
				ri[iri][0]=linn;
				if (1<=p_ex(il,"for ")&&1<=p_ex(il," to "))
				{
					j=ifinbt+whileinbt+forinbt;
					if (j==0){j=1;}
					for (i=6;i>j;--i){ri[iri][i]=0;}

					if (ri[iri][j]==1)
					{
						ri[iri][j]==12;
						eri=j;
					}else{
						if (ri[iri][j]==0)
						{
							ri[iri][j]=12;
							eri=j;
						}else{
							ri[iri][j+1]=12;
							eri=j+1;
						}
					}
					inb=1;
					++forinbt;
					++iri;

					++linn;
					for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
					for(i=0;i<r_strlen(pf[linn]);++i){il[ili]=pf[linn][i];++ili;}
					continue;
				}
				if (1<=p_ex(il,"next"))
				{
					--forinbt;
					if (forinbt==0)
					{
						if
						(
							ifinbt>=1||
							whileinbt>=1
						)
						{
							ri[iri][ifinbt+whileinbt+1]=12;
							ri[iri][ifinbt+whileinbt+1+1]=0;
							eri=ifinbt+whileinbt;
						}else{
							eri=1;
							ri[iri][1]=12;
							ri[iri][2]=0;
							ri[iri][3]=0;
							ri[iri][4]=0;
							ri[iri][5]=0;
							ri[iri][6]=0;
						}
					}else{
						if
						(
							ifinbt>=1||
							whileinbt>=1
						)
						{
							ri[iri][ifinbt+whileinbt+forinbt+1]=12;
							ri[iri][ifinbt+whileinbt+forinbt+1+1]=0;
							eri=ifinbt+whileinbt+forinbt;
						}else{
							ri[iri][forinbt+1]=12;
							ri[iri][forinbt+1+1]=0;
							eri=forinbt;
						}
					}				
					++iri;

					++linn;
					for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
					for(i=0;i<r_strlen(pf[linn]);++i){il[ili]=pf[linn][i];++ili;}
					continue;
				}
			}
			if 
			(
				1<=p_ex(il,"while (")||

				1<=p_ex(il,"wend")
			)
			{
				if (inb==0)
				{
					ri[iri][1]=0;
					ri[iri][2]=0;
					ri[iri][3]=0;
					ri[iri][4]=0;
					ri[iri][5]=0;
					ri[iri][6]=0;
					eri=1;
				}else{
					ri[iri][1]=ri[iri-1][1];
					ri[iri][2]=ri[iri-1][2];
					ri[iri][3]=ri[iri-1][3];
					ri[iri][4]=ri[iri-1][4];
					ri[iri][5]=ri[iri-1][5];
					ri[iri][6]=ri[iri-1][6];

					j=ifinbt+whileinbt+forinbt;
					if (j==0){j=1;}
					for (i=6;i>j;--i){ri[iri][i]=0;}
				}
				ri[iri][0]=linn;
				if(1<=p_ex(il,"while ("))
				{
					j=ifinbt+whileinbt+forinbt;
					if (j==0){j=1;}
					for (i=6;i>j;--i){ri[iri][i]=0;}
					if (ri[iri][j]==1)
					{
						ri[iri][j]==15;
						eri=j;
					}else{
						if(ri[iri][j]==0)
						{
							ri[iri][j]=15;
							eri=j;
						}else{
							ri[iri][j+1]=15;
							eri=j+1;
						}
					}
					inb=1;
					++whileinbt;
					++iri;

					++linn;
					for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
					for(i=0;i<r_strlen(pf[linn]);++i){il[ili]=pf[linn][i];++ili;}
					continue;
				}
				if(1<=p_ex(il,"wend"))
				{
					--whileinbt;
					if(whileinbt==0)
					{
						if 
						(
							ifinbt>=1||
							forinbt>=1
						)
						{
							ri[iri][ifinbt+forinbt+1]=15;
							ri[iri][ifinbt+forinbt+1+1]=0;
							eri=ifinbt+forinbt;
						}else{
							eri=1;
							ri[iri][1]=15;
							ri[iri][2]=0;
							ri[iri][3]=0;
							ri[iri][4]=0;
							ri[iri][5]=0;
							ri[iri][6]=0;
						}
					}else{
						if (ifinbt>=1||forinbt>=1)
						{
							ri[iri][ifinbt+whileinbt+forinbt+1]=15;
							ri[iri][ifinbt+whileinbt+forinbt+1+1]=0;
							eri=ifinbt+whileinbt+forinbt;
						}else{
							ri[iri][whileinbt+1]=15;
							ri[iri][whileinbt+1+1]=0;
							eri=whileinbt;
						}
					}
					++iri;

					++linn;
					for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
					for(i=0;i<r_strlen(pf[linn]);++i){il[ili]=pf[linn][i];++ili;}
					continue;
				}
			}
			if 
			(
				(1<=p_ex(il,"if (")&&1<=p_ex(il," then"))||
				1<=p_ex(il,"end if")
			)
			{
				if (inb==0)
				{
					ri[iri][1]=0;
					ri[iri][2]=0;
					ri[iri][3]=0;
					ri[iri][4]=0;
					ri[iri][5]=0;
					ri[iri][6]=0;
					eri=1;
				}else{
					ri[iri][1]=ri[iri-1][1];
					ri[iri][2]=ri[iri-1][2];
					ri[iri][3]=ri[iri-1][3];
					ri[iri][4]=ri[iri-1][4];
					ri[iri][5]=ri[iri-1][5];
					ri[iri][6]=ri[iri-1][6];

					j=ifinbt+whileinbt+forinbt;
					if (j==0){j=1;}
					for (i=6;i>j;--i){ri[iri][i]=0;}
				}
				ri[iri][0]=linn;
				if (1<=p_ex(il,"if (")&&1<=p_ex(il," then"))
				{
					j=ifinbt+whileinbt+forinbt;
					if (j==0){j=1;}
					for (i=6;i>j;--i){ri[iri][i]=0;}

					if (ri[iri][j]==1)
					{
						ri[iri][j]==13;
						eri=j;
					}else{
						if (ri[iri][j]==0)
						{
							ri[iri][j]=13;
							eri=j;
						}else{
							ri[iri][j+1]=13;
							eri=j+1;
						}
					}
					inb=1;
					++ifinbt;
					++iri;

					++linn;
					for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
					for(i=0;i<r_strlen(pf[linn]);++i){il[ili]=pf[linn][i];++ili;}
					continue;
				}
				if (1<=p_ex(il,"end if"))
				{
					--ifinbt;
					if (ifinbt==0)
					{	
						if (forinbt>=1||whileinbt>=1)
						{
							ri[iri][forinbt+whileinbt+1]=13;
							ri[iri][forinbt+whileinbt+1+1]=0;
							eri=forinbt+whileinbt;
						}else{
							eri=1;
							ri[iri][1]=13;
							ri[iri][2]=0;
							ri[iri][3]=0;
							ri[iri][4]=0;
							ri[iri][5]=0;
							ri[iri][6]=0;
						}
					}else{
						if (forinbt>=1||whileinbt>=1)
						{
							ri[iri][forinbt+whileinbt+ifinbt+1]=13;
							ri[iri][forinbt+whileinbt+ifinbt+1+1]=0;
							eri=forinbt+whileinbt+ifinbt;
						}else{
							ri[iri][ifinbt+1]=13;
							ri[iri][ifinbt+1+1]=0;
							eri=ifinbt;
						}
					}
					++iri;

					++linn;
					for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
					for(i=0;i<r_strlen(pf[linn]);++i){il[ili]=pf[linn][i];++ili;}
					continue;
				}
	
			}
		}

		++linn;
		for(i=0;i<plinel;++i){il[i]='\0';}ili=0;
		for(i=0;i<r_strlen(pf[linn]);++i){il[ili]=pf[linn][i];++ili;}
	}

//exc
// parse +

	exlin=0;
	for (i=0;i<iri;++i)
	{

		//printf("%d %d %d %d %d %d\n",ri[i][0],ri[i][1],ri[i][2],ri[i][3],ri[i][4],ri[i][5]);

		if (ri[i][1]==1){exc(ri[i][0]);++exlin;}
		if (ri[i][1]==11){if(-1==vdcl_(ri[i][0])){exc(ri[i][0]);}++exlin;}

		if (ri[i][1]==12&&ri[i][2]==0)
		{

			s=ri[i][0];l=1;
			for (j=i+1;j<iri;++j)
			{
				if 
				(
					ri[j][1]==12&&
					(ri[j][2]==0||ri[j][2]==1)

				){if(ri[j][2]==0){++l;if(l==2){++j;break;}}}else{break;}
			}
			if (l==2)
			{
				e=ri[j-1][0];
				pfor_(s,e);
				exlin+=e-s+1;


				i=j-1;
				continue;
			}else{

				for(l=0;l<maxv;++l)
				{
					nri[l][0]=0;nri[l][1]=0;nri[l][2]=0;nri[l][3]=0;nri[l][4]=0;
					nri[l][5]=0;nri[l][6]=0;nri[l][7]=0;nri[l][8]=0;nri[l][9]=0;
				}inri=0;
				for(l=0;l<10;++l){cv[l]=0;iv[l][0]=-1;iv[l][1]=-1;}cvi=0;
				e=-1;

				for (l=i+1;l<iri;++l)
				{
					if
					(
						ri[i][1]==ri[l][1]&&
						ri[i][2]==ri[l][2]&&
						0==ri[l][2]
					)
					{
						p_for_(s,ri[l][0]);
						e=l;
						break;
					}
				}

				for (k=i+1;k<e;++k)
				{
					if 
					(
						ri[k][1]==12&&
						(ri[k][2]==12||ri[k][2]==13||ri[k][2]==15)&&
						ri[k][3]==0
					)
					{

						for (l=k+1;l<e;++l)
						{
							if
							(
								ri[k][1]==ri[l][1]&&	
								ri[k][2]==ri[l][2]&&
								ri[k][3]==ri[l][3]&&
								0==ri[l][3]
							)
							{
								if(ri[k][2]==12)
								{
									p_for_(ri[k][0],ri[l][0]);

									for (m=k;m<l;++m)
									{
									    if(ri[m][3]==13)
									    {
									       for(n=m+1;n<l;++n)
									       {
									          if
									          (
									             ri[i][1]==ri[n][1]&&	
									             ri[k][2]==ri[n][2]&&
									             ri[m][3]==ri[n][3]&&
										     ri[m][4]==ri[n][4]&&
									             0==ri[n][4]
									          )
									          {
									            p_if_(ri[m][0],ri[n][0]);
									            break;
									          }
									      }
									      m=n;
									   }
							               }
						                }
						
								if(ri[k][2]==13)
								{
									p_if_(ri[k][0],ri[l][0]);

									for (m=k;m<l;++m)
									{
									    if(ri[m][3]==13)
									    {
									       for(n=m+1;n<l;++n)
									       {
									          if
									          (
									             ri[i][1]==ri[n][1]&&	
									             ri[k][2]==ri[n][2]&&
									             ri[m][3]==ri[n][3]&&
										     ri[m][4]==ri[n][4]&&
									             0==ri[n][4]
									          )
									          {
									            p_if_(ri[m][0],ri[n][0]);
									            break;
									          }
									      }
									      m=n;
									   }
							               }

								}
								if(ri[k][2]==15)
								{
									p_while_(ri[k][0],ri[l][0]);

									for (m=k;m<l;++m)
									{
									    if(ri[m][3]==13)
									    {
									       for(n=m+1;n<l;++n)
									       {
									          if
									          (
									             ri[i][1]==ri[n][1]&&	
									             ri[k][2]==ri[n][2]&&
									             ri[m][3]==ri[n][3]&&
										     ri[m][4]==ri[n][4]&&
									             0==ri[n][4]
									          )
									          {
									            p_if_(ri[m][0],ri[n][0]);
									            break;
									          }
									      }
									      m=n;
									   }
							               }

								}

								k=l;
								break;

							}
						}
					}
				}
			}

			//for (n=0;n<inri;++n)
			//{
			//	printf("%d %d %d %d %d %d %d %d %d %d\n",nri[n][0],nri[n][1],nri[n][2],nri[n][3],nri[n][4],nri[n][5],nri[n][6],nri[n][7],nri[n][8],nri[n][9]);
			//}

			if(inri!=0)
			{
				parse_for_1(s,cv,0,inri);
				exlin+=nri[0][4]-s+1;i=e;
				continue;
			}
		}


		if (ri[i][1]==13&&ri[i][2]==0)
		{

			s=ri[i][0];l=1;
			for (j=i+1;j<iri;++j)
			{
				if 
				(
					ri[j][1]==13&&

					(ri[j][2]==0||ri[j][2]==1)

				){if(ri[j][2]==0){++l;if(l==2){++j;break;}}}else{break;}
			}
			if (l==2)
			{
				e=ri[j-1][0];
				pif_(s,e);
				exlin+=e-s+1;
				i=j-1;
				continue;
			}else{

				for(l=0;l<maxv;++l)
				{
					nri[l][0]=0;nri[l][1]=0;nri[l][2]=0;nri[l][3]=0;nri[l][4]=0;
					nri[l][5]=0;nri[l][6]=0;nri[l][7]=0;nri[l][8]=0;nri[l][9]=0;
				}inri=0;
				for(l=0;l<10;++l){cv[l]=0;iv[l][0]=-1;iv[l][1]=-1;}cvi=0;
				e=-1;

				for (l=i+1;l<iri;++l)
				{
					if
					(
						ri[i][1]==ri[l][1]&&
						ri[i][2]==ri[l][2]&&
						0==ri[l][2]
					)
					{
						p_if_(s,ri[l][0]);
						e=l;
						break;
					}
				}

				for (k=i+1;k<e;++k)
				{
					if 
					(
						ri[k][1]==13&&
						(ri[k][2]==12||ri[k][2]==13||ri[k][2]==15)&&
						ri[k][3]==0
					)
					{

						for (l=k+1;l<e;++l)
						{
							if
							(
								ri[k][1]==ri[l][1]&&	
								ri[k][2]==ri[l][2]&&
								ri[k][3]==ri[l][3]&&
								0==ri[l][3]
							)
							{
								if(ri[k][2]==12)
								{
									p_for_(ri[k][0],ri[l][0]);

									for (m=k;m<l;++m)
									{
									    if(ri[m][3]==13)
									    {
									       for(n=m+1;n<l;++n)
									       {
									          if
									          (
									             ri[i][1]==ri[n][1]&&	
									             ri[k][2]==ri[n][2]&&
									             ri[m][3]==ri[n][3]&&
										     ri[m][4]==ri[n][4]&&
									             0==ri[n][4]
									          )
									          {
									            p_if_(ri[m][0],ri[n][0]);
									            break;
									          }
									      }
									      m=n;
									   }
							               }
						                }
						
								if(ri[k][2]==13)
								{
									p_if_(ri[k][0],ri[l][0]);

									for (m=k;m<l;++m)
									{
									    if(ri[m][3]==13)
									    {
									       for(n=m+1;n<l;++n)
									       {
									          if
									          (
									             ri[i][1]==ri[n][1]&&	
									             ri[k][2]==ri[n][2]&&
									             ri[m][3]==ri[n][3]&&
										     ri[m][4]==ri[n][4]&&
									             0==ri[n][4]
									          )
									          {
									            p_if_(ri[m][0],ri[n][0]);
									            break;
									          }
									      }
									      m=n;
									   }
							               }

								}
								if(ri[k][2]==15)
								{
									p_while_(ri[k][0],ri[l][0]);

									for (m=k;m<l;++m)
									{
									    if(ri[m][3]==13)
									    {
									       for(n=m+1;n<l;++n)
									       {
									          if
									          (
									             ri[i][1]==ri[n][1]&&	
									             ri[k][2]==ri[n][2]&&
									             ri[m][3]==ri[n][3]&&
										     ri[m][4]==ri[n][4]&&
									             0==ri[n][4]
									          )
									          {
									            p_if_(ri[m][0],ri[n][0]);
									            break;
									          }
									      }
									      m=n;
									   }
							               }

								}

								k=l;
								break;

							}
						}
					}
				}
			}

			//for (n=0;n<inri;++n)
			//{
			//	printf("%d %d %d %d %d %d %d %d %d %d\n",nri[n][0],nri[n][1],nri[n][2],nri[n][3],nri[n][4],nri[n][5],nri[n][6],nri[n][7],nri[n][8],nri[n][9]);
			//}

			if(inri!=0)
			{
				parse_if_1(s,0,inri);
				exlin+=nri[0][4]-s+1;i=e;
				continue;

			}
		}


		if (ri[i][1]==15&&ri[i][2]==0)
		{

			s=ri[i][0];l=1;
			for (j=i+1;j<iri;++j)
			{
				if 
				(
					ri[j][1]==15&&
					(ri[j][2]==0||ri[j][2]==1)

				){if(ri[j][2]==0){++l;if(l==2){++j;break;}}}else{break;}
			}
			if (l==2)
			{
				e=ri[j-1][0];
				pwhile_(s,e);
				exlin+=e-s+1;
				i=j-1;
				continue;
			}else{

				for(l=0;l<maxv;++l)
				{
					nri[l][0]=0;nri[l][1]=0;nri[l][2]=0;nri[l][3]=0;nri[l][4]=0;
					nri[l][5]=0;nri[l][6]=0;nri[l][7]=0;nri[l][8]=0;nri[l][9]=0;
				}inri=0;
				for(l=0;l<10;++l){cv[l]=0;iv[l][0]=-1;iv[l][1]=-1;}cvi=0;
				e=-1;

				for (l=i+1;l<iri;++l)
				{
					if
					(
						ri[i][1]==ri[l][1]&&
						ri[i][2]==ri[l][2]&&
						0==ri[l][2]
					)
					{
						p_while_(s,ri[l][0]);
						e=l;
						break;
					}
				}

				for (k=i+1;k<e;++k)
				{
					if 
					(
						ri[k][1]==15&&
						(ri[k][2]==12||ri[k][2]==13||ri[k][2]==15)&&

						ri[k][3]==0
					)
					{

						for (l=k+1;l<e;++l)
						{
							if
							(
								ri[k][1]==ri[l][1]&&	
								ri[k][2]==ri[l][2]&&
								ri[k][3]==ri[l][3]&&
								0==ri[l][3]
							)
							{
								if(ri[k][2]==12)
								{
									p_for_(ri[k][0],ri[l][0]);

									for (m=k;m<l;++m)
									{
									    if(ri[m][3]==13)
									    {
									       for(n=m+1;n<l;++n)
									       {
									          if
									          (
									             ri[i][1]==ri[n][1]&&	
									             ri[k][2]==ri[n][2]&&
									             ri[m][3]==ri[n][3]&&
										     ri[m][4]==ri[n][4]&&
									             0==ri[n][4]
									          )
									          {
									            p_if_(ri[m][0],ri[n][0]);
									            break;
									          }
									      }
									      m=n;
									   }
							               }
						                }
						
								if(ri[k][2]==13)
								{
									p_if_(ri[k][0],ri[l][0]);

									for (m=k;m<l;++m)
									{
									    if(ri[m][3]==13)
									    {
									       for(n=m+1;n<l;++n)
									       {
									          if
									          (
									             ri[i][1]==ri[n][1]&&	
									             ri[k][2]==ri[n][2]&&
									             ri[m][3]==ri[n][3]&&
										     ri[m][4]==ri[n][4]&&
									             0==ri[n][4]
									          )
									          {
									            p_if_(ri[m][0],ri[n][0]);
									            break;
									          }
									      }
									      m=n;
									   }
							               }

								}
								if(ri[k][2]==15)
								{
									p_while_(ri[k][0],ri[l][0]);

									for (m=k;m<l;++m)
									{
									    if(ri[m][3]==13)
									    {
									       for(n=m+1;n<l;++n)
									       {
									          if
									          (
									             ri[i][1]==ri[n][1]&&	
									             ri[k][2]==ri[n][2]&&
									             ri[m][3]==ri[n][3]&&
										     ri[m][4]==ri[n][4]&&
									             0==ri[n][4]
									          )
									          {
									            p_if_(ri[m][0],ri[n][0]);
									            break;
									          }
									      }
									      m=n;
									   }
							               }

								}

								k=l;
								break;

							}
						}
					}
				}
			}

			//for (n=0;n<inri;++n)
			//{
			//	printf("%d %d %d %d %d %d %d %d %d %d\n",nri[n][0],nri[n][1],nri[n][2],nri[n][3],nri[n][4],nri[n][5],nri[n][6],nri[n][7],nri[n][8],nri[n][9]);
			//}
		
			if(inri!=0)
			{
				parse_while_1(s,0,inri);
				exlin+=nri[0][4]-s+1;i=e;
				continue;
			}
		}

	}

	return(exlin);

}


int mariabasic(char infn[vnaml],char outfn[vnaml])
{
	int			i,j,k,l,m,n;
	int			fbyte;
	int			errC=0;

	//char		infn[vnaml]="in.bas";

	FILE		*f1,*f2;

	char		cl[plinel];int	cli=0;
	char		cl1[plinel];int	cl1i=0;

	char		kw0[vnaml]="if (",kw1[vnaml]="else",kw2[vnaml]="end if",kw3[vnaml]="for ";
	char		kw4[vnaml]="next",kw5[vnaml]="while (",kw6[vnaml]="wend",kw7[vnaml]="print ";
	char		kw8[vnaml]="input #",kw9[vnaml]="sub",kw10[vnaml]="end sub",kw11[vnaml]="end";
	char		kw12[vnaml]="=mid$(",kw13[vnaml]="=trim$(",kw14[vnaml]="=left$(",kw15[vnaml]="=right$(";
	char		kw16[vnaml]="=len$(",kw17[vnaml]="open ",kw18[vnaml]="input #",kw19[vnaml]="close #";
	char		kw20[vnaml]="=val$(",kw21[vnaml]=" or ",kw22[vnaml]=" and ",kw23[vnaml]=" xor ";
	char		kw24[vnaml]="=format$(",kw25[vnaml]="print #",kw26[vnaml]="=round$(";

	char		rout0[vnaml]="exc",rout1[vnaml]="pfor",rout2[vnaml]="pwhile",rout3[vnaml]="pif",rout4[vnaml]="psub";	

	char		to[]="This Program is Dedicated to Nada Popstefanova and Maria,Dusica,Borce Dzinleski";	

	f1=fopen(infn,"rb");

	if(f1==NULL){printf("Nothing to do!\n");return(0);}else{fclose(f1);}

	for(i=0;i<plinel;++i){cl[i]='\0';}

	if(strlen(outfn)>0){of=1;}
	if(of){fout=fopen(outfn,"w");}

	if(c_syntax(infn,outfn)!=0){printf("\nExecution will not continue...\n");return(0);}

	//exc
	
	if(errC!=0){printf("\nExecution will not continue...\n");return(0);}

	//if(!of){printf("\n\n\nThe mariaBasic Interpreter\n");}else{fprintf(fout,"\n\n\nThe mariaBasic Interpreter\n");}
	//if(!of){printf("\nWritten by Dzinleski Jasenko Jun,2005\n");}else{fprintf(fout,"\nWritten by Dzinleski Jasenko Jun,2005 and later\n");}
	//if(!of){printf("OS Win32 VRM 3.5.0.5\n\n");}else{fprintf(fout,"OS Win32 VRM 3.5.0.5\n\n");}

	for (j=0;j<r_strlen(rout0);++j){rout[0][j]=rout0[j];}
	for (j=0;j<r_strlen(rout1);++j){rout[1][j]=rout1[j];}
	for (j=0;j<r_strlen(rout2);++j){rout[2][j]=rout2[j];}
	for (j=0;j<r_strlen(rout3);++j){rout[3][j]=rout3[j];}

	for (j=0;j<r_strlen(rout4);++j){rout[4][j]=rout4[j];}
	irout=5;

	for (i=0;i<mc;++i)
	{
		if (i== 0){for(j=0;j<r_strlen(kw0); ++j){kw[i][j]= kw0[j];}}
		if (i== 1){for(j=0;j<r_strlen(kw1); ++j){kw[i][j]= kw1[j];}}
		if (i== 2){for(j=0;j<r_strlen(kw2); ++j){kw[i][j]= kw2[j];}}
		if (i== 3){for(j=0;j<r_strlen(kw3); ++j){kw[i][j]= kw3[j];}}
		if (i== 4){for(j=0;j<r_strlen(kw4); ++j){kw[i][j]= kw4[j];}}
		if (i== 5){for(j=0;j<r_strlen(kw5); ++j){kw[i][j]= kw5[j];}}
		if (i== 6){for(j=0;j<r_strlen(kw6); ++j){kw[i][j]= kw6[j];}}
		if (i== 7){for(j=0;j<r_strlen(kw7); ++j){kw[i][j]= kw7[j];}}
		if (i== 8){for(j=0;j<r_strlen(kw8); ++j){kw[i][j]= kw8[j];}}
		if (i== 9){for(j=0;j<r_strlen(kw9); ++j){kw[i][j]= kw9[j];}}
		if (i==10){for(j=0;j<r_strlen(kw10);++j){kw[i][j]=kw10[j];}}
		if (i==11){for(j=0;j<r_strlen(kw11);++j){kw[i][j]=kw11[j];}}
		if (i==12){for(j=0;j<r_strlen(kw12);++j){kw[i][j]=kw12[j];}}
		if (i==13){for(j=0;j<r_strlen(kw13);++j){kw[i][j]=kw13[j];}}
		if (i==14){for(j=0;j<r_strlen(kw14);++j){kw[i][j]=kw14[j];}}
		if (i==15){for(j=0;j<r_strlen(kw15);++j){kw[i][j]=kw15[j];}}
		if (i==16){for(j=0;j<r_strlen(kw16);++j){kw[i][j]=kw16[j];}}
		if (i==17){for(j=0;j<r_strlen(kw17);++j){kw[i][j]=kw17[j];}}
		if (i==18){for(j=0;j<r_strlen(kw18);++j){kw[i][j]=kw18[j];}}
		if (i==19){for(j=0;j<r_strlen(kw19);++j){kw[i][j]=kw19[j];}}
		if (i==20){for(j=0;j<r_strlen(kw20);++j){kw[i][j]=kw20[j];}}
		if (i==21){for(j=0;j<r_strlen(kw21);++j){kw[i][j]=kw21[j];}}
		if (i==22){for(j=0;j<r_strlen(kw22);++j){kw[i][j]=kw22[j];}}
		if (i==23){for(j=0;j<r_strlen(kw23);++j){kw[i][j]=kw23[j];}}
		if (i==24){for(j=0;j<r_strlen(kw24);++j){kw[i][j]=kw24[j];}}
		if (i==25){for(j=0;j<r_strlen(kw25);++j){kw[i][j]=kw25[j];}}
		if (i==26){for(j=0;j<r_strlen(kw26);++j){kw[i][j]=kw26[j];}}
	}

	f1=fopen("code.mar","rb");
	j=0;fbyte=getc(f1);
	while(!feof(f1))
	{
		for(i=0;i<plinel;++i){pf[j][i]='\0';}i=0;
		while(!feof(f1)&&fbyte!=13&&fbyte!=10){pf[j][i]=fbyte;++i;fbyte=getc(f1);}
		while(!feof(f1)&&(fbyte==13||fbyte==10)){fbyte=getc(f1);}++j;
	}
	fclose(f1);

	i=parse();

	if (i>0){if(!of){printf("\n(%d) Lines, (%d) Executed\n",j,i);}else{fprintf(fout,"\n(%d) Lines, (%d) Executed\n",j,i);}}else{if(!of){printf("\n!Error executing at line %d\n",-1*i);}else{fprintf(fout,"\n!Error executing at line %d\n",-1*i);}}

	if(of){fclose(fout);}

	return(0);
}

int main(int argc,char *argv[])
{

	int	i,j,k,l,m;

	char	cmd[50][256];
	char	c_1[256];
	char	c_2[256];

	char	fn[plinel];
	char	ofn[plinel];
	int	df=0;

	//
	//char	*pv[]={"mariabasic3313","-eb.txt";
	//printf("%s\n",pv[0]);
	//printf("%s\n",pv[1]);
	//argv[0]=pv[0];
	//argv[1]=pv[1];
	//argc=2;
	//

	printf("\n\n\nThe mariaBasic Interpreter\n");
	printf("\nWritten by Dzinleski Jasenko Jun,2005 and later\n");
	printf("OS Win32 VRM 3.5.0.5\n\n");

	if(argv[1]==NULL){return(0);}

	for(i=0;i<50;++i){for(j=0;j<256;++j){cmd[i][j]='\0';}}
	for(i=0;i<argc;++i){strcpy(cmd[i],argv[i]);}
	for(j=0;j<plinel;++j){fn[j]='\0';}
	for(j=0;j<plinel;++j){ofn[j]='\0';}

	if(argv[2]!=NULL)
	{
		ci=1;
		c_p(cml,ci,1,c_1);
		c_p(c_1,ci,0,c_2);
		if(c_2[0]<=cmd[2][0]&&cmd[2][0]<=c_2[1])
		{
			if(df){printf("%c\n",cmd[2][0]);}
			ci=2;
			c_p(cml,ci,1,c_1);
			ci=4;
			c_p(c_1,ci,0,c_2);
			if(c_2[0]<=cmd[2][1]&&cmd[2][1]<=c_2[1])
			{
				ci=3;
				c_p(cml,ci,1,c_1);
				k=0;
				for(j=2;j<strlen(cmd[2]);++j)
				{
					i=1;
					while(i<=8)
					{
						ci=i;
						c_p(c_1,ci,0,c_2);
						if(c_2[0]<=cmd[2][j]&&cmd[2][j]<=c_2[1]){if(df){printf("%c\n",cmd[2][j]);}ofn[k]=cmd[2][j];++k;break;}else{++i;continue;}
						++i;
					}
				}
				if(j==strlen(cmd[2])){}else{printf("Error Parameter %s\n",cmd[2]);}
			}
		}
	}

	ci=1;
	c_p(cml,ci,1,c_1);
	c_p(c_1,ci,0,c_2);
	if(c_2[0]<=cmd[1][0]&&cmd[1][0]<=c_2[1])
	{
		if(df){printf("%c\n",cmd[1][0]);}
		ci=2;
		c_p(cml,ci,1,c_1);
		ci=1;
		c_p(c_1,ci,0,c_2);
		if(c_2[0]<=cmd[1][1]&&cmd[1][1]<=c_2[1])
		{
					printf("\n");
					printf("mariaBasic -e<mariaBasic code filename to execute>\n");
					printf("\n");

					printf("mariaBasic -e<mariaBasic code filename to execute> -o<output filename>\n");
					printf("\n");

					return(0);
		}else{
			ci=2;
			c_p(c_1,ci,0,c_2);
			if(c_2[0]<=cmd[1][1]&&cmd[1][1]<=c_2[1])
			{
					printf("\n");
					printf("\tThis source and mariaBasic interpreter apply to GNU General Public License.\n");
					printf("\t		Copyright (C) 2005 and later Jasenko Dzinleski \n");
					printf("\n");
					printf("\t	This program is free software; you can redistribute it\n");
					printf("\tand/or modify it under the terms of the GNU General Public License as\n");
					printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
					printf("\tLicense, or (at your option) any later version.\n");
					printf("\n");
					printf("\tThis program is distributed in the hope that it will be useful, but\n");
					printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
					printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
					printf("\tGeneral Public License for more details.\n");
					printf("\n");
					printf("\tYou should have received a copy of the GNU General Public License along\n");
					printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
					printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
					printf("\n");

	 				return(0);

			}else{
				ci=5;
				c_p(c_1,ci,0,c_2);
				if(c_2[0]<=cmd[1][1]&&cmd[1][1]<=c_2[1])
				{
					printf("\n");
					printf("mariaBasic -e<mariaBasic code filename to execute>\n");
					printf("\n");

					printf("mariaBasic -e<mariaBasic code filename to execute> -o<output filename> \n");
					printf("\n");

					return(0);
				}else{
					ci=3;
					c_p(c_1,ci,0,c_2);
					if(c_2[0]<=cmd[1][1]&&cmd[1][1]<=c_2[1])
					{
						ci=3;
						c_p(cml,ci,1,c_1);
						k=0;
						for(j=2;j<strlen(cmd[1]);++j)
						{
							i=1;
							while(i<=8)
							{
								ci=i;
								c_p(c_1,ci,0,c_2);
								if(c_2[0]<=cmd[1][j]&&cmd[1][j]<=c_2[1]){if(df){printf("%c\n",cmd[1][j]);}fn[k]=cmd[1][j];++k;break;}else{++i;continue;}
								++i;
							}
						}
						if(j==strlen(cmd[1])){mariabasic(fn,ofn);}else{printf("Error Parameter %s\n",cmd[1]);}
					}
				}
			}
		}

	}else{printf("Error Token %c\n",cmd[1][0]);return(0);}

	
	for(j=0;j<fni;++j)
	{
		if(fvars[j]!=NULL)
		{
			fclose(fvars[j]);
			fvars[j]=NULL;
			fvarc[j]=-1;
			fvarp[j]=-1;
			fvarn[j][0]='\0';
		}
	}

	return(0);
}


